;**************************************************************************
;
; Filename : DEFS.D
; -----------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; allgemeine Definitionen
;
;
;**************************************************************************


	; =================
	; Task Definitionen
	; =================

STK_TAST	equ	30	; Stackgre der Task Tastaturabfrage
STK_MAIN	equ	30	; Stackgre der Hauptprg. Task
STK_UPD	equ	20	; Stackgre der Update Task
STK_EXTCMD	equ	30	; Stackgre der Cmd. Auswertung Task

	; Stackgre fr alle Task`s
	; --------------------------
SIZE_TASK_S	equ	STK_TAST+STK_MAIN+STK_UPD+STK_EXTCMD
ANZ_TASK	equ	4	; Anzahl der Task`s



	; =======================
	; allgemeine Definitionen
	; =======================

UHR_BULA	equ	7	; Gre des Uhr Buffers
TERM_BEL	equ	%10000000	; Termin belegt Kennzeichnung

TERM_BEA_ON	equ	0	; Kennung fr Beantworter Termin ein
TERM_BEA_OF	equ	1	; Kennung fr Beantworter Termin aus
TERM_ZW_ON	equ	2	; Kennung fr Zweitapparat Termin ein
TERM_ZW_OFF	equ	3	; Kennung fr Zweitapparat Termin aus


	; ==================================================
	; Untermenu Nummern
	; bei Speicher/Kontrolltaste andere Prg.`s ausfhren
	; das Hauptmenu hat Kennung 0
	; Menunr. werden in "menu" eingetragen
	; ==================================================

MENU_REL	equ	2	; Untermenu Relais wurde ausgewhlt
MENU_STAT	equ	4	; Untermenu Statistik wurde ausgewhlt
MENU_TERM	equ	6	; Untermenu Termin wurde ausgewhlt
MENU_VERS	equ	8	; Untermenu Version wurde ausgewhlt
MENU_NOTRUF	equ	10	; Untermenu Notruf wurde ausgewhlt


	; ======================
	; Struktur fr Statistik
	; ======================

	org	0
STAT_NANR	edo	1	; Anzahl nicht abgefragter Anrufe
STAT_ANR	edo	2	; Anzahl Anrufe gesamt
STAT_GSPR	edo	2	; Anzahl abgehender Gesprche
STAT_GEB	edo	2	; Anzahl Gebhrenimpulse gesamt
STAT_GEBMON	edo	2*12	; Anzahl Gebhrenimpulse je Monat

STRUCT_STAT	edo	0	; Struktur Gre


	; =============================
	; BIT-Nr. fr aktiven Modus
	; werden in "modus" eingetragen
	; =============================

MOD_SP	equ	0	; Speichern aktiv
MOD_KO	equ	1	; Kontrolle aktiv
MOD_NT_SPEC	equ	2	; Namenspeicher hat Sonderfunktion
MOD_BTA	equ	3	; BTA ist aktiviert
MOD_NO_KEY	equ	4	; Tastendrcke nicht auswerten
MOD_KEYSPEC	equ	5	; Tasten auf Spezialfunktion umleiten
MOD_TXT	equ	6	; Text auf Taste berechtigen
MOD_BABY	equ	7	; Babyruf Funktion vorbereitet


	; =========================================
	; BIT-Nr. fr den Zustand des Fernsprechers
	; werden in "feap_stat" eingetragen
	; =========================================

ST_2SP	equ	0	; 2.Speicher aktiv
ST_FSLH	equ	1	; Freisprechen ein/ausgeschaltet
ST_BEANTW	equ	2	; Beantworter ein/aus
ST_MODEM	equ	3	; Modem ein/aus
ST_POST	equ	4	; Postapparat ein/aus
ST_GU	equ	5	; Gabelumschalter eingehangen = 0
ST_CURS	equ	6	; Cursor ist eingeschaltet = 1
ST_BABY	equ	7	; Babyruf Funktion aktiv = 1


	; =================================
	; Hrton und Gebhren Infos
	; werden in "hgeb_stat" eingetragen
	; =================================

HTON_UEB	equ	0	; Hrtonberwachung eingeschaltet
HTON_OK	equ	1	; Hrton ist erkannt
GEB_OUT	equ	2	; Gesprchsdauer/Gebhrenausgabe zugelassen
GEB_IMP	equ	3	; Gebhrenimpuls erkannt
WHL_START	equ	4	; Hilfsflag fr Gebhrenausgabe nach Wahlstart


	; =================================
	; allgemeine BIT-Nr.
	; werden in "allg_stat" eingetragen
	; =================================

ST_ZRAM	equ	0	; Zusatz-RAM ist installiert
UHR_FLAG	equ	1	; Zustand des Uhr-Ports
UHR_NOT	equ	2	; Notbetrieb der Uhr ein/aus
TASTER	equ	3	; Taster ist gedrckt
SS_STAT	equ	4	; aktueller Zustand des Schlsselschalter`s
NT_OUT	equ	5	; Rufnr. auf NT nur ausgeben
EDIT_NT	equ	6	; NT zum editieren anzeigen
ST_EPR2	equ	7	; Erweiterungs Eprom 2 installiert


	; ===================================
	; BIT-Nr. fr den Zustand des Summers
	; werden in "su_stat" eingetragen
	; ===================================

ST_SUAB	equ	0	; Anruf Summer Abschaltung, Taste SA
ST_ANRLED	equ	1	; Anruf steht an, LED in Ltg.Taste einschalten
ST_ALD_ON	equ	2	; Anruf-LED ist eingeschaltet
ST_ANRSU	equ	3	; Status des Anrufsummers
ST_SU	equ	4	; Summer einschalten


	; ================================
	; BIT-Nr. fr den Leitungs-Zustand
	; werden in "ltg_stat" eingetragen
	; ================================

LTG_MARK	equ	0	; Leitung soll belegt werden
LTG_BEL	equ	1	; Leitung ist belegt
LTG_DURCH	equ	2	; Leitung ist bis zum Hrer durchgeschaltet
LTG_HLT	equ	3	; Leitung ist in Halten
LTG_WHL	equ	4	; Leitung whlt
WHL_ERDE	equ	5	; Erde wir gewhlt



	; ===================================================
	; BIT-Nr. fr den Zustand der seriellen Schnittstelle
	; werden in "tty_sts" eingetragen
	; ===================================================

TTY_CON	equ	0	Terminal Modus ist aktiv


