;**************************************************************************
;
; Filename : TAST.D
; -----------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Tasten und LED Definitionen
;
;
;**************************************************************************


	; =======================
	; Tastatur und LED Matrix
	; =======================
MAX_X	equ	15	; maximale Anzahl der X-Achsen
MAX_XL	equ	16	; maximale Anzahl der XL-Achsen

LED_MATRIX	equ	MAX_XL*8	; Gre der LED-Matrix, 16 X-Achsen, 8 Y-Achsen
TAST_MATRIX	equ	MAX_X*8	; Gre der Tast-Matrix,15 X-Achsen, 8 Y-Achsen
TAST_BER	equ	TAST_MATRIX*2	; Gre der Tastaturberechtigung

ANZ_ANR_LED	equ	12	; Anz. der LED`s fr nicht abgefragten Anruf


	org	0
YL0	edo	MAX_XL	; Offset auf LED-RAM fr YL0
YL1	edo	MAX_XL	; Offset auf LED-RAM fr YL1
YL2	edo	MAX_XL	; Offset auf LED-RAM fr YL2
YL3	edo	MAX_XL	; Offset auf LED-RAM fr YL3
YL4	edo	MAX_XL	; Offset auf LED-RAM fr YL4
YL5	edo	MAX_XL	; Offset auf LED-RAM fr YL5
YL6	edo	MAX_XL	; Offset auf LED-RAM fr YL6
YL7	edo	MAX_XL	; Offset auf LED-RAM fr YL7

OFFS_NO_LED	equ	YL6+$00	; wenn keine LED berechtigt


	; ===============
	; LED Blinkzeiten
	; ===============

LD_R	equ	%00001000	; rechte LED bearbeiten
LD_L	equ	%00010000	; linke LED bearbeiten

LD_OFF	equ	0	; LED ausschalten
LD_ON	equ	1	; LED einschalten
LD_N	equ	2	; LED blinkt normal
LD_S	equ	3	; LED blinkt schnell
LD_T	equ	4	; LED blinkt sehr schnell
LD_TP	equ	5	; LED blinkt sehr schnell, phasenverschoben




	; ============================================
	; Offset auf Berechtigung fr Relaisfunktionen
	; ============================================

ANR_REL	equ	0	; Relais bei Anruf
TERM7_REL	equ	1	; Relais bei Termin 7 setzen
TERM8_REL	equ	2	; Relais bei Termin 8 lschen



	; ===============================
	; Offset auf Namentasten Speicher
	; ===============================

NT_BABYRUF	equ	0		; Namentaste fr Babyruf Nummer
NT_NOTRUF	equ	1		; 1. Namentaste fr Notruf Nummern
HLP	set	MAX_NOTRUF/2	; Anzahl NT fr Notruf Nummern
NT_NAMTAST	equ	NT_NOTRUF+HLP	; 1. wirkliche Namentaste
NT_TELBUCH	equ	MAX_NAM_TAST+NT_NAMTAST	; 1. NT fr Telefonbuch Eintrge


	; =======================================
	; Offset auf Prg. Tabelle fr NT Ausgaben
	; =======================================
NTFKT_NAMT	equ	0		; Namentaste speichern/kontrollieren
NTFKT_NOTR	equ	2		; Notruf speichern/kontrollieren
NTFKT_TELB	equ	4		; Telefonbuch



	; ================================
	; Offset der LED`s fr RX/TX Daten
	; ================================
LD_TXD	equ	YL6	LED fr TX Data
LD_RXD	equ	YL6+1	LED fr RX Data



	; =================================
	; Offset der Relais ber LED Matrix
	; =================================

	ifequ RELTEST
LD_AB	equ	YL7+$0f	; a/b anschalten
LD_HALT	equ	YL6+$0d	; Halten Relais
LD_POST	equ	YL7+$0d	; Relais Netzausfall/Postapparat
LD_BEANTW	equ	YL6+$0e	; Relais fr Anrufbeantworter
LD_MODEM	equ	YL6+$0f	; Relais fr Modemanschlu
LD_REL1	equ	YL6+$0c	; frei programmierbares Relais 1
LD_REL2	equ	YL7+$0c	; frei programmierbares Relais 2
LD_REL3	equ	YL7+$0e	; frei programmierbares Relais 3
	endif

	; LED`s fr Testzwecke einschalten
	; --------------------------------
	if RELTEST
LD_AB	equ	YL1+9	; a/b anschalten
LD_HALT	equ	YL1+11	; Halten Relais
LD_POST	equ	YL1+3	; Relais Netzausfall/Postapparat
LD_BEANTW	equ	YL1+5	; Relais fr Anrufbeantworter
LD_MODEM	equ	YL1+7	; Relais fr Modemanschlu
LD_REL1	equ	YL0+5	; frei programmierbares Relais 1
LD_REL2	equ	YL0+3	; frei programmierbares Relais 2
LD_REL3	equ	YL0+1	; frei programmierbares Relais 3
LD_RL2	equ	YL0+9	; frei programmierbarer Port RL2
LD_RL3	equ	YL0+7	; frei programmierbares Port RL3
	endif



	; ============
	; Whltastatur
	; ============

MB4	equ 	%11110111	; Start MB4 bei Whltastaturabfrage
BTA_START	equ	12	; BTA-Modus einleiten durch "*"
BTA_NXT_MEN	equ	12	; nchstes BTA Menue durch "*"
BTA_END	equ	11	; BTA-Modus verlassen durch "#"
SHOWKEY_END	equ	11	; Tastenwert anzeigen beenden durch "#"
ASK_YES	equ	01	; pos. Besttigung bei ndern J/N = 1

ERD_ZIFF	equ	13	; WTA-Wert fr Erdtaste
HTON_ZIFF	equ	11	; WTA-Wert fr Hrtonauswertung starten



	; ================================================
	; Programmnummern fr Tasten mit Text Funktion
	; werden in keytxt_prg eingetragen
	; ================================================

KEYTXT_TERM	equ	00	; Termin Eingabe
KEYTXT_TELB	equ	02	; Telefonbuch Eingabe



	; ================================================
	; Programmnummern fr Whltasten und Lschfunktion
	; werden in wta_prg eingetragen
	; ================================================

WTA_WAHL	equ	00	; Wahl, mu immer NULL bleiben (stz)
WTA_FUNKT	equ	02	; Funktion fr Whltasten ausfhren
WTA_BTA_WHL	equ	04	; BTA Modus auswhlen
WTA_KEY_BER	equ	06	; BTA Modus Tastenberechtigung automatisch
WTA_ASCII	equ	08	; BTA Modus Textberechtigung
WTA_UHRSET	equ	10	; Uhr stellen
WTA_SHOWKEY	equ	12	; Tastenwert zeigen
WTA_SPNAM	equ	14	; Namentaste speichern
WTA_TERMWHL	equ	16	; Terminnr. auswhlen
WTA_TERMEIN	equ	18	; Termin eingeben
WTA_TERMTXT	equ	20	; Termintext eingeben
WTA_TERMDAY	equ	22	; Termintage eingeben
WTA_STAT	equ	24	; Menueauswahl bei Statistik
WTA_BER_CLR	equ	26	; Tastenber wirklich lschen ?
WTA_SPREL	equ	28	; Relais speichern
WTA_SPGEB	equ	30	; Gebhrenfaktor speichern
WTA_SETUP	equ	32	; Setup Routine
WTA_SPTZYKL	equ	34	; Termin Zyklus
WTA_TMODE	equ	36	; Terminal Mode aktiv

WTA_NOPRG	equ	38	; kein Programm ausfhren
