;**************************************************************************
;
; Filename : TIMER.D
; ------------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Timer Definitionen
;
;
;**************************************************************************


	; ====================================
	; Timerwerte, gelten fr jeweils 100mS
	; ====================================

VERS_TIM	equ	60	; Version anzeigen
ANR_TIM	equ	50	; Anrufberbrckung, 5Sec
DISPL_TIM	equ	$ff	; Displayanzeige ohne Tastendruck
ERD_TIM	equ	05	; Dauer der Erde bei Wahl




	; ===================================
	; Timerwerte, gelten fr jeweils 10mS
	; ===================================

IRQ_TIM1	equ	$0640	; 800uS, $0640 = 1600*Phi2
IRQ_TIM2	equ	$4833	;  10mS, $4833 = 18483*Phi2
UHR_TIM	equ	100	; Anzahl der 100Hz Impulse bis Sek. erreicht
HTON_TIM	equ	50	; Zeit bis Hrton gltig ist, 500mS

WTA_PR_TIM	equ	3	; Whltasten Entprellung, 30mS
TA_PR_TIM	equ	3	; Tastaturentprellung, 30mS

BLINK_TIM	equ	16	; Blink BIT weiterschalten wenn Timer abgel.

BEL_TIM	equ	150	; Wiederbelegung der Ltg.

VORWHL_TIM	equ	120	; Vorwahlzeit
ZWWHL_TIM	equ	80	; Zwischenwahlzeit
NSION_TIM	equ	4	; Timerwert fr "NSI ein", Schleife
NSIOFF_TIM	equ	6	; Timerwert fr "NSI aus", keine Schleife

ANRIMP_TIM	equ	5	; Timerwert Anrufimpuls berbrcken, 50mS

TERMSU_TIM	equ	30	; Timerwert Termin-Summer ein/aus, 300mS




	; ====================================================
	; Definitionen der Offsets auf die 100mS Timerstruktur
	; ====================================================
	org	0

VERS_TIM_O	edo	1	; Version anzeigen
ANR_TIM_O	edo	1	; Anrufberbrckungs Timer
DISPL_TIM_O	edo	1	; Timer fr Displayanzeige ohne Tastendruck
ERD_TIM_O	edo	1	; Timer fr Erdtaste whlen


ANZ_TIM100	edo	0	; Anzahl der Timer in der Struktur




	; ===================================================
	; Definitionen der Offsets auf die 10mS Timerstruktur
	; ===================================================
	org	0
BLK_TIM_O	edo	1	; Blink Timer fr LED-Matrix
BEL_TIM_O	edo	1	; Wiederbelegungs Timer
WHL_TIM_O	edo	1	; Wahl Timer
ANRIMP_TIM_O edo	1	; Anrufimpuls berbrckungs Timer
TERMSU_TIM_O edo	1	; Termin-Summer Wiederholung
UHRNOT_TIM_O edo	1	; Uhr im Notbetrieb
TASK_TIM_O	edo	ANZ_TASK	; Timer fr Task Delay


ANZ_TIM	edo	0	; Anzahl der Timer in der Struktur





