;**************************************************************************
;
; Filename : BTA.ASM
; ------------------
;
; (c) 1990/91 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; BTA Routinen
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen


; =========================================================================
;
; Funktion	: BTA-Wahl-Modus einschalten
;	  nachdem das Passwort korrekt eingegeben wurde oder Direktwahl
;	  Whltasten auf BTA-Wahl umleiten
;
; Eingang	: ----------
;
; Ausgang	: ----------
;
; Register	: Accu, X, Y
;
; (c) by Thomas Lehmann Januar 1991
;
; =========================================================================

btawhl_txt	byte	DSP_CLR
	shift	"BTA   *=vor #=Ende   -->"

	byte	DSP_CLR
	shift	"1=Tastenber. 2=Text  -->"

	byte	DSP_CLR
	shift	"3=Ber.loesch 4=Setup -->"


bta_tab	word set_keyber	; Tastenberechtigung automatisch
	word bta_ascii	; Tasten-Textberechtigung einschalten
	word clr_tastber	; Tastenberechtigung lschen
	word setup	; Setup Funktionen

TAB_LEN	set	*-bta_tab	; Tabellenlnge



bta	smb MOD_BTA,modus	; BTA Modus ist aktiviert
	lda #$00	; Fllwert
	jsr fill_ledram	; alle LED`s ausschalten
	smb MOD_NO_KEY,modus	; Tastendrcke nicht auswerten
	smb MOD_KEYSPEC,modus	; Tasten haben Spezialfunktion
	rmb MOD_TXT,modus	; Tastentext nicht berechtigen

	; Funktionstabelle fr Whltasten
	; -------------------------------
	lda #TAB_LEN	; Tabellenlnge laden
	ldx #<bta_tab	; Adresse der Tabelle
	ldy #>bta_tab
	jsr set_wta_fkt	; Funktionstabelle fr Whltasten installieren
	lda #WTA_BTA_WHL	; BTA-Prg. Nr. fr BTA-Wahl laden
	sta wta_prg	; und bei Whltaste ausfhren

	ldx #<btawhl_txt	; 1. BTA Text laden
	ldy #>btawhl_txt
	lda #ANZ_BTATXT	; Anzahl der Texte laden
	jmp init_dsptxt	; Textwahl initialisieren


; =========================================================================
;
; Funktion	: BTA-Modus auswhlen
;	  angewhlte BTA-Funktion eingeleitet
;
; Eingang	: bei Whltaste und eingeschaltetem BTA-Wahl-Modus
;	: Tastenwert (1 bis ...) im Accu
;
; Ausgang	: ------------
;
; Register	: Accu, X, Y
;
; (c) by Thomas Lehmann Mrz 1990
;
; =========================================================================

wta_bta_whl	cmp #BTA_END	; BTA verlassen ?
	beq bta_off	; ja, BTA-Modus aus

	cmp #BTA_NXT_MEN	; nchstes Menue anzeigen ?
	bne wta_bta_1	; nein, Auswahl eines Menuepunkts

	; nchstes BTA-Menue im Display anzeigen
	; --------------------------------------
	jmp nxt_dsptxt	; nchsten Text ausgeben

wta_bta_1	jmp wta_funkt	; Funktion der Whltaste ausfhren



	; =============
	; BTA verlassen
	; =============
bta_off	jmp ledoff_ende	; LED`s ausschalten, Key Ende ausfhren



; =========================================================================
;
; Funktion	: Tastentext-Berechtigung
;	  der ASCII-Wert mu immer 2-stellig eingegeben werden
;	  Eingaben von Werten > 99 sind deshalb nicht mglich
;
; Eingang	: -------
;
; Ausgang	: -------
;
; Register	: Accu
;
; (c) by Thomas Lehmann Januar 1991
;
; =========================================================================

bta_ascii	lda #WTA_ASCII	; BTA-Prg. Nr. fr Text berechtigen laden
	sta wta_prg	; und bei Whltaste ausfhren
	rmb MOD_NO_KEY,modus	; Tastendrcke auswerten

	smb MOD_TXT,modus	; Text berechtigen eintragen

	lda #$ff	; erstes Textzeichen einstellen
	bra ta_txt_out	; Textzeichen ausgeben



HLP	set	*

bta_asc_txt	byte 01|DSP_CLR|CURS_SET|CURS_ON
	shift	"ASCII-Wert: \""

HLP	set	*-HLP
INPUT_CURS	set	HLP+4	; Position des Eingabe Cursors


	; =======================
	; Einsprung bei Whltaste
	; =======================

wta_ascii_e	rts

wta_ascii	cmp #BTA_END	; BTA verlassen ?
	bne wta_ascii_1

	jmp bta		; wieder BTA Haupt-Menue anzeigen

wta_ascii_1	cmp #BTA_NXT_MEN	; nchsten ASCII-Wert automatisch einstellen ?
	bne wta_ascii_2

	inc akt_txtchar	; nchstes Textzeichen einstellen(NXT_BTA)
	lda akt_txtchar
	bra ta_txt_out	; Textzeichen ausgeben


wta_ascii_2	jsr check_wta	; Taste im Gltigkeitsbereich ?
	bcs wta_ascii_e	; nein, Ende

	jsr input	; ASCII-Wert eintragen
	ldx input_po	; Offset auf akt. Eingabe
	cpx #2		; ASCII-Wert komplett eingegeben ?
	bcc wta_ascii_e	; nein

	ldx #00		; 2-stellige Eingabe holen
	jsr get_input	; Textwert holen (Wert im ACCU)

	sta akt_txtchar	; aktuelles Textzeichen eintragen


	; Textzeichen ausgeben
	; --------------------
ta_txt_out	stz input_po	; Offset auf akt. Eingabe
	ldx #<bta_asc_txt	; Text ausgeben
	ldy #>bta_asc_txt
	jsr puttxt

	cmp #$00	; ASCII-Text lschen ?
	beq tast_txt_2	; ja, Textwert belassen, Meldung ins Display

	cmp #128	; alle Textzeichen ausgegeben ?
	bcc tast_txt_1	; nein

	lda #SPACE	; erstes Textzeichen laden
	sta akt_txtchar	; und fr Textber. einstellen

tast_txt_1	pha		; Zeichen Wert merken
	jsr putchar	; Textzeichen der Taste ausgeben
	lda #"\""	; Anfhrungszeichen laden
	jsr putchar	; und ausgeben
	jsr space	; Space hinterher, Cursor ist eingeschaltet
	pla		; Zeichen zurck
	jsr putdez	; und 3-stellig ausgeben
	lda #INPUT_CURS	; Cursorposition holen
	jmp curs_set	; Cursor auf Eingabe setzten


tast_txt_2	ldx #<clr_txt	; Text ausgeben
	ldy #>clr_txt
	jmp puttxt


clr_txt	byte DSP_CLR
	shift	"Text loeschen, Taste ?"




	; =======================================
	; Einsprung bei gedrckter Taste
	; Textzeichen in Tastentextber. eintragen
	; =======================================
key_ascii	ldy akt_txtchar	; aktuelles Textzeichen laden
	beq key_asc_1	; Text auf Taste lschen

	cmp #KEY_ENDE	; ist es "Ende" Taste
	beq wta_ascii_e	; fatal, kein Text auf Ende Taste (Terminer)

key_asc_1	txa		; Offset auf Tastenber. kopieren
	lsr a		; Offset auf Textber. erzeugen
	tax

	tya		; aktuelles Textzeichen laden
	sta tast_txt,x	; ASCII-Zeichen fr Taste in Ber. eintragen
	beq ta_txt_out	; Tastentext wurde gelscht

	inc akt_txtchar	; nchstes Textzeichen einstellen
	inc a		; und nchstes Textzeichen ausgeben
	bra ta_txt_out	; Textzeichen ausgeben



; =========================================================================
;
; Type	: Unterprg.
;
; Eingang	: -------
;
; Ausgang	: komplette Tastenberechtigung initialisiert
;
; Register	: Accu, X, Y
;
; (c) by Thomas Lehmann Mai 1990
;
; =========================================================================

clr_tastber	lda #WTA_BER_CLR	; BTA-Prg. Nr. fr Tastenber. clr laden
	sta wta_prg	; und bei Whltaste ausfhren

	ldx #<berclr_txt	; Text ausgeben
	ldy #>berclr_txt
	jmp puttxt

berclr_txt	byte DSP_CLR
	shift	"!! Ber. loeschen ?? 1=ja"


; =========================================================================

;
; Type	: Hauptprg.
;	: Sicherheits-Abfrage ob Tastenber wirklich gelscht werden soll
;
; Eingang	: bei Whltaste und eingeschaltetem BTA-Modus->Tastenber. clr
;	: Tastenwert im Accu
;
; Ausgang	: wenn ja, TW 1, komplette Tastenberechtigung gelscht
;
; Register	: Accu, X
;
; (c) by Thomas Lehmann Mai 1990
;
; =========================================================================

wta_berclr	cmp #1		; wurde Frage mit ja beantwortet ?
	bne wta_bercl_1	; nein, Ber. nicht clr

	ldx #<tast_tab	; low Byte der Tastenber. laden
	stx ind_adr	; und setzen
	ldx #>tast_tab	; dito high Byte
	stx ind_adr+1	; und setzen
	ldx #<KEYBER_INIT	; low Byte Tastenber. Ende
	ldy #>KEYBER_INIT	; dito high
	lda #00		; Fllwert laden
	jsr fill_ram	; RAM fllen
	jsr fill_ledram	; alle LED`s ausschalten (ACCU=Fllwert)

wta_bercl_1	jmp bta		; wieder 1.BTA Menue anzeigen





; --------------------------------------------------------------------------

HLP	set	*
_BTA	equ	HLP-MODUL_START		; Gre des Moduls

