;**************************************************************************
;
; Filename : HOERTON.ASM
; ----------------------
;
; (c) 1991 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Hrtonauswertung
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen


; =========================================================================
;
; Type	: Timer IRQ
;	: Hrton testen
;
; Eingang	: alle 10mS
;
; Ausgang	: BIT "HTON_OK" in hgeb_stat gesetzt wenn Hrtonzeit erreicht
;
; Register	: Accu
;
; (c) by Thomas Lehmann Mai 1990
;
; =========================================================================

tst_hton	bbr HTON_UEB,hgeb_stat,tst_hton_e	; keine berwachung eingesch.

	lda Via_porta	; Zustand des Ports laden
	and #HTON	; ist Hrton vorhanden ?
	bne tst_hton_e	; nein, Ende

	if TEST
	lda #$ff
	sta led_ram+1+YL1
	endif

	dec hton_tim	; Hrtonzeit nachtriggern
	bpl tst_hton_e1	; Hrton ist noch ungltig

	smb HTON_OK,hgeb_stat	; Flag fr Hrton erkannt setzen
	rmb HTON_UEB,hgeb_stat	; berwachung ausschalten
	jmp htport_off	; Hrton Port lschen

tst_hton_e
	if TEST
	stz led_ram+1+YL1
	endif

	lda #HTON_TIM	; Timerwert laden
	sta hton_tim	; Timer aufziehen
tst_hton_e1	rts


; =========================================================================
;
; Type	: Unterprg.
;	: Hrtonauswertung einschalten
;
; Eingang	: --------
;
; Ausgang	: BIT`s fr Hrtonerkennung geschaltet
;
; Register	: ------
;
; (c) by Thomas Lehmann Mai 1990
;
; =========================================================================

hton_on	bbr DIP_HTON,dip_stat,hton_on_1	; Hardware ist installiert

	smb HTON_OK,hgeb_stat	; Hrton erkannt eintragen
	ldx #VORWHL_TIM	; Timerwert Vorwahlzeit ohne Hrton laden
	stx vorwahl_tim	; und fr Wahlzeit eintragen
	rts

hton_on_1	ldx #04		; Timerwert Vorwahlzeit mit Hrton laden
	stx vorwahl_tim	; und fr Wahlzeit eintragen
	smb HTON_UEB,hgeb_stat	; berwachung einschalten
	rmb HTON_OK,hgeb_stat	; kein Hrton erkannt eintragen
	jmp htport_on	; Hrton Port setzen





; --------------------------------------------------------------------------

HLP	set	*
_HOERTON	equ	HLP-MODUL_START		; Gre des Moduls

