;**************************************************************************
;
; Filename : KONTROLLE.ASM
; ------------------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Kontroll Funktionen
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen

; =========================================================================
;
; Type	: Hauptprg.
;
; Eingang	: bei Kontrolltaste
;	: Offset auf Tastaturtabelle in X-Reg.
;	: Tastenwert im Accu
;
; Ausgang	: Kontrolltext ausgegeben
;	: LED eingeschaltet
;	: Whltasten umgeleitet
;	: letzte Textnr. in X-Reg
;	: erste Textnr. in Y-Reg
;
; Register	: Accu, X, Y
;
; (c) by Thomas Lehmann Mrz 1990
;
; =========================================================================

komenu_tab	word ko_h_menu	; Kontrolle Hauptmenu
	word _rts	; Untermenu Relais ist aktiv
	word stat_out	; Untermenu Statisktik ist aktiv
	word term_out	; Untermenu Termin ist aktiv
	word vers_out	; Untermenu Version ist aktiv
	word _rts	; Untermenu Notruf ist aktiv



kowhl_txt	byte	DSP_CLR
	shift "1=NT 2=Term 3=Stat.  -->"

	byte	DSP_CLR
	shift "4=Beantw. 5=Zweitapp.-->"

	byte	DSP_CLR
	shift "6=Tastenwert 7=Vers. -->"



kontr_tab	word spko_namkey	; 1=Namentaste kontrollieren
	word spko_term	; 2=Termin kontrollieren
	word statistik	; 3=Statistik ausgeben
	word spko_bea	; 4=Beantworter ein/aus
	word spko_post	; 5=Postapparat ein/aus
	word show_key	; 7=Tastenwert anzeigen
	word show_vers	; 6=Version anzeigen

TAB_LEN	set	*-kontr_tab	; Tabellenlnge



key_kontr	bbs MOD_SP,modus,ko_h_menu	; Speichern ist aktiv, KO einsch.

	ldx menu	; ausgewhltes Menu laden
	jmp (komenu_tab,x)	; Programm ausfhren


	; Kontrolle Hauptmenu
	; ===================
ko_h_menu	bbr MOD_KO,modus,key_ko_1	; Kontrolle nicht eingeschaltet

	jsr nxt_dsptxt	; nchstes Menu ausgeben
	bra kontr_wta	; Whltastenfunktionen intallieren

	; Kontrollmodus einschalten
	; -------------------------
key_ko_1	jsr key_ende	; Speichern ausschalten
	smb MOD_KO,modus	; Kontrollmodus aktiv eintragen

	ldy #LD_L|LD_ON	; LED-Wert laden
	jsr set_prgled	; und LED einschalten

	ldx #<kowhl_txt	; Textadr. laden
	ldy #>kowhl_txt
	lda #ANZ_KOTXT	; Anzahl der Texte laden
	jsr init_dsptxt	; Textwahl initialisieren

	; Funktionstabelle fr Whltasten
	; -------------------------------
kontr_wta	lda #TAB_LEN	; Tabellenlnge laden
	ldx #<kontr_tab	; Adresse der Tabelle
	ldy #>kontr_tab
	jmp set_wta_fkt	; Funktionstabelle fr Whltasten installieren





; --------------------------------------------------------------------------

HLP	set	*
_KONTROLLE	equ	HLP-MODUL_START		; Gre des Moduls

