;**************************************************************************
;
; Filename : SETUP.ASM
; --------------------
;
; (c) 1991 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Setup Routinen
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen


; =========================================================================
;
; Type	: Hauptprg.
;
; Eingang	: BTA-Modus fr automatische Tastenberechtigung einschalten
;
; Ausgang	: Whltasten auf BTA-Tastenwert Eingabe umgeleitet
;	: Tasten in X/Y-Matrix umgeleitet
;
; Register	: Accu, X
;
; (c) by Thomas Lehmann Januar 1991
;
; =========================================================================

setup	lda #WTA_SETUP		; Prg. bei Whltaste
	sta wta_prg
	bra ht_out		; Text und Port ausgeben


; =========================================================================
;
; Type	: Hauptprg.
;
; Eingang	: bei Whltaste und eingeschaltetem Setup-Modus
;	: Tastenwert (1 bis ...) im Accu
;
; Ausgang	: --------
;
; Register	: Accu
;
; (c) by Thomas Lehmann Mai 1991
;
; =========================================================================

wta_setup	cmp #BTA_END	; BTA verlassen ?
	bne wta_setup_1	; nein

	jmp bta		; wieder BTA Haupt-Menue anzeigen

wta_setup_1	jsr check_wta	; Taste im Gltigkeitsbereich ?
	bcs wta_setup_e	; nein, Ende

	cmp #PRG_PORT	; Portnr. gltig ?
	bcc setup_1	; ja, eintragen

	lda #$ff	; freier Port
setup_1	sta ht_port	; Hrtonport eintragen

	; Hrtonport Text ausgeben
	; ----------------------
ht_out
	block
	ldx #<ht_txt	; Hrton Port Text ausgeben
	ldy #>ht_txt
	jsr puttxt

	lda ht_port	; Hrtonport holen
	cmp #PRG_PORT	; ist Port gltig ?
	bcc ht_out_1	; ja, Portnr. ausgeben

	lda #253	; "-" -48 Char fr kein Port gespeichert laden
ht_out_1	clc
	adc #48		; ASCII erzeugen
	jsr putchar	; Port ausgeben
	jmp curs_left
	bend

wta_setup_e	rts


ht_txt	byte DSP_CLR|CURS_ON
	shift "Hoertonport ? "




; --------------------------------------------------------------------------

HLP	set	*
_SETUP	equ	HLP-MODUL_START		; Gre des Moduls

