;**************************************************************************
;
; Filename : SUMMER.ASM
; ---------------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Summer Routinen
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen


; =========================================================================
;
; Type	: Hauptprg.
;	: Summer-BIT testen und Summer entsprechend schalten
;
; Eingang	: wird zyklisch von Haupt-Prg.-Schleife aufgerufen
;
; Ausgang	: Summer bei Anforderung ein bzw. ausgeschaltet
;	: Summer nicht geschaltet wenn Summerabschaltung aktiv ist
;
; Register	: -------
;
; (c) by Thomas Lehmann Mrz 1990
;
; =========================================================================

summer	bbr ST_SUAB,su_stat,summer_1	; Summer ist nicht abgeschaltet
	rts		; SA aktiv, keinen Anrufsummer bringen

summer_1	bbs ST_SU,su_stat,summer_on	; Summer einschalten

	jmp su_off	; Summer ausschalten

summer_on	jmp su_on	; Summer einschalten


; =========================================================================
;
; Type	: Hauptprg.
;
; Eingang	: bei Summertaste
;
; Ausgang	: Summer ein/ausgeschaltet
;
; Register	: Accu
;
; (c) by Thomas Lehmann Mrz 1990
;
; =========================================================================

key_su	bbs ST_SUAB,su_stat,key_suon	; Summer wieder ein

	smb ST_SUAB,su_stat	; "Summer abgeschaltet" eintragen
	rmb ST_SU,su_stat	; Summer ausschalten
	ldy #LD_L|LD_ON	; LED-Status laden
	bra key_suled	; LED schalten

key_suon	rmb ST_SUAB,su_stat	; "Summer eingeschaltet" eintragen
	ldy #LD_L|LD_OFF	; LED-Status laden

key_suled	jmp set_prgled	; und LED schalten



; --------------------------------------------------------------------------

HLP	set	*
_SUMMER	equ	HLP-MODUL_START		; Gre des Moduls

