#ifndef CLIB_INI_PROTOS_H
#define CLIB_INI_PROTOS_H

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef  LIBRARIES_INI_H
#include <libraries/ini.h>
#endif

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

INIERROR ini_New(STRPTR fileName,INIPARSER *parser);
INIERROR ini_Delete(INIPARSER *parser);
INILINEINFO *ini_GetHeader(INIPARSER *parser,STRPTR headerName);
INILINEINFO *ini_GetVariable(INILINEINFO *parser,STRPTR variableName);
STRPTR ini_ErrorString(INIERROR errorCode);
INIERROR ini_GetString(INIPARSER *parser,STRPTR header,STRPTR variable,STRPTR defaultString,STRPTR target,WORD sizeOfTarget);
INIERROR ini_GetInteger(INIPARSER *parser,STRPTR header,STRPTR variable,LONG defaultLong,LONG *target);
INIERROR ini_GetBool(INIPARSER *parser,STRPTR header,STRPTR variable,BOOL defaultBool,BOOL *target);
INIERROR ini_Save(STRPTR fileName,INIPARSER *parser);
INIERROR ini_RemoveVariable(INIPARSER *parser,STRPTR header,STRPTR variable);
INIERROR ini_ChangeString(INIPARSER *parser,STRPTR header,STRPTR variable,STRPTR value);
INIERROR ini_NewConfig(struct TagItem *tags);
INICONFIG *ini_LocalConfig(void);
STRPTR ini_NewFilename(STRPTR filename);
void ini_DeleteFilename(STRPTR filename);
INIERROR ini_ProtectSection(INIPARSER *parser,INILINEINFO *header,STRPTR *password);
INIERROR ini_CheckProtection(INILINEINFO *header,STRPTR *password);
BPTR ini_OpenFile(STRPTR filename,WORD mode,INIPARSER *parser);

#endif /* CLIB_INI_PROTOS_H */

