#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <proto/exec.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <exec/execbase.h>

extern struct ExecBase *SysBase;

char *GetTaskName( struct Task *t )
{
    if( t->tc_Node.ln_Type == NT_PROCESS )
    {
        struct Process *p = (struct Process *)t;
        struct CommandLineInterface *cli;
        static char buffer[256];
        char *cp,*dp;
        int i;

        if( p->pr_TaskNum == 0 )
            return t->tc_Node.ln_Name;

        cli = BADDR( p->pr_CLI );
        cp = BADDR( cli->cli_CommandName );
        dp = buffer;

        for( i=*cp++; i; i-- )
        {
            *dp++ = *cp++;
        }
        *dp=0;
        return buffer;
    }

    return t->tc_Node.ln_Name;
}

void ShowTaskInfo( struct Task *t )
{
    printf("%s\n",GetTaskName( t ) );
    
}

void main( void )
{
    struct Node *np;

    ShowTaskInfo( SysBase->ThisTask );

    for( np = SysBase->TaskWait.lh_Head;
         np != (struct Node *)&(SysBase->TaskWait.lh_Tail);
         np = np->ln_Succ )
    {
        ShowTaskInfo( (struct Task *)np );
    }
    for( np = SysBase->TaskReady.lh_Head;
         np != (struct Node *)&(SysBase->TaskReady.lh_Tail);
         np = np->ln_Succ )
    {
        ShowTaskInfo( (struct Task *)np );
    }
}
