/* $Id: grp.h,v 1.1 1993/09/15 01:08:56 ppessi Exp $
 *
 * grp.h - Group structure and prototypes for Network Library
 *
 * This file is part of the AmiTCP/IP Network Library.
 *
 * Author: ppessi <Pekka.Pessi@hut.fi>
 * Copyright  1993 AmiTCP/IP Group, <AmiTCP-Group@hut.fi>
 *                  Helsinki University of Technology, Finland.
 *
 * Created      : Sun Jun 20 17:52:37 1993 ppessi
 * Last modified: Wed Sep 15 07:38:42 1993 ppessi
 */

#ifndef GRP_H
#define GRP_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

/* Normally defined in <netdb.h> */
#ifndef _PATH_GROUP
#define _PATH_GROUP  "AmiTCP:db/group"
#endif

/* The group structure */
struct group
{
  UBYTE  *gr_name;		/* Group name.	*/
  UBYTE  *gr_passwd;		/* Password.	*/
  ULONG   gr_gid;		/* Group ID.	*/
  UBYTE **gr_mem;		/* Member list.	*/
};

#ifndef _GID_T
#define _GID_T ULONG
typedef _GID_T gid_t;
#endif

/* 
 * POSIX compatible routines 
 */
struct group *getgrgid(gid_t gid);
struct group *getgrnam(const char *name);

#endif
