/* amiga.h --- Amiga specific thingies to niftyterm
 *
 * Copyright 1991 Pekka Pessi
 * All Rights Reserved
 * Permission is granted to copy, modify, and use this as long
 * as this notice remains intact.  This is a nifty program.
 *
 * DISCLAIMER: the author (and maintainer) of this program is not responsible
 * for any damage or other problems caused by it.
 *
 * $Author: ppessi $ $Revision: 1.4 $ $Date: 1993/07/12 22:46:10 $
 */

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <devices/timer.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/dos_protos.h>
#include <clib/diskfont_protos.h>
#include <clib/timer_protos.h>
#include <clib/alib_protos.h>

#if USE_RLOGIN
/* we are kludging around the devices/timer.h braindamage */
#include <sys/time.h>
#endif

extern struct ExecBase *SysBase;
extern struct Library *DOSBase;
extern struct GfxBase *GfxBase;
extern struct IntuitionBase *IntuitionBase;
extern struct DiskfontBase *DiskfontBase;
extern struct timerequest *tr;
#define TimerBase (tr->tr_node.io_Device)

#if defined(__SASC)
#include <pragmas/exec_sysbase_pragmas.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/graphics_pragmas.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/diskfont_pragmas.h>
#include <pragmas/timer_pragmas.h>
#endif


