/***********************************************************************/
/* WACOMII Digitizerdriver                (C) 1993 by ROLAND SCHWINGEL */
/***********************************************************************/
/* Headerfile for receiving Pressuredata from the Driver               */
/* Revision 1.0                                                        */
/***********************************************************************/


/* DEFINES *******************************/
#define WACOM_PORT_NAME   "Wacom DataPort"     /* Name of the DataPort */
#define NO_PRESS          -64;                 /* No valid Pressure */


/* Structures ****************************/
struct Wacom
{
 UBYTE        Sync;            /* Synchronisation with Subprocess (internal must be 0)*/
 UBYTE        Driver_running;  /* Driver active or not */
                               /* 0 = inactive */
                               /* 1 = active */
 UBYTE        Wacom_Series;    /* 0 = SD-Series */
                               /* 1 = UD-Series */
 UBYTE        Beeper;          /* State of the Beeper */
                               /* 0 = off */
                               /* 1 = on */
 UBYTE        Mode;            /* Pressure or "normal" Mode */
                               /* 0 = normal */
                               /* 1 = pressure */
 UBYTE        MB_Emu;          /* Mousebuttonemulation in Pressure Mode */
                               /* 0 = inactive */
                               /* 1 = active */
 int          Pressure_Limit;  /* Limit for LMB-Emulation (-30 ... 30) */
 WORD         Pressure;        /* current Pressure when in Pressure Mode (-30 ... 30) */
 UBYTE        input_device;    /* Type of current Stylus/Digitzer */
                               /* 1 = standard Stylus */
                               /* 2 = pressure Stylus */
                               /* 4 = Digitizer */
 UBYTE        Buttons;         /* State of the current input_device Buttons */
                               /* Standard Stylus:  1 = Frontbutton */
                               /*                   2 = Sidebutton */
                               /*                   3 = both */
                               /* Digitizer:        1 = middle Button on the top */
                               /*                   2 = left Button */
                               /*                   3 = middle Button bottom */
                               /*                   4 = right Button */
 ULONG        Tablett_Max_X;   /* Maximum X-Value on the Digitizer */
 ULONG        Tablett_Max_Y;   /* Maximum Y-Value on the Digitizer */
 long         Tablett_X;       /* Digitizer's current X-Value */
 long         Tablett_Y;       /* Digitizer's current Y-Value */

 UBYTE        reserved[128];   /* For future Expansions */
};


/* Message Structure for getting the above for use with PutMsg() */
struct WacomMSG
{
 struct Message Mess;
 struct Wacom   WacomInfo;
 UBYTE          reserved[32];  /* For future Expansions */
};

