#include "intelhex.h"

/* Definitions for Program Algorythms - don't change them, they work together
   with the 'nitem' code of the appropriate MX Algorythm Selector Gadget ! */
#define AG_50MS	0
#define AG_INTE	1	
#define AG_EPRO	2
#define AG_NDEL	3

#define DSIZE 130
#define FCHARS 30

/* Definitions for 'numerical Base' - don't change them, they work together
   with the 'nitem' code of the appropriate Cycle Selector Gadget ! */
#define CY_DEC 		0
#define CY_DECHEX	1
#define CY_HEX 		2

/* Definitions for 'VPP Test' - don't change them, they work together
   with the 'nitem' code of the appropriate Cycle Selector Gadget ! */
#define CY_VPP12	0
#define CY_VPP21	1
#define CY_VPP25	2

/* Data Format */
#define BINARY 0
#define INTELHEX 1

struct Config
{
	int  epromtype;			/* Choosed Eprom type */
	int  dataformat;		/* File dataformat (BINARY,INTELHEX) */
	BOOL bufferfragmented;	/* Fargmented Buffer allowed */
	BOOL clearbuffer;		/* Buffer cleared before loading Data */
	BOOL inforeq;			/* Information requester appears*/
	BOOL counting;			/* Show address counting in Busy Window */
	BOOL defepsize;			/* Show default Eprom Size */
	int  numericalbase;		/* Numericalbase for number gadgets (DEC,DECHEX,HEX) */
	char loaddir[256];		/* Load Directory */
	char savedir[256];		/* Save Directory */
	ULONG waitcnt;			/* CIA delay time */
};

#define CONFIG_ENV "Env:Eprommer.Prefs"
#define CONFIG_ENVARC "EnvArc:Eprommer.Prefs"

#define EP_2716		0
#define EP_2732		1
#define EP_2732A	2
#define EP_2764		3
#define EP_2764A	4
#define EP_27128	5
#define EP_27256	6
#define EP_27512	7
#define EP_6216		8
#define EP_6264		9
#define EP_62256	10
