/****************************************************************/
/*								*/
/* Reasm.c - this file includes the Reassembler			*/
/*								*/
/*								*/
/* used Compiler: SAS-C 6.0					*/
/* 								*/
/****************************************************************/


#include <exec/memory.h>
#include <libraries/dos.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>
#include <libraries/locale.h>
#include <ctype.h>
#include <string.h>

#include <proto/locale.h>
#include <proto/reqtools.h>
#include <proto/intuition.h>
#include <proto/gadtools.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include "GALer.h"
#include "Localize.h"



/**************************** defines  *********************************/

#define GD_RAsmGad01		1	/* GadgetID mu mit Pinnummer */
#define GD_RAsmGad02		2	/* bereinstimmen */
#define GD_RAsmGad03		3
#define GD_RAsmGad04		4
#define GD_RAsmGad05		5
#define GD_RAsmGad06		6
#define GD_RAsmGad07		7
#define GD_RAsmGad08		8
#define GD_RAsmGad09		9
#define GD_RAsmGad10		10
#define GD_RAsmGad11		11
#define GD_RAsmGad12		12
#define GD_RAsmGad13		13
#define GD_RAsmGad14		14
#define GD_RAsmGad15		15
#define GD_RAsmGad16		16
#define GD_RAsmGad17		17
#define GD_RAsmGad18		18
#define GD_RAsmGad19		19
#define GD_RAsmGad20		20
#define GD_RAsmGad21		21
#define GD_RAsmGad22		22
#define GD_RAsmGad23		23
#define GD_RAsmGad24		24

#define GD_RAsmGad30		30
#define GD_RAsmGad31		31
#define GD_RAsmGad32		32
#define GD_RAsmGad33		33





/************************** extern variables ****************************/

extern	char	path[];
extern	int	JedecGALType;
extern	char	filename[];			/*Puffer fr Filenamen*/
extern	struct	JedecStruct	Jedec;
extern	struct	Window		*window;
extern	struct	Screen		*screen;
extern	struct	Gadget		*RAsm16GList, *RAsm20GList;
extern	struct	Catalog		*catalog;





/*************************** variables  *********************************/


int FuseToPin16Mode1[] = { 2,1,3,19,4,18,5,17,6,14,7,13,8,12,9,11 };
int FuseToPin16Mode2[] = { 2,1,3,18,4,17,5,16,6,15,7,14,8,13,9,11 };
int FuseToPin16Mode3[] = { 2,19,3,18,4,17,5,16,6,15,7,14,8,13,9,12 };

int FuseToPin20Mode1[] = { 2,1,3,23,4,22,5,21,6,20,7,17,8,16,9,15,10,14,11,13 };
int FuseToPin20Mode2[] = { 2,1,3,23,4,21,5,20,6,19,7,18,8,17,9,16,10,14,11,13 };
int FuseToPin20Mode3[] = { 2,23,3,22,4,21,5,20,6,19,7,18,8,17,9,16,10,15,11,14 };






				/* Gadgets fr GAL16V8 */

UWORD RAsm16GTypes[] = {
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

struct NewGadget RAsm16NGad[] = {
	16, 11, 93, 12, (UBYTE *)" 1", NULL, GD_RAsmGad01, PLACETEXT_RIGHT, NULL, NULL,
	16, 23, 93, 12, (UBYTE *)" 2", NULL, GD_RAsmGad02, PLACETEXT_RIGHT, NULL, NULL,
	16, 35, 93, 12, (UBYTE *)" 3", NULL, GD_RAsmGad03, PLACETEXT_RIGHT, NULL, NULL,
	16, 47, 93, 12, (UBYTE *)" 4", NULL, GD_RAsmGad04, PLACETEXT_RIGHT, NULL, NULL,
	16, 59, 93, 12, (UBYTE *)" 5", NULL, GD_RAsmGad05, PLACETEXT_RIGHT, NULL, NULL,
	16, 71, 93, 12, (UBYTE *)" 6", NULL, GD_RAsmGad06, PLACETEXT_RIGHT, NULL, NULL,
	16, 83, 93, 12, (UBYTE *)" 7", NULL, GD_RAsmGad07, PLACETEXT_RIGHT, NULL, NULL,
	16, 95, 93, 12, (UBYTE *)" 8", NULL, GD_RAsmGad08, PLACETEXT_RIGHT, NULL, NULL,
	16, 107, 93, 12, (UBYTE *)" 9", NULL, GD_RAsmGad09, PLACETEXT_RIGHT, NULL, NULL,
	15, 119, 93, 12, (UBYTE *)"10", NULL, GD_RAsmGad10, PLACETEXT_RIGHT, NULL, NULL,
	179, 119, 93, 12, (UBYTE *)"11", NULL, GD_RAsmGad11, PLACETEXT_LEFT, NULL, NULL,
	179, 107, 93, 12, (UBYTE *)"12", NULL, GD_RAsmGad12, PLACETEXT_LEFT, NULL, NULL,
	179, 95, 93, 12, (UBYTE *)"13", NULL, GD_RAsmGad13, PLACETEXT_LEFT, NULL, NULL,
	179, 83, 93, 12, (UBYTE *)"14", NULL, GD_RAsmGad14, PLACETEXT_LEFT, NULL, NULL,
	179, 71, 93, 12, (UBYTE *)"15", NULL, GD_RAsmGad15, PLACETEXT_LEFT, NULL, NULL,
	179, 59, 93, 12, (UBYTE *)"16", NULL, GD_RAsmGad16, PLACETEXT_LEFT, NULL, NULL,
	179, 47, 93, 12, (UBYTE *)"17", NULL, GD_RAsmGad17, PLACETEXT_LEFT, NULL, NULL,
	179, 35, 93, 12, (UBYTE *)"18", NULL, GD_RAsmGad18, PLACETEXT_LEFT, NULL, NULL,
	179, 23, 93, 12, (UBYTE *)"19", NULL, GD_RAsmGad19, PLACETEXT_LEFT, NULL, NULL,
	179, 11, 93, 12, (UBYTE *)"20", NULL, GD_RAsmGad20, PLACETEXT_LEFT, NULL, NULL,
	193, 155, 79, 14, NULL, NULL, GD_RAsmGad30, PLACETEXT_IN, NULL, NULL,
	16,  155, 79, 14, NULL, NULL, GD_RAsmGad31, PLACETEXT_IN, NULL, NULL,
	117, 149, 54, 12, NULL, NULL, GD_RAsmGad32, PLACETEXT_IN, NULL, NULL,
	117, 163, 54, 12, NULL, NULL, GD_RAsmGad33, PLACETEXT_IN, NULL, NULL
};

ULONG RAsm16GTags[] = {
	(GTST_String), (ULONG)"P1", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P2", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P3", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P4", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P5", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P6", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P7", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P8", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P9", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"GND", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P11", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P12", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P13", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P14", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P15", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P16", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P17", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P18", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P19", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"VCC", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(TAG_DONE),
	(TAG_DONE),
	(TAG_DONE),
	(TAG_DONE)
};




			/* Gadgets fr GAL20V8 */


UWORD RAsm20GTypes[] = {
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	STRING_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND
};

struct NewGadget RAsm20NGad[] = {
	16, 1, 93, 12, (UBYTE *)" 1", NULL, GD_RAsmGad01, PLACETEXT_RIGHT, NULL, NULL,
	16, 13, 93, 12, (UBYTE *)" 2", NULL, GD_RAsmGad02, PLACETEXT_RIGHT, NULL, NULL,
	16, 25, 93, 12, (UBYTE *)" 3", NULL, GD_RAsmGad03, PLACETEXT_RIGHT, NULL, NULL,
	16, 37, 93, 12, (UBYTE *)" 4", NULL, GD_RAsmGad04, PLACETEXT_RIGHT, NULL, NULL,
	16, 49, 93, 12, (UBYTE *)" 5", NULL, GD_RAsmGad05, PLACETEXT_RIGHT, NULL, NULL,
	16, 61, 93, 12, (UBYTE *)" 6", NULL, GD_RAsmGad06, PLACETEXT_RIGHT, NULL, NULL,
	16, 73, 93, 12, (UBYTE *)" 7", NULL, GD_RAsmGad07, PLACETEXT_RIGHT, NULL, NULL,
	16, 85, 93, 12, (UBYTE *)" 8", NULL, GD_RAsmGad08, PLACETEXT_RIGHT, NULL, NULL,
	16, 97, 93, 12, (UBYTE *)" 9", NULL, GD_RAsmGad09, PLACETEXT_RIGHT, NULL, NULL,
	16, 109, 93, 12, (UBYTE *)"10", NULL, GD_RAsmGad10, PLACETEXT_RIGHT, NULL, NULL,
	16, 121, 93, 12, (UBYTE *)"11", NULL, GD_RAsmGad11, PLACETEXT_RIGHT, NULL, NULL,
	16, 133, 93, 12, (UBYTE *)"12", NULL, GD_RAsmGad12, PLACETEXT_RIGHT, NULL, NULL,
	179, 133, 93, 12, (UBYTE *)"13", NULL, GD_RAsmGad13, PLACETEXT_LEFT, NULL, NULL,
	179, 121, 93, 12, (UBYTE *)"14", NULL, GD_RAsmGad14, PLACETEXT_LEFT, NULL, NULL,
	179, 109, 93, 12, (UBYTE *)"15", NULL, GD_RAsmGad15, PLACETEXT_LEFT, NULL, NULL,
	179, 97, 93, 12, (UBYTE *)"16", NULL, GD_RAsmGad16, PLACETEXT_LEFT, NULL, NULL,
	179, 85, 93, 12, (UBYTE *)"17", NULL, GD_RAsmGad17, PLACETEXT_LEFT, NULL, NULL,
	179, 73, 93, 12, (UBYTE *)"18", NULL, GD_RAsmGad18, PLACETEXT_LEFT, NULL, NULL,
	179, 61, 93, 12, (UBYTE *)"19", NULL, GD_RAsmGad19, PLACETEXT_LEFT, NULL, NULL,
	179, 49, 93, 12, (UBYTE *)"20", NULL, GD_RAsmGad20, PLACETEXT_LEFT, NULL, NULL,
	179, 37, 93, 12, (UBYTE *)"21", NULL, GD_RAsmGad21, PLACETEXT_LEFT, NULL, NULL,
	179, 25, 93, 12, (UBYTE *)"22", NULL, GD_RAsmGad22, PLACETEXT_LEFT, NULL, NULL,
	179, 13, 93, 12, (UBYTE *)"23", NULL, GD_RAsmGad23, PLACETEXT_LEFT, NULL, NULL,
	179, 1, 93, 12, (UBYTE *)"24", NULL, GD_RAsmGad24, PLACETEXT_LEFT, NULL, NULL,
	193, 155, 79, 14, NULL, NULL, GD_RAsmGad30, PLACETEXT_IN, NULL, NULL,
	16,  155, 79, 14, NULL, NULL, GD_RAsmGad31, PLACETEXT_IN, NULL, NULL,
	117, 149, 54, 12, NULL, NULL, GD_RAsmGad32, PLACETEXT_IN, NULL, NULL,
	117, 163, 54, 12, NULL, NULL, GD_RAsmGad33, PLACETEXT_IN, NULL, NULL
};

ULONG RAsm20GTags[] = {
	(GTST_String), (ULONG)"P1", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P2", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P3", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P4", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P5", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P6", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P7", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P8", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P9", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P10", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P11", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"GND", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGRIGHT), (TAG_DONE),
	(GTST_String), (ULONG)"P13", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P14", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P15", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P16", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P17", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P18", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P19", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P20", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P21", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P22", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"P23", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(GTST_String), (ULONG)"VCC", (GTST_MaxChars), 9, (STRINGA_Justification), (GACT_STRINGLEFT), (TAG_DONE),
	(TAG_DONE),
	(TAG_DONE),
	(TAG_DONE),
	(TAG_DONE)
};



/***************************** Routinen  ********************************/



/* gibt Zeiger auf String-Gadget-Text von Pin 'pinnum' in der
** Gadget-Liste 'gadget' zurck
*/
UBYTE *PinNamePtr(int pinnum, struct Gadget *gadget)
{

 while (gadget) {

   if (gadget->GadgetID == pinnum)
     return (((struct StringInfo *)gadget->SpecialInfo)->Buffer);

   gadget = gadget->NextGadget;

 }

 return((UBYTE *)0);
}





/* CheckPinNames: Pinnamen berprfen
   Aufruf: result = CheckPinNames();
	   JedecGALType mu den GAL-Typ enthalten
   Ergebnis:  result = 0 : alles o.k.
	            sonst: entsprechende Fehlernummer
*/
int CheckPinNames(void)
{
struct	Gadget	*glist;
UBYTE	*ptr;
int	numofpins, i, j, l, n;


 if (JedecGALType == GAL16V8) {
   numofpins = 20;
   glist = RAsm16GList;
 }
 else {
   numofpins = 24;
   glist = RAsm20GList;
 }

					/*Pinnamen berprfen*/
 for (n = 0; n < numofpins; n++) {

   ptr = PinNamePtr(n+1, glist);		/*berprfen ob Pinname aus*/
						/*gltigen Zeichen besteht*/
   if (*ptr == '/')
     ptr++;

   if (!*ptr) {					/*kein Zeichen da?->Fehler*/
     ReasmError(4, n+1);
     return(4);
   }

   while (isalpha(*ptr) || isdigit(*ptr))
     ptr++;

   if (*ptr == '/') {
     ReasmError(6, n+1);
     return(6);
   }

   if (*ptr) {
     ReasmError(3, n+1);
     return(3);
   }

   for (l=0; l<n; l++) {			/*Pinname doppelt?*/
     if (strcmp((char *)PinNamePtr(l+1, glist), "NC")) {
       i = j = 0;
       if (*(PinNamePtr(l+1, glist)) == '/') i = 1;
       if (*(PinNamePtr(n+1, glist)) == '/') j = 1;
       if (!strcmp((char *)PinNamePtr(l+1, glist) + (long)i, (char *)PinNamePtr(n+1, glist) + (long)j)) {
	 ReasmError(2, n+1);
	 return(2);
       }
     }
   }
					/*GND an entsprechenden Pin?*/
   if (!strcmp((char *)PinNamePtr(n+1, glist), "GND")) {
     if (n+1 != numofpins/2) {
       ReasmError(5, n+1);
       return(5);
     }
   }
   if (n+1 == numofpins/2) {
     if (strcmp((char *)PinNamePtr(n+1, glist), "GND")) {
       ReasmError(7, n+1);
       return(5);
     }
   }
					/*VCC an entsprechenden Pin?*/
   if (!strcmp((char *)PinNamePtr(n+1, glist), "VCC")) {
     if (n+1 != numofpins) {
       ReasmError(5,n+1);
       return(5);
     }
   }
   if (n+1 == numofpins) {
     if (strcmp((char *)PinNamePtr(n+1, glist), "VCC")) {
       ReasmError(8,n+1);
       return(5);
     }
    }
  }

 return(0);
}




/* PinNameRequster: Lt Requester erscheinen, in dem die Pinnamen
		    fr den Reassembler eingegeben werden knnen
   Aufruf   : result = PinNameRequester(galtype);
   Parameter: galtype: GAL16V8 oder GAL20V8
   Ergebnis : result = 0: Weiter angewhlt
		     = 1: Abbruch angewhlt oder Fehler
*/
int PinNameRequester(int galtype)
{
struct	Window 	        *reasmwin;
struct	IntuiMessage	*imsg;
struct	Gadget		*glist, *gadget;
ULONG	class;
USHORT	code, gadID;
UWORD   offy = screen->WBorTop + screen->RastPort.TxHeight + 1;
int	n, numofpins;
char	name[4], numstrng[3];

  if (galtype == GAL16V8) {		/* Variablen initialisieren */
    numofpins = 20;
    glist     = RAsm16GList;
  }
  else {
    numofpins = 24;
    glist     = RAsm20GList;
  }

					/* Fenster ffnen */
  if (!(reasmwin = OpenWindowTags( NULL,
			WA_Left,	 171,
			WA_Top,		 5,
			WA_Width,	 297,
			WA_Height,	 180 + offy,
			WA_IDCMP,	 STRINGIDCMP|BUTTONIDCMP|IDCMP_REFRESHWINDOW|IDCMP_VANILLAKEY,
			WA_Flags,	 WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_SMART_REFRESH|WFLG_ACTIVATE,
			WA_Gadgets,	 glist,
			WA_Title,	 (UBYTE *)"Reassembler",
			WA_CustomScreen, screen,
			TAG_DONE )))
    return(1);


  GT_RefreshWindow(reasmwin, NULL);




  for (;;) {

    Wait (1 << reasmwin->UserPort->mp_SigBit);

    while (imsg = GT_GetIMsg(reasmwin->UserPort)) {

      class = imsg->Class;
      code  = imsg->Code;

      if (class == GADGETUP)
	gadID = ((struct Gadget *)imsg->IAddress)->GadgetID;

      GT_ReplyIMsg(imsg);


      if (class == VANILLAKEY) {
	if (code == 13) {			/* Retrun => Weiter */
	  if (!CheckPinNames()) {
	    CloseWindow(reasmwin);
	    return(0);
	  }
	}

	if (code == 0x1B) {			/* ESC => Abbruch */
	  CloseWindow(reasmwin);
	  return(1);
        }
      }

      if (class == GADGETUP) {

	switch (gadID) {

	  case GD_RAsmGad30:				/* Abbruch */
		CloseWindow(reasmwin);
		return(1);

	  case GD_RAsmGad31:				/* Weiter */
		if (!CheckPinNames()) {
		  CloseWindow(reasmwin);
		  return(0);
		}
		break;

	  case GD_RAsmGad32:				/* Clear */
		gadget = glist;			/* Pinnamen zurcksetzen */

		while (gadget) {
		  if ((gadget->GadgetID < numofpins) &&
		      (gadget->GadgetID != numofpins/2))
		    GT_SetGadgetAttrs(gadget, reasmwin, NULL, GTST_String, NULL, TAG_END);

		  gadget = gadget->NextGadget;
		}
		break;

	  case GD_RAsmGad33:				/* Set */
		gadget = glist;

		while (gadget) {
		  n = (int)gadget->GadgetID;

		  if (n <= numofpins) {
		    if (n == numofpins/2)
		      GT_SetGadgetAttrs(gadget, reasmwin, NULL, GTST_String, "GND", TAG_END);
		    else
		      if (n == numofpins)
		        GT_SetGadgetAttrs(gadget, reasmwin, NULL, GTST_String, "VCC", TAG_END);
		      else {
			name[0] = 'P';
			name[1] = (char)0;

			sprintf(numstrng, "%d", n);

			strcat(name, numstrng);

		        GT_SetGadgetAttrs(gadget, reasmwin, NULL, GTST_String, name, TAG_END);
		      }
		  }

		  gadget = gadget->NextGadget;
		}
		break;

	}
      }
    }
  }

  return(1);
}







/*RowActive: gibt an, ob eine Zeile aktiviert oder deaktiviert ist
	     berprft PT-Bit und sucht nach Folge A * /A
  Aufruf:   result = RowActive(row,colsize);
  result = 0: Zeile ist deaktiviert
	 = 1: Zeile ist aktiviert
	 = 2: Zeile ist aktiviert, aber lauter 1en (VCC)
  row:     Zeile die berprft werden soll
*/
int RowActive(int row)
{
int n, colsize, flag;

 if (JedecGALType == GAL16V8)
   colsize   = MAX_FUSE_ADR16+1;
 else
   colsize   = MAX_FUSE_ADR20+1;

 if (!Jedec.GALPT[row])				/*PT-Bit berprfen*/
   return(0);

 flag = 0;
 for (n=0; n<colsize; n++) {			/*nach "A * /A" suchen*/
   if (!Jedec.GALLogic[row*colsize+n]) {
     flag = 1;
     if (!(n % 2))
       if (!Jedec.GALLogic[row*colsize+n+1])
         return(0);
   }
 }

 if (flag)
   return(1);
 else
   return(2);
}





/*OLMCOutput: gibt an, ob OLMC als Ausgang programmiert ist
  Aufruf:     result = OLMCOutput(olmc);
  	      olmc:    die zu testende OLMC
	      mode:    Modus, in dem sich das GAL befindet
  Ergebnis:   result = 0:  kein Ausgang
	   	     = 1:  Ausgang (enthlt sinnvolle Gleichung)
*/
int OLMCOutput(int olmc, int mode)
{
int n, flag;

 if ((mode == 1) && (Jedec.GALAC1[olmc]))
   return(0);

 flag = 0;
 for (n=0; n<8; n++) {
   if (!n && ((mode == 2) || ((mode == 3) && Jedec.GALAC1[olmc]))) {
     if (!RowActive(olmc*8))		/*Tristatefreigabe = GND?*/
       return(0);			/*ja, dann Eingang*/
   }
   else {
     if (RowActive(olmc*8+n))
       flag = 1;
   }
 }

 return(flag);
}


/*MakeEquation: erstellt aus den angegebenen Zeilen der JEDEC-Struktur
		die entsprechende Gleichung
  Aufruf:     result = MakeEquation(buff, olmc, colsize, mode, numofrows);

  Ergebnis:   result =  0: alles o.k.
	   	     = -1: Fehler, kein Speicher mehr
*/
int MakeEquation(struct ActBuffer *buff, int olmc, int colsize, int mode,
                 int rowoffset, int numofrows)
{
int	ORflag, ANDflag, pin, m, n, result, numofchar;
struct	ActBuffer  startbuff;


 startbuff = *buff;				/*Zeiger merken*/

 numofchar = 8;
 n = rowoffset;

 ORflag = 0;
 while (n < numofrows) {
   result = RowActive(olmc*8 + n);
   if (result == 1) {				/*enthlt die Zeile etwas*/
     if (ORflag) {				/*Sinnvolles? ja, dann OR*/
       if (AddString(buff, (UBYTE *)" + "))
	 return(-1);
       numofchar += 3;				/*Zeichen mitzhlen*/
     }
     ORflag  = 1;
     ANDflag = 0;
     for (m=0; m<colsize; m++) {
       if (!Jedec.GALLogic[(olmc*8+n)*colsize+m]) {
         if (ANDflag) {
           if (AddByte(buff, (UBYTE)'*'))		    /*Produkterm auswerten*/
 	     return(-1);
	   numofchar++;
         }
         ANDflag = 1;
         if (JedecGALType == GAL16V8) {		/*GAL16V8*/
           if (mode == 1)				/*Pinnummer aus der*/
 	     pin = FuseToPin16Mode1[m/2];		/*Spaltennummer bes-*/
           if (mode == 2)				/*stimmen*/
	     pin = FuseToPin16Mode2[m/2];
           if (mode == 3)
	     pin = FuseToPin16Mode3[m/2];
	   if (((*PinNamePtr(pin, RAsm16GList) == '/') && !(m % 2)) || /*Negation in*/
	       ((*PinNamePtr(pin, RAsm16GList) != '/') &&  (m % 2))) { /*Pindek. be-*/
	     if (AddByte(buff, (UBYTE)'/'))		      /*rcksichtigen*/
	       return(-1);
	     numofchar++;
	   }
	   if (*PinNamePtr(pin, RAsm16GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	     if (AddString(buff, (PinNamePtr(pin, RAsm16GList) + 1L)))
               return(-1);
	   }
	   else {
	     if (AddString(buff, PinNamePtr(pin, RAsm16GList)))
               return(-1);
	   }
	   numofchar += (int)strlen((char *)PinNamePtr(pin, RAsm16GList));
         }
         if (JedecGALType == GAL20V8) {		/*GAL20V8*/
           if (mode == 1)				/*Pinnummer aus der*/
 	     pin = FuseToPin20Mode1[m/2];		/*Spaltennummer bes-*/
           if (mode == 2)				/*stimmen*/
	     pin = FuseToPin20Mode2[m/2];
           if (mode == 3)
	     pin = FuseToPin20Mode3[m/2];
	   if (((*PinNamePtr(pin, RAsm20GList) == '/') && !(m % 2)) || /*Negation in*/
	       ((*PinNamePtr(pin, RAsm20GList) != '/') &&  (m % 2))) { /*Pindek. be-*/
	     if (AddByte(buff, (UBYTE)'/'))		      /*rcksichtigen*/
	       return(-1);
	     numofchar++;
	   }
	   if (*PinNamePtr(pin, RAsm20GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	     if (AddString(buff, PinNamePtr(pin, RAsm20GList) + 1L))
               return(-1);
	   }
	   else {
	     if (AddString(buff, PinNamePtr(pin, RAsm20GList)))
               return(-1);
	   }
	   numofchar += (int)strlen((char *)PinNamePtr(pin, RAsm20GList));
         }
	 if (numofchar > 60) {				/*neue Zeile?*/
	   if (AddString(buff, (UBYTE *)"\n        "))
	     return(-1);
	   numofchar = 8;
	 }
       }
     }
   }
   if (result == 2) {			/*nur 1en in der Zeile, dann*/
     *buff = startbuff;			/*liegt VCC vor*/
     if (AddString(buff, (UBYTE *)"VCC"))
       return(-1);
       break;
   }
   n++;
 }
 if (AddString(buff, (UBYTE *)"\n\n"))		/*Gleichungsende*/
   return(-1);

 return(0);
}







/*Reasm: Erstellt aus der Jedec-Struktur wieder die Eingabe-Datei. Diese
	 wird in "buff" abelegt.
  Aufruf: result = Reasm(buff);
  	  buff: ActBuffer-Struktur fr Speicher, in dem das File abgelegt
		werden soll
  Ergebnis: result = 0:     alles o.k.
		   = sonst: Fehler
*/
int Reasm(struct ActBuffer buff)
{
int	mode, n, numofpins, byte;
int	olmc, colsize;
int	tricon[8];


 if (JedecGALType == GAL16V8) {		/*GAL-Typ bestimmen*/
   if (AddString(&buff, (UBYTE *)"GAL16V8\n"))
     return(-1);
   numofpins = 20;
   colsize   = MAX_FUSE_ADR16+1;
 }
 else {
   if (AddString(&buff, (UBYTE *)"GAL20V8\n"))
     return(-1);
   numofpins = 24;
   colsize   = MAX_FUSE_ADR20+1;
 }

 byte = 0;				/*Signatur erstellen*/
 for (n=0; n<SIG_SIZE; n++) {
   byte |= Jedec.GALSig[n];			/*8 Bits zu einem Byte*/
   if (!((n+1)%8)) {				/*zusammenfgen*/
     if (!isprint(byte))
       byte = '.';
     if (AddByte(&buff, (UBYTE)byte))
       return(-1);
     byte = 0;
    }
   byte <<= 1;
 } 
 if (AddString(&buff, (UBYTE *)"\n\n"))
   return(-1);

					/*Pinnamen erstellen*/
 for (n=1; n<=numofpins; n++) {
   if (JedecGALType == GAL16V8)
     if (AddString(&buff, PinNamePtr(n, RAsm16GList)))
       return(-1);
   if (JedecGALType == GAL20V8)
     if (AddString(&buff, PinNamePtr(n, RAsm20GList)))
       return(-1);
   if (n == numofpins/2) {
     if (AddString(&buff, (UBYTE *)"\n"))
       return(-1);
   }
   else {
     if (AddString(&buff, (UBYTE *)" "))
       return(-1);
   }
 }

 if (AddString(&buff, (UBYTE *)"\n\n"))
   return(-1);



 if (!Jedec.GALAC0 && !Jedec.GALSYN) {	/*Modus berprfen*/
   ReasmError(1,0);				/*Fehler, dann Ende*/
   return(1);
 }
					/*Modus bestimmen*/
 if (!Jedec.GALSYN) {				/*Wenn SYN = 0, dann Mode 3*/
   mode = 3;					/*Register-Modus*/
 }
 else {
   if (Jedec.GALSYN && Jedec.GALAC0)
     mode = 2;					/*Tristate-Modus*/
   else
      mode = 1;					/*kombinatorische Ausgnge*/
 }

 for (n=0; n<8; tricon[n++]=0);		/*Merker fr Ausgnge mit Tristate-*/
					/*kontrolle initialisieren*/

					/*Gleichungen erstellen*/
 for (olmc=0; olmc<8; olmc++) {			/*8 OLMCs vorhanden*/
   if (OLMCOutput(olmc,mode)) {			/*OLMC als Ausgang?*/

     if (JedecGALType == GAL16V8) {
				      /*Negation in Pindek. bercksichtigen*/
       if (((*PinNamePtr(19-olmc, RAsm16GList) == '/') && Jedec.GALXOR[olmc]) ||
	   ((*PinNamePtr(19-olmc, RAsm16GList) != '/') && !Jedec.GALXOR[olmc])) {
	 if (AddByte(&buff, (UBYTE)'/'))
	   return(-1);
       }

       if (*PinNamePtr(19-olmc, RAsm16GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	 if (AddString(&buff, PinNamePtr(19-olmc, RAsm16GList) + 1L))
           return(-1);
       }
       else {
	 if (AddString(&buff, PinNamePtr(19-olmc, RAsm16GList)))
           return(-1);
       }
     }

     if (JedecGALType == GAL20V8) {
				      /*Negation in Pindek. bercksichtigen*/
       if (((*PinNamePtr(22-olmc, RAsm20GList) == '/') && Jedec.GALXOR[olmc]) ||
	   ((*PinNamePtr(22-olmc, RAsm20GList) != '/') && !Jedec.GALXOR[olmc])) {
	 if (AddByte(&buff, (UBYTE)'/'))
	   return(-1);
       }

       if (*PinNamePtr(22-olmc, RAsm20GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	 if (AddString(&buff, PinNamePtr(22-olmc, RAsm20GList) + 1L))
           return(-1);
       }
       else {
	 if (AddString(&buff, PinNamePtr(22-olmc, RAsm20GList)))
           return(-1);
       }
     }

     if ((mode == 2) || ((mode == 3) && (Jedec.GALAC1[olmc]))) {
       if (AddString(&buff, (UBYTE *)".T"))
         return(-1);
       tricon[olmc] = 1;			/*Merker setzen, da Tri.-*/
     }						/*kontrolle vorhanden ist*/

     if ((mode == 3) && (!Jedec.GALAC1[olmc]))
       if (AddString(&buff, (UBYTE *)".R"))
         return(-1);

     if (AddString(&buff, (UBYTE *)" = "))
       return(-1);

     n = 0;
     if ((mode == 2) || ((mode == 3) && Jedec.GALAC1[olmc])) /*bei Tri.*/
       n++;				   /*die erste Zeile berspringen*/
     if (MakeEquation(&buff, olmc, colsize, mode, n, 8))
       return(-1);
   }
 }

				/*Tristate-Kontrolle erzeugen*/
 for (olmc=0; olmc<8; olmc++) {
   if (tricon[olmc]) {
     if (JedecGALType == GAL16V8) {
       if (*PinNamePtr(19-olmc, RAsm16GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	 if (AddString(&buff, PinNamePtr(19-olmc, RAsm16GList) + 1L))
           return(-1);
       }
       else {
	 if (AddString(&buff, PinNamePtr(19-olmc, RAsm16GList)))
           return(-1);
       }
     }
     if (JedecGALType == GAL20V8) {
       if (*PinNamePtr(22-olmc, RAsm20GList) == '/') {   /*Pinnamen ohne '/' schreiben*/
	 if (AddString(&buff, PinNamePtr(22-olmc, RAsm20GList) + 1L))
           return(-1);
       }
       else {
	 if (AddString(&buff, PinNamePtr(22-olmc, RAsm20GList)))
           return(-1);
       }
     }
     if (AddString(&buff, (UBYTE *)".E"))		/*Tristate-Freigabe*/
       return(-1);
     if (AddString(&buff, (UBYTE *)" = "))
       return(-1);

     if (MakeEquation(&buff, olmc, colsize, mode, 0, 1))
       return(-1);
   }
 }


					/*Abschlutext schreiben*/
 if (AddString(&buff,"DESCRIPTION:\nThis is a reassembled file. Used JEDEC file: '"))
   return(-1);
 if (AddString(&buff, (UBYTE *)&filename[0]))
   return(-1);
 if (AddString(&buff, (UBYTE *)"'\n\n"))
   return(-1);

 return(0);				/*kein Fehler aufgetreten, fertig*/
}




/*Reassembler: Jedec-File in Source-File zurckverwandeln
*/
void Reassembler(void)
{
struct	Buffer		*reasm_buff;
struct	ActBuffer	mybuff;
BPTR 	fh;
UBYTE	*filebuffer, *filebuffer2;
int	result;

 if (MyFileReq(GetCatalogStr(catalog, MSG_LOADJED, "load JEDEC file"), ".jed", YES, LOAD)) {
   if (!(GetJedec((UBYTE *)&path[0]))) {	/*JEDEC-File holen*/

     if (PinNameRequester(JedecGALType))
       return;


     if (!(reasm_buff = (struct Buffer *)AllocMem((long)sizeof(struct Buffer),MEMF_PUBLIC|MEMF_CLEAR))) {
       ErrorReq(2);			/*kein Speicher mehr->Fehlermeldung*/
       return;
     }
     mybuff.ThisBuff = reasm_buff;
     mybuff.Entry    = (UBYTE *)(&reasm_buff->Entries[0]);
     mybuff.BuffEnd  = (UBYTE *)reasm_buff + (long)sizeof(struct Buffer);


     if (!Reasm(mybuff) && MyFileReq(GetCatalogStr(catalog, MSG_WRITE_SOURCE, "save source file"), ".pld", YES, SAVE)) {
       PrintText(GetCatalogStr(catalog, MSG_WRITING_SOURCE, "saving source file..."), 1);
       if ((fh = Open(&path[0], (long)MODE_NEWFILE))) {
         for (;;) {
	   filebuffer = filebuffer2 = mybuff.Entry;

	   while (filebuffer2 < mybuff.BuffEnd) {	/*Gre des Puffers bestimmen*/
	     if (!*filebuffer2) 
	       break;
             filebuffer2++;
	   }
						/*Puffer schreiben*/
	   result = Write(fh, (char *)filebuffer, (long)(filebuffer2-filebuffer));
	   if (result == -1L) {			/*Fehler beim Schreiben?*/
	     Close(fh);				/*ja, dann Ende*/
	     FreeBuffer(reasm_buff);
	     PrintText(GetCatalogStr(catalog, MSG_ERROR, " Error!"), 0);
	     ErrorReq(13);
	     return;
	   }

	   if (!mybuff.ThisBuff->Next)		/*noch ein Puffer da?*/
	     break;					/*nein, dann for(;;)-Ende*/
	   mybuff.ThisBuff = mybuff.ThisBuff->Next;
	   mybuff.Entry    = (UBYTE *)(&mybuff.ThisBuff->Entries[0]);
	   mybuff.BuffEnd  = (UBYTE *)mybuff.ThisBuff + (long)sizeof(struct Buffer);
         }
         Close(fh);
       }
       else {
         FreeBuffer(reasm_buff);		/*Fehler?, dann Abbruch*/
         PrintText(GetCatalogStr(catalog, MSG_ERROR, " Error!"), 0);
         ErrorReq(13);			/*Datei lt sich nicht ffnen*/
         return;
       }

       PrintText(GetCatalogStr(catalog, MSG_LOWER_OK, " o.k."), 0);
     }
     FreeBuffer(reasm_buff);			/*Speicher freigeben*/
   }
 }
}



/* gibt Fehlermeldungen des Reassemblers aus und gibt Speicher frei
*/
void ReasmError(int errornum, int pinnum)
{
char    string[40];

 switch (errornum) {
   case  1:
     MyRequest(ERR_REQ, GetCatalogStr(catalog, MSG_REASM_ERR, "Reassembler error!"));
     PrintText(GetCatalogStr(catalog, MSG_ERR_REASM1, "Mode AC0 = SYN = 0 is not supported"), 1);
     break;
   case  2:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM2, "Pin xx: pinname defined twice"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  3:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM3, "Pin xx: illegal character"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  4:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM4, "Pin xx: no pinname found"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  5:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM5, "Pin xx: VCC/GND at wrong pin"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  6:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM6, "Pin xx: illegal use of '/'"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  7:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM7, "Pin xx: GND expected"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;
   case  8:
     strcpy(string, GetCatalogStr(catalog, MSG_ERR_REASM8, "Pin xx: VCC expected"));
     sprintf(&string[4], "%2d", pinnum);
     string[6] = ':';
     MyRequest(ERR_REQ, string);
     break;

 }
}




