** The offset tables and decoding routines for the prefixed Z80
** instructions


** See the file "cache.txt" for details on the decoding.


** All Z80 opcodes exactly follow Zaks' "Programming the Z80"

**	n  = 8-bit number
**	nn = 16-bit number
**	e  = 8-bit relative jump offset
**	d  = 8-bit displacement
**	pq = 16-bit address
**	p  = 8-bit address

** Label notation:	Underscore used for SPACE, comma and +

**			1 (one) used for ( and )

** =====================================================================

	IFD VERBOSE
	LIST
** Compiling the prefix_offsets.i file.
	NOLIST
	ENDC


** If a CB-prefix has been found:

CBdecode	cmp.w	#out_of_bounds,(PPC)    ;test 2nd word
		bne.s	.not_oob
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		getz	d7,d7	;get second byte
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	CBoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,(PPC)
		jmp	(InstrB,d7.w)

CBoffsets
	dc.w	Rlc_B-base
	dc.w	Rlc_C-base
	dc.w	Rlc_D-base
	dc.w	Rlc_E-base
	dc.w	Rlc_H-base
	dc.w	Rlc_L-base
	dc.w	Rlc_1HL1-base
	dc.w	Rlc_A-base
	dc.w	Rrc_B-base
	dc.w	Rrc_C-base
	dc.w	Rrc_D-base
	dc.w	Rrc_E-base
	dc.w	Rrc_H-base
	dc.w	Rrc_L-base
	dc.w	Rrc_1HL1-base
	dc.w	Rrc_A-base
.10	dc.w	Rl_B-base
	dc.w	Rl_C-base
	dc.w	Rl_D-base
	dc.w	Rl_E-base
	dc.w	Rl_H-base
	dc.w	Rl_L-base
	dc.w	Rl_1HL1-base
	dc.w	Rl_A-base
	dc.w	Rr_B-base
	dc.w	Rr_C-base
	dc.w	Rr_D-base
	dc.w	Rr_E-base
	dc.w	Rr_H-base
	dc.w	Rr_L-base
	dc.w	Rr_1HL1-base
	dc.w	Rr_A-base
.20	dc.w	Sla_B-base
	dc.w	Sla_C-base
	dc.w	Sla_D-base
	dc.w	Sla_E-base
	dc.w	Sla_H-base
	dc.w	Sla_L-base
	dc.w	Sla_1HL1-base
	dc.w	Sla_A-base
	dc.w	Sra_B-base
	dc.w	Sra_C-base
	dc.w	Sra_D-base
	dc.w	Sra_E-base
	dc.w	Sra_H-base
	dc.w	Sra_L-base
	dc.w	Sra_1HL1-base
	dc.w	Sra_A-base
.30	dc.w	Sll_B-base	;undocumented
	dc.w	Sll_C-base	;undocumented
	dc.w	Sll_D-base	;undocumented
	dc.w	Sll_E-base	;undocumented
	dc.w	Sll_H-base	;undocumented
	dc.w	Sll_L-base	;undocumented
	dc.w	Sll_1HL1-base	;undocumented
	dc.w	Sll_A-base	;undocumented
	dc.w	Srl_B-base
	dc.w	Srl_C-base
	dc.w	Srl_D-base
	dc.w	Srl_E-base
	dc.w	Srl_H-base
	dc.w	Srl_L-base
	dc.w	Srl_1HL1-base
	dc.w	Srl_A-base
.40	dc.w	Bit_0_B-base
	dc.w	Bit_0_C-base
	dc.w	Bit_0_D-base
	dc.w	Bit_0_E-base
	dc.w	Bit_0_H-base
	dc.w	Bit_0_L-base
	dc.w	Bit_0_1HL1-base
	dc.w	Bit_0_A-base
	dc.w	Bit_1_B-base
	dc.w	Bit_1_C-base
	dc.w	Bit_1_D-base
	dc.w	Bit_1_E-base
	dc.w	Bit_1_H-base
	dc.w	Bit_1_L-base
	dc.w	Bit_1_1HL1-base
	dc.w	Bit_1_A-base
.50	dc.w	Bit_2_B-base
	dc.w	Bit_2_C-base
	dc.w	Bit_2_D-base
	dc.w	Bit_2_E-base
	dc.w	Bit_2_H-base
	dc.w	Bit_2_L-base
	dc.w	Bit_2_1HL1-base
	dc.w	Bit_2_A-base
	dc.w	Bit_3_B-base
	dc.w	Bit_3_C-base
	dc.w	Bit_3_D-base
	dc.w	Bit_3_E-base
	dc.w	Bit_3_H-base
	dc.w	Bit_3_L-base
	dc.w	Bit_3_1HL1-base
	dc.w	Bit_3_A-base
.60	dc.w	Bit_4_B-base
	dc.w	Bit_4_C-base
	dc.w	Bit_4_D-base
	dc.w	Bit_4_E-base
	dc.w	Bit_4_H-base
	dc.w	Bit_4_L-base
	dc.w	Bit_4_1HL1-base
	dc.w	Bit_4_A-base
	dc.w	Bit_5_B-base
	dc.w	Bit_5_C-base
	dc.w	Bit_5_D-base
	dc.w	Bit_5_E-base
	dc.w	Bit_5_H-base
	dc.w	Bit_5_L-base
	dc.w	Bit_5_1HL1-base
	dc.w	Bit_5_A-base
.70	dc.w	Bit_6_B-base
	dc.w	Bit_6_C-base
	dc.w	Bit_6_D-base
	dc.w	Bit_6_E-base
	dc.w	Bit_6_H-base
	dc.w	Bit_6_L-base
	dc.w	Bit_6_1HL1-base
	dc.w	Bit_6_A-base
	dc.w	Bit_7_B-base
	dc.w	Bit_7_C-base
	dc.w	Bit_7_D-base
	dc.w	Bit_7_E-base
	dc.w	Bit_7_H-base
	dc.w	Bit_7_L-base
	dc.w	Bit_7_1HL1-base
	dc.w	Bit_7_A-base
.80	dc.w	Res_0_B-base
	dc.w	Res_0_C-base
	dc.w	Res_0_D-base
	dc.w	Res_0_E-base
	dc.w	Res_0_H-base
	dc.w	Res_0_L-base
	dc.w	Res_0_1HL1-base
	dc.w	Res_0_A-base
	dc.w	Res_1_B-base
	dc.w	Res_1_C-base
	dc.w	Res_1_D-base
	dc.w	Res_1_E-base
	dc.w	Res_1_H-base
	dc.w	Res_1_L-base
	dc.w	Res_1_1HL1-base
	dc.w	Res_1_A-base
.90	dc.w	Res_2_B-base
	dc.w	Res_2_C-base
	dc.w	Res_2_D-base
	dc.w	Res_2_E-base
	dc.w	Res_2_H-base
	dc.w	Res_2_L-base
	dc.w	Res_2_1HL1-base
	dc.w	Res_2_A-base
	dc.w	Res_3_B-base
	dc.w	Res_3_C-base
	dc.w	Res_3_D-base
	dc.w	Res_3_E-base
	dc.w	Res_3_H-base
	dc.w	Res_3_L-base
	dc.w	Res_3_1HL1-base
	dc.w	Res_3_A-base
.A0	dc.w	Res_4_B-base
	dc.w	Res_4_C-base
	dc.w	Res_4_D-base
	dc.w	Res_4_E-base
	dc.w	Res_4_H-base
	dc.w	Res_4_L-base
	dc.w	Res_4_1HL1-base
	dc.w	Res_4_A-base
	dc.w	Res_5_B-base
	dc.w	Res_5_C-base
	dc.w	Res_5_D-base
	dc.w	Res_5_E-base
	dc.w	Res_5_H-base
	dc.w	Res_5_L-base
	dc.w	Res_5_1HL1-base
	dc.w	Res_5_A-base
.B0	dc.w	Res_6_B-base
	dc.w	Res_6_C-base
	dc.w	Res_6_D-base
	dc.w	Res_6_E-base
	dc.w	Res_6_H-base
	dc.w	Res_6_L-base
	dc.w	Res_6_1HL1-base
	dc.w	Res_6_A-base
	dc.w	Res_7_B-base
	dc.w	Res_7_C-base
	dc.w	Res_7_D-base
	dc.w	Res_7_E-base
	dc.w	Res_7_H-base
	dc.w	Res_7_L-base
	dc.w	Res_7_1HL1-base
	dc.w	Res_7_A-base
.C0	dc.w	Set_0_B-base
	dc.w	Set_0_C-base
	dc.w	Set_0_D-base
	dc.w	Set_0_E-base
	dc.w	Set_0_H-base
	dc.w	Set_0_L-base
	dc.w	Set_0_1HL1-base
	dc.w	Set_0_A-base
	dc.w	Set_1_B-base
	dc.w	Set_1_C-base
	dc.w	Set_1_D-base
	dc.w	Set_1_E-base
	dc.w	Set_1_H-base
	dc.w	Set_1_L-base
	dc.w	Set_1_1HL1-base
	dc.w	Set_1_A-base
.D0	dc.w	Set_2_B-base
	dc.w	Set_2_C-base
	dc.w	Set_2_D-base
	dc.w	Set_2_E-base
	dc.w	Set_2_H-base
	dc.w	Set_2_L-base
	dc.w	Set_2_1HL1-base
	dc.w	Set_2_A-base
	dc.w	Set_3_B-base
	dc.w	Set_3_C-base
	dc.w	Set_3_D-base
	dc.w	Set_3_E-base
	dc.w	Set_3_H-base
	dc.w	Set_3_L-base
	dc.w	Set_3_1HL1-base
	dc.w	Set_3_A-base
.E0	dc.w	Set_4_B-base
	dc.w	Set_4_C-base
	dc.w	Set_4_D-base
	dc.w	Set_4_E-base
	dc.w	Set_4_H-base
	dc.w	Set_4_L-base
	dc.w	Set_4_1HL1-base
	dc.w	Set_4_A-base
	dc.w	Set_5_B-base
	dc.w	Set_5_C-base
	dc.w	Set_5_D-base
	dc.w	Set_5_E-base
	dc.w	Set_5_H-base
	dc.w	Set_5_L-base
	dc.w	Set_5_1HL1-base
	dc.w	Set_5_A-base
.F0	dc.w	Set_6_B-base
	dc.w	Set_6_C-base
	dc.w	Set_6_D-base
	dc.w	Set_6_E-base
	dc.w	Set_6_H-base
	dc.w	Set_6_L-base
	dc.w	Set_6_1HL1-base
	dc.w	Set_6_A-base
	dc.w	Set_7_B-base
	dc.w	Set_7_C-base
	dc.w	Set_7_D-base
	dc.w	Set_7_E-base
	dc.w	Set_7_H-base
	dc.w	Set_7_L-base
	dc.w	Set_7_1HL1-base
	dc.w	Set_7_A-base

** -------------------------------

** If an ED-prefix has been found:

EDdecode	cmp.w	#out_of_bounds,(PPC)    ;test 2nd word
		bne.s	.not_oob
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		getz	d7,d7	;get 2nd byte
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	EDoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,(PPC)
		jmp	(InstrB,d7.w)

EDoffsets
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.10	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.20	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.30	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.40	dc.w	In_B_1C1-base
	dc.w	Out_1C1_B-base
	dc.w	Sbc_HL_BC-base
	dc.w	Ld_1nn1_BC-base
	dc.w	Neg-base
	dc.w	Retn-base
	dc.w	Im_0-base
	dc.w	Ld_I_A-base
	dc.w	In_C_1C1-base
	dc.w	Out_1C1_C-base
	dc.w	Adc_HL_BC-base
	dc.w	Ld_BC_1nn1-base
	dc.w	undoc_neg	;undocumented
	dc.w	Reti-base
	dc.w	undef
	dc.w	Ld_R_A-base
.50	dc.w	In_D_1C1-base
	dc.w	Out_1C1_D-base
	dc.w	Sbc_HL_DE-base
	dc.w	Ld_1nn1_DE-base
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	Im_1-base
	dc.w	Ld_A_I-base
	dc.w	In_E_1C1-base
	dc.w	Out_1C1_E-base
	dc.w	Adc_HL_DE-base
	dc.w	Ld_DE_1nn1-base
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	Im_2-base
	dc.w	Ld_A_R-base
.60	dc.w	In_H_1C1-base
	dc.w	Out_1C1_H-base
	dc.w	Sbc_HL_HL-base
	dc.w	ED_Ld_1nn1_HL-base  ;"ED_" to separate from unprefixed
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	undef
	dc.w	Rrd-base
	dc.w	In_L_1C1-base
	dc.w	Out_1C1_L-base
	dc.w	Adc_HL_HL-base
	dc.w	ED_Ld_HL_1nn1-base  ;"ED_" to separate from unprefixed
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	undef
	dc.w	Rld-base
.70	dc.w	In_xx_1C1-base	;undocumented. Reads, but never stores.
	dc.w	Out_1C1_xx-base	;undocumented. Seems to send 00 to port C.
	dc.w	Sbc_HL_SP-base
	dc.w	Ld_1nn1_SP-base
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	undef
	dc.w	undef
	dc.w	In_A_1C1-base
	dc.w	Out_1C1_A-base
	dc.w	Adc_HL_SP-base
	dc.w	Ld_SP_1nn1-base
	dc.w	undoc_neg	;undocumented
	dc.w	undoc_retn	;undocumented
	dc.w	undef
	dc.w	undef
.80	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.90	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.A0	dc.w	Ldi-base
	dc.w	Cpi-base
	dc.w	Ini-base
	dc.w	Outi-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ldd-base
	dc.w	Cpd-base
	dc.w	Ind-base
	dc.w	Outd-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.B0	dc.w	Ldir-base
	dc.w	Cpir-base
	dc.w	Inir-base
	dc.w	Otir-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Lddr-base
	dc.w	Cpdr-base
	dc.w	Indr-base
	dc.w	Otdr-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.C0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.D0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.E0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.F0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef

** -------------------------------

** If a DD-prefix has been found:

DDdecode	cmp.w	#out_of_bounds,(PPC)    ;test 2nd word
		bne.s	.not_oob
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		getz	d7,d7	;get 2nd byte
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	DDoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,(PPC)
		jmp	(InstrB,d7.w)

DDoffsets
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_IX_BC-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.10	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_IX_DE-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.20	dc.w	undef
	dc.w	Ld_IX_nn-base
	dc.w	Ld_1nn1_IX-base
	dc.w	Inc_IX-base
	dc.w	Inc_XH-base	;undocumented
	dc.w	Dec_XH-base	;undocumented
	dc.w	Ld_XH_n-base	;undocumented
	dc.w	undef
	dc.w	undef
	dc.w	Add_IX_IX-base
	dc.w	Ld_IX_1nn1-base
	dc.w	Dec_IX-base
	dc.w	Inc_XL-base	;undocumented
	dc.w	Dec_XL-base	;undocumented
	dc.w	Ld_XL_n-base	;undocumented
	dc.w	undef
.30	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Inc_1IX_d1-base
	dc.w	Dec_1IX_d1-base
	dc.w	Ld_1IX_d1_n-base
	dc.w	undef
	dc.w	undef
	dc.w	Add_IX_SP-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.40	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_B_XH-base	;undocumented
	dc.w	Ld_B_XL-base	;undocumented
	dc.w	Ld_B_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_C_XH-base	;undocumented
	dc.w	Ld_C_XL-base	;undocumented
	dc.w	Ld_C_1IX_d1-base
	dc.w	undef
.50	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_D_XH-base	;undocumented
	dc.w	Ld_D_XL-base	;undocumented
	dc.w	Ld_D_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_E_XH-base	;undocumented
	dc.w	Ld_E_XL-base	;undocumented
	dc.w	Ld_E_1IX_d1-base
	dc.w	undef
.60	dc.w	Ld_XH_B-base	;undocumented
	dc.w	Ld_XH_C-base	;undocumented
	dc.w	Ld_XH_D-base	;undocumented
	dc.w	Ld_XH_E-base	;undocumented
	dc.w	Ld_XH_XH-base	;undocumented
	dc.w	Ld_XH_XL-base	;undocumented
	dc.w	Ld_H_1IX_d1-base
	dc.w	Ld_XH_A-base	;undocumented
	dc.w	Ld_XL_B-base	;undocumented
	dc.w	Ld_XL_C-base	;undocumented
	dc.w	Ld_XL_D-base	;undocumented
	dc.w	Ld_XL_E-base	;undocumented
	dc.w	Ld_XL_XH-base	;undocumented
	dc.w	Ld_XL_XL-base	;undocumented
	dc.w	Ld_L_1IX_d1-base
	dc.w	Ld_XL_A-base	;undocumented
.70	dc.w	Ld_1IX_d1_B-base
	dc.w	Ld_1IX_d1_C-base
	dc.w	Ld_1IX_d1_D-base
	dc.w	Ld_1IX_d1_E-base
	dc.w	Ld_1IX_d1_H-base
	dc.w	Ld_1IX_d1_L-base
	dc.w	undef
	dc.w	Ld_1IX_d1_A-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_A_XH-base	;undocumented
	dc.w	Ld_A_XL-base	;undocumented
	dc.w	Ld_A_1IX_d1-base
	dc.w	undef
.80	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_A_XH-base	;undocumented
	dc.w	Add_A_XL-base	;undocumented
	dc.w	Add_A_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Adc_A_XH-base	;undocumented
	dc.w	Adc_A_XL-base	;undocumented
	dc.w	Adc_A_1IX_d1-base
	dc.w	undef
.90	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Sub_XH-base	;undocumented
	dc.w	Sub_XL-base	;undocumented
	dc.w	Sub_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Sbc_A_XH-base	;undocumented
	dc.w	Sbc_A_XL-base	;undocumented
	dc.w	Sbc_A_1IX_d1-base
	dc.w	undef
.A0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	And_XH-base	;undocumented
	dc.w	And_XL-base	;undocumented
	dc.w	And_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Xor_XH-base	;undocumented
	dc.w	Xor_XL-base	;undocumented
	dc.w	Xor_1IX_d1-base
	dc.w	undef
.B0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Or_XH-base	;undocumented
	dc.w	Or_XL-base	;undocumented
	dc.w	Or_1IX_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Cp_XH-base	;undocumented
	dc.w	Cp_XL-base	;undocumented
	dc.w	Cp_1IX_d1-base
	dc.w	undef
.C0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	DDCBdecode-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.D0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.E0	dc.w	undef
	dc.w	Pop_IX-base
	dc.w	undef
	dc.w	Ex_1SP1_IX-base
	dc.w	undef
	dc.w	Push_IX-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Jp_1IX1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.F0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_SP_IX-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef

** -------------------------------

** If a DDCB sequence has been found:
** Remember: DD CB offset opcode. PPC points to CB. CB is marked as
**           unchanged.

DDCBdecode	cmp.w	#out_of_bounds,4(PPC)    ;test 4th word
		bne.s	.not_oob
		clr.w	(PPC)	;remove 'unchanged' marker from CB
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		addq.w	#2,d7	;get 4th byte
		getz	d7,d7
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	DDCBoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,4(PPC)
		jmp	(InstrB,d7.w)

DDCBoffsets
	dc.w	Rlc_B_1IX_d1-base	;undocumented
	dc.w	Rlc_C_1IX_d1-base	;undocumented
	dc.w	Rlc_D_1IX_d1-base	;undocumented
	dc.w	Rlc_E_1IX_d1-base	;undocumented
	dc.w	Rlc_H_1IX_d1-base	;undocumented
	dc.w	Rlc_L_1IX_d1-base	;undocumented
	dc.w	Rlc_1IX_d1-base
	dc.w	Rlc_A_1IX_d1-base	;undocumented
	dc.w	Rrc_B_1IX_d1-base	;undocumented
	dc.w	Rrc_C_1IX_d1-base	;undocumented
	dc.w	Rrc_D_1IX_d1-base	;undocumented
	dc.w	Rrc_E_1IX_d1-base	;undocumented
	dc.w	Rrc_H_1IX_d1-base	;undocumented
	dc.w	Rrc_L_1IX_d1-base	;undocumented
	dc.w	Rrc_1IX_d1-base
	dc.w	Rrc_A_1IX_d1-base	;undocumented
.10	dc.w	Rl_B_1IX_d1-base	;undocumented
	dc.w	Rl_C_1IX_d1-base	;undocumented
	dc.w	Rl_D_1IX_d1-base	;undocumented
	dc.w	Rl_E_1IX_d1-base	;undocumented
	dc.w	Rl_H_1IX_d1-base	;undocumented
	dc.w	Rl_L_1IX_d1-base	;undocumented
	dc.w	Rl_1IX_d1-base
	dc.w	Rl_A_1IX_d1-base	;undocumented
	dc.w	Rr_B_1IX_d1-base	;undocumented
	dc.w	Rr_C_1IX_d1-base	;undocumented
	dc.w	Rr_D_1IX_d1-base	;undocumented
	dc.w	Rr_E_1IX_d1-base	;undocumented
	dc.w	Rr_H_1IX_d1-base	;undocumented
	dc.w	Rr_L_1IX_d1-base	;undocumented
	dc.w	Rr_1IX_d1-base
	dc.w	Rr_A_1IX_d1-base	;undocumented
.20	dc.w	Sla_B_1IX_d1-base	;undocumented
	dc.w	Sla_C_1IX_d1-base	;undocumented
	dc.w	Sla_D_1IX_d1-base	;undocumented
	dc.w	Sla_E_1IX_d1-base	;undocumented
	dc.w	Sla_H_1IX_d1-base	;undocumented
	dc.w	Sla_L_1IX_d1-base	;undocumented
	dc.w	Sla_1IX_d1-base
	dc.w	Sla_A_1IX_d1-base	;undocumented
	dc.w	Sra_B_1IX_d1-base	;undocumented
	dc.w	Sra_C_1IX_d1-base	;undocumented
	dc.w	Sra_D_1IX_d1-base	;undocumented
	dc.w	Sra_E_1IX_d1-base	;undocumented
	dc.w	Sra_H_1IX_d1-base	;undocumented
	dc.w	Sra_L_1IX_d1-base	;undocumented
	dc.w	Sra_1IX_d1-base
	dc.w	Sra_A_1IX_d1-base	;undocumented
.30	dc.w	Sll_B_1IX_d1-base	;undocumented
	dc.w	Sll_C_1IX_d1-base	;undocumented
	dc.w	Sll_D_1IX_d1-base	;undocumented
	dc.w	Sll_E_1IX_d1-base	;undocumented
	dc.w	Sll_H_1IX_d1-base	;undocumented
	dc.w	Sll_L_1IX_d1-base	;undocumented
	dc.w	Sll_1IX_d1-base		;undocumented
	dc.w	Sll_A_1IX_d1-base	;undocumented
	dc.w	Srl_B_1IX_d1-base	;undocumented
	dc.w	Srl_C_1IX_d1-base	;undocumented
	dc.w	Srl_D_1IX_d1-base	;undocumented
	dc.w	Srl_E_1IX_d1-base	;undocumented
	dc.w	Srl_H_1IX_d1-base	;undocumented
	dc.w	Srl_L_1IX_d1-base	;undocumented
	dc.w	Srl_1IX_d1-base
	dc.w	Srl_A_1IX_d1-base	;undocumented
.40	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_0_1IX_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_1_1IX_d1-base
	dc.w	undef_3byte
.50	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_2_1IX_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_3_1IX_d1-base
	dc.w	undef_3byte
.60	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_4_1IX_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_5_1IX_d1-base
	dc.w	undef_3byte
.70	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_6_1IX_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_7_1IX_d1-base
	dc.w	undef_3byte
.80	dc.w	Res_B_0_1IX_d1-base	;undefined
	dc.w	Res_C_0_1IX_d1-base	;undefined
	dc.w	Res_D_0_1IX_d1-base	;undefined
	dc.w	Res_E_0_1IX_d1-base	;undefined
	dc.w	Res_H_0_1IX_d1-base	;undefined
	dc.w	Res_L_0_1IX_d1-base	;undefined
	dc.w	Res_0_1IX_d1-base
	dc.w	Res_A_0_1IX_d1-base	;undefined
	dc.w	Res_B_1_1IX_d1-base	;undefined
	dc.w	Res_C_1_1IX_d1-base	;undefined
	dc.w	Res_D_1_1IX_d1-base	;undefined
	dc.w	Res_E_1_1IX_d1-base	;undefined
	dc.w	Res_H_1_1IX_d1-base	;undefined
	dc.w	Res_L_1_1IX_d1-base	;undefined
	dc.w	Res_1_1IX_d1-base
	dc.w	Res_A_1_1IX_d1-base	;undefined
.90	dc.w	Res_B_2_1IX_d1-base	;undefined
	dc.w	Res_C_2_1IX_d1-base	;undefined
	dc.w	Res_D_2_1IX_d1-base	;undefined
	dc.w	Res_E_2_1IX_d1-base	;undefined
	dc.w	Res_H_2_1IX_d1-base	;undefined
	dc.w	Res_L_2_1IX_d1-base	;undefined
	dc.w	Res_2_1IX_d1-base
	dc.w	Res_A_2_1IX_d1-base	;undefined
	dc.w	Res_B_3_1IX_d1-base	;undefined
	dc.w	Res_C_3_1IX_d1-base	;undefined
	dc.w	Res_D_3_1IX_d1-base	;undefined
	dc.w	Res_E_3_1IX_d1-base	;undefined
	dc.w	Res_H_3_1IX_d1-base	;undefined
	dc.w	Res_L_3_1IX_d1-base	;undefined
	dc.w	Res_3_1IX_d1-base
	dc.w	Res_A_3_1IX_d1-base	;undefined
.A0	dc.w	Res_B_4_1IX_d1-base	;undefined
	dc.w	Res_C_4_1IX_d1-base	;undefined
	dc.w	Res_D_4_1IX_d1-base	;undefined
	dc.w	Res_E_4_1IX_d1-base	;undefined
	dc.w	Res_H_4_1IX_d1-base	;undefined
	dc.w	Res_L_4_1IX_d1-base	;undefined
	dc.w	Res_4_1IX_d1-base
	dc.w	Res_A_4_1IX_d1-base	;undefined
	dc.w	Res_B_5_1IX_d1-base	;undefined
	dc.w	Res_C_5_1IX_d1-base	;undefined
	dc.w	Res_D_5_1IX_d1-base	;undefined
	dc.w	Res_E_5_1IX_d1-base	;undefined
	dc.w	Res_H_5_1IX_d1-base	;undefined
	dc.w	Res_L_5_1IX_d1-base	;undefined
	dc.w	Res_5_1IX_d1-base
	dc.w	Res_A_5_1IX_d1-base	;undefined
.B0	dc.w	Res_B_6_1IX_d1-base	;undefined
	dc.w	Res_C_6_1IX_d1-base	;undefined
	dc.w	Res_D_6_1IX_d1-base	;undefined
	dc.w	Res_E_6_1IX_d1-base	;undefined
	dc.w	Res_H_6_1IX_d1-base	;undefined
	dc.w	Res_L_6_1IX_d1-base	;undefined
	dc.w	Res_6_1IX_d1-base
	dc.w	Res_A_6_1IX_d1-base	;undefined
	dc.w	Res_B_7_1IX_d1-base	;undefined
	dc.w	Res_C_7_1IX_d1-base	;undefined
	dc.w	Res_D_7_1IX_d1-base	;undefined
	dc.w	Res_E_7_1IX_d1-base	;undefined
	dc.w	Res_H_7_1IX_d1-base	;undefined
	dc.w	Res_L_7_1IX_d1-base	;undefined
	dc.w	Res_7_1IX_d1-base
	dc.w	Res_A_7_1IX_d1-base	;undefined
.C0	dc.w	Set_B_0_1IX_d1-base	;undefined
	dc.w	Set_C_0_1IX_d1-base	;undefined
	dc.w	Set_D_0_1IX_d1-base	;undefined
	dc.w	Set_E_0_1IX_d1-base	;undefined
	dc.w	Set_H_0_1IX_d1-base	;undefined
	dc.w	Set_L_0_1IX_d1-base	;undefined
	dc.w	Set_0_1IX_d1-base
	dc.w	Set_A_0_1IX_d1-base	;undefined
	dc.w	Set_B_1_1IX_d1-base	;undefined
	dc.w	Set_C_1_1IX_d1-base	;undefined
	dc.w	Set_D_1_1IX_d1-base	;undefined
	dc.w	Set_E_1_1IX_d1-base	;undefined
	dc.w	Set_H_1_1IX_d1-base	;undefined
	dc.w	Set_L_1_1IX_d1-base	;undefined
	dc.w	Set_1_1IX_d1-base
	dc.w	Set_A_1_1IX_d1-base	;undefined
.D0	dc.w	Set_B_2_1IX_d1-base	;undefined
	dc.w	Set_C_2_1IX_d1-base	;undefined
	dc.w	Set_D_2_1IX_d1-base	;undefined
	dc.w	Set_E_2_1IX_d1-base	;undefined
	dc.w	Set_H_2_1IX_d1-base	;undefined
	dc.w	Set_L_2_1IX_d1-base	;undefined
	dc.w	Set_2_1IX_d1-base
	dc.w	Set_A_2_1IX_d1-base	;undefined
	dc.w	Set_B_3_1IX_d1-base	;undefined
	dc.w	Set_C_3_1IX_d1-base	;undefined
	dc.w	Set_D_3_1IX_d1-base	;undefined
	dc.w	Set_E_3_1IX_d1-base	;undefined
	dc.w	Set_H_3_1IX_d1-base	;undefined
	dc.w	Set_L_3_1IX_d1-base	;undefined
	dc.w	Set_3_1IX_d1-base
	dc.w	Set_A_3_1IX_d1-base	;undefined
.E0	dc.w	Set_B_4_1IX_d1-base	;undefined
	dc.w	Set_C_4_1IX_d1-base	;undefined
	dc.w	Set_D_4_1IX_d1-base	;undefined
	dc.w	Set_E_4_1IX_d1-base	;undefined
	dc.w	Set_H_4_1IX_d1-base	;undefined
	dc.w	Set_L_4_1IX_d1-base	;undefined
	dc.w	Set_4_1IX_d1-base
	dc.w	Set_A_4_1IX_d1-base	;undefined
	dc.w	Set_B_5_1IX_d1-base	;undefined
	dc.w	Set_C_5_1IX_d1-base	;undefined
	dc.w	Set_D_5_1IX_d1-base	;undefined
	dc.w	Set_E_5_1IX_d1-base	;undefined
	dc.w	Set_H_5_1IX_d1-base	;undefined
	dc.w	Set_L_5_1IX_d1-base	;undefined
	dc.w	Set_5_1IX_d1-base
	dc.w	Set_A_5_1IX_d1-base	;undefined
.F0	dc.w	Set_B_6_1IX_d1-base	;undefined
	dc.w	Set_C_6_1IX_d1-base	;undefined
	dc.w	Set_D_6_1IX_d1-base	;undefined
	dc.w	Set_E_6_1IX_d1-base	;undefined
	dc.w	Set_H_6_1IX_d1-base	;undefined
	dc.w	Set_L_6_1IX_d1-base	;undefined
	dc.w	Set_6_1IX_d1-base
	dc.w	Set_A_6_1IX_d1-base	;undefined
	dc.w	Set_B_7_1IX_d1-base	;undefined
	dc.w	Set_C_7_1IX_d1-base	;undefined
	dc.w	Set_D_7_1IX_d1-base	;undefined
	dc.w	Set_E_7_1IX_d1-base	;undefined
	dc.w	Set_H_7_1IX_d1-base	;undefined
	dc.w	Set_L_7_1IX_d1-base	;undefined
	dc.w	Set_7_1IX_d1-base
	dc.w	Set_A_7_1IX_d1-base	;undefined

** -------------------------------

** If an FD-prefix has been found:

FDdecode	cmp.w	#out_of_bounds,(PPC)    ;test 2nd word
		bne.s	.not_oob
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		getz	d7,d7	;get 2nd byte
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	FDoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,(PPC)
		jmp	(InstrB,d7.w)

FDoffsets
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_IY_BC-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.10	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_IY_DE-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.20	dc.w	undef
	dc.w	Ld_IY_nn-base
	dc.w	Ld_1nn1_IY-base
	dc.w	Inc_IY-base
	dc.w	Inc_YH-base	;undocumented
	dc.w	Dec_YH-base	;undocumented
	dc.w	Ld_YH_n-base	;undocumented
	dc.w	undef
	dc.w	undef
	dc.w	Add_IY_IY-base
	dc.w	Ld_IY_1nn1-base
	dc.w	Dec_IY-base
	dc.w	Inc_YL-base	;undocumented
	dc.w	Dec_YL-base	;undocumented
	dc.w	Ld_YL_n-base	;undocumented
	dc.w	undef
.30	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Inc_1IY_d1-base
	dc.w	Dec_1IY_d1-base
	dc.w	Ld_1IY_d1_n-base
	dc.w	undef
	dc.w	undef
	dc.w	Add_IY_SP-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.40	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_B_YH-base	;undocumented
	dc.w	Ld_B_YL-base	;undocumented
	dc.w	Ld_B_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_C_YH-base	;undocumented
	dc.w	Ld_C_YL-base	;undocumented
	dc.w	Ld_C_1IY_d1-base
	dc.w	undef
.50	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_D_YH-base	;undocumented
	dc.w	Ld_D_YL-base	;undocumented
	dc.w	Ld_D_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_E_YH-base	;undocumented
	dc.w	Ld_E_YL-base	;undocumented
	dc.w	Ld_E_1IY_d1-base
	dc.w	undef
.60	dc.w	Ld_YH_B-base	;undocumented
	dc.w	Ld_YH_C-base	;undocumented
	dc.w	Ld_YH_D-base	;undocumented
	dc.w	Ld_YH_E-base	;undocumented
	dc.w	Ld_YH_YH-base	;undocumented
	dc.w	Ld_YH_YL-base	;undocumented
	dc.w	Ld_H_1IY_d1-base
	dc.w	Ld_YH_A-base	;undocumented
	dc.w	Ld_YL_B-base	;undocumented
	dc.w	Ld_YL_C-base	;undocumented
	dc.w	Ld_YL_D-base	;undocumented
	dc.w	Ld_YL_E-base	;undocumented
	dc.w	Ld_YL_YH-base	;undocumented
	dc.w	Ld_YL_YL-base	;undocumented
	dc.w	Ld_L_1IY_d1-base
	dc.w	Ld_YL_A-base	;undocumented
.70	dc.w	Ld_1IY_d1_B-base
	dc.w	Ld_1IY_d1_C-base
	dc.w	Ld_1IY_d1_D-base
	dc.w	Ld_1IY_d1_E-base
	dc.w	Ld_1IY_d1_H-base
	dc.w	Ld_1IY_d1_L-base
	dc.w	undef
	dc.w	Ld_1IY_d1_A-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_A_YH-base	;undocumented
	dc.w	Ld_A_YL-base	;undocumented
	dc.w	Ld_A_1IY_d1-base
	dc.w	undef
.80	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Add_A_YH-base	;undocumented
	dc.w	Add_A_YL-base	;undocumented
	dc.w	Add_A_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Adc_A_YH-base	;undocumented
	dc.w	Adc_A_YL-base	;undocumented
	dc.w	Adc_A_1IY_d1-base
	dc.w	undef
.90	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Sub_YH-base	;undocumented
	dc.w	Sub_YL-base	;undocumented
	dc.w	Sub_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Sbc_A_YH-base	;undocumented
	dc.w	Sbc_A_YL-base	;undocumented
	dc.w	Sbc_A_1IY_d1-base
	dc.w	undef
.A0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	And_YH-base	;undocumented
	dc.w	And_YL-base	;undocumented
	dc.w	And_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Xor_YH-base	;undocumented
	dc.w	Xor_YL-base	;undocumented
	dc.w	Xor_1IY_d1-base
	dc.w	undef
.B0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Or_YH-base	;undocumented
	dc.w	Or_YL-base	;undocumented
	dc.w	Or_1IY_d1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Cp_YH-base	;undocumented
	dc.w	Cp_YL-base	;undocumented
	dc.w	Cp_1IY_d1-base
	dc.w	undef
.C0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	FDCBdecode-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.D0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.E0	dc.w	undef
	dc.w	Pop_IY-base
	dc.w	undef
	dc.w	Ex_1SP1_IY-base
	dc.w	undef
	dc.w	Push_IY-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Jp_1IY1-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
.F0	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	Ld_SP_IY-base
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef
	dc.w	undef

** -------------------------------

** If a FDCB sequence has been found:
** Remember: FD CB offset opcode. PPC points to CB. CB is marked as
**           unchanged.

FDCBdecode	cmp.w	#out_of_bounds,4(PPC)    ;test 4th word
		bne.s	.not_oob
		clr.w	(PPC)	;remove 'unchanged' marker from CB
		jmp	go_low_buf(InstrB)
.not_oob
		getRPC
		addq.w	#2,d7	;get 4th byte
		getz	d7,d7
		and.w	#$00ff,d7
		add.w	d7,d7
		move.w	FDCBoffsets(PC,d7.w),d7
		move.w	d7,-2(PPC)
		move.w	#unchanged,4(PPC)
		jmp	(InstrB,d7.w)

FDCBoffsets
	dc.w	Rlc_B_1IY_d1-base	;undocumented
	dc.w	Rlc_C_1IY_d1-base	;undocumented
	dc.w	Rlc_D_1IY_d1-base	;undocumented
	dc.w	Rlc_E_1IY_d1-base	;undocumented
	dc.w	Rlc_H_1IY_d1-base	;undocumented
	dc.w	Rlc_L_1IY_d1-base	;undocumented
	dc.w	Rlc_1IY_d1-base
	dc.w	Rlc_A_1IY_d1-base	;undocumented
	dc.w	Rrc_B_1IY_d1-base	;undocumented
	dc.w	Rrc_C_1IY_d1-base	;undocumented
	dc.w	Rrc_D_1IY_d1-base	;undocumented
	dc.w	Rrc_E_1IY_d1-base	;undocumented
	dc.w	Rrc_H_1IY_d1-base	;undocumented
	dc.w	Rrc_L_1IY_d1-base	;undocumented
	dc.w	Rrc_1IY_d1-base
	dc.w	Rrc_A_1IY_d1-base	;undocumented
.10	dc.w	Rl_B_1IY_d1-base	;undocumented
	dc.w	Rl_C_1IY_d1-base	;undocumented
	dc.w	Rl_D_1IY_d1-base	;undocumented
	dc.w	Rl_E_1IY_d1-base	;undocumented
	dc.w	Rl_H_1IY_d1-base	;undocumented
	dc.w	Rl_L_1IY_d1-base	;undocumented
	dc.w	Rl_1IY_d1-base
	dc.w	Rl_A_1IY_d1-base	;undocumented
	dc.w	Rr_B_1IY_d1-base	;undocumented
	dc.w	Rr_C_1IY_d1-base	;undocumented
	dc.w	Rr_D_1IY_d1-base	;undocumented
	dc.w	Rr_E_1IY_d1-base	;undocumented
	dc.w	Rr_H_1IY_d1-base	;undocumented
	dc.w	Rr_L_1IY_d1-base	;undocumented
	dc.w	Rr_1IY_d1-base
	dc.w	Rr_A_1IY_d1-base	;undocumented
.20	dc.w	Sla_B_1IY_d1-base	;undocumented
	dc.w	Sla_C_1IY_d1-base	;undocumented
	dc.w	Sla_D_1IY_d1-base	;undocumented
	dc.w	Sla_E_1IY_d1-base	;undocumented
	dc.w	Sla_H_1IY_d1-base	;undocumented
	dc.w	Sla_L_1IY_d1-base	;undocumented
	dc.w	Sla_1IY_d1-base
	dc.w	Sla_A_1IY_d1-base	;undocumented
	dc.w	Sra_B_1IY_d1-base	;undocumented
	dc.w	Sra_C_1IY_d1-base	;undocumented
	dc.w	Sra_D_1IY_d1-base	;undocumented
	dc.w	Sra_E_1IY_d1-base	;undocumented
	dc.w	Sra_H_1IY_d1-base	;undocumented
	dc.w	Sra_L_1IY_d1-base	;undocumented
	dc.w	Sra_1IY_d1-base
	dc.w	Sra_A_1IY_d1-base	;undocumented
.30	dc.w	Sll_B_1IY_d1-base	;undocumented
	dc.w	Sll_C_1IY_d1-base	;undocumented
	dc.w	Sll_D_1IY_d1-base	;undocumented
	dc.w	Sll_E_1IY_d1-base	;undocumented
	dc.w	Sll_H_1IY_d1-base	;undocumented
	dc.w	Sll_L_1IY_d1-base	;undocumented
	dc.w	Sll_1IY_d1-base		;undocumented
	dc.w	Sll_A_1IY_d1-base	;undocumented
	dc.w	Srl_B_1IY_d1-base	;undocumented
	dc.w	Srl_C_1IY_d1-base	;undocumented
	dc.w	Srl_D_1IY_d1-base	;undocumented
	dc.w	Srl_E_1IY_d1-base	;undocumented
	dc.w	Srl_H_1IY_d1-base	;undocumented
	dc.w	Srl_L_1IY_d1-base	;undocumented
	dc.w	Srl_1IY_d1-base
	dc.w	Srl_A_1IY_d1-base	;undocumented
.40	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_0_1IY_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_1_1IY_d1-base
	dc.w	undef_3byte
.50	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_2_1IY_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_3_1IY_d1-base
	dc.w	undef_3byte
.60	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_4_1IY_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_5_1IY_d1-base
	dc.w	undef_3byte
.70	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_6_1IY_d1-base
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	undef_3byte
	dc.w	Bit_7_1IY_d1-base
	dc.w	undef_3byte
.80	dc.w	Res_B_0_1IY_d1-base	;undefined
	dc.w	Res_C_0_1IY_d1-base	;undefined
	dc.w	Res_D_0_1IY_d1-base	;undefined
	dc.w	Res_E_0_1IY_d1-base	;undefined
	dc.w	Res_H_0_1IY_d1-base	;undefined
	dc.w	Res_L_0_1IY_d1-base	;undefined
	dc.w	Res_0_1IY_d1-base
	dc.w	Res_A_0_1IY_d1-base	;undefined
	dc.w	Res_B_1_1IY_d1-base	;undefined
	dc.w	Res_C_1_1IY_d1-base	;undefined
	dc.w	Res_D_1_1IY_d1-base	;undefined
	dc.w	Res_E_1_1IY_d1-base	;undefined
	dc.w	Res_H_1_1IY_d1-base	;undefined
	dc.w	Res_L_1_1IY_d1-base	;undefined
	dc.w	Res_1_1IY_d1-base
	dc.w	Res_A_1_1IY_d1-base	;undefined
.90	dc.w	Res_B_2_1IY_d1-base	;undefined
	dc.w	Res_C_2_1IY_d1-base	;undefined
	dc.w	Res_D_2_1IY_d1-base	;undefined
	dc.w	Res_E_2_1IY_d1-base	;undefined
	dc.w	Res_H_2_1IY_d1-base	;undefined
	dc.w	Res_L_2_1IY_d1-base	;undefined
	dc.w	Res_2_1IY_d1-base
	dc.w	Res_A_2_1IY_d1-base	;undefined
	dc.w	Res_B_3_1IY_d1-base	;undefined
	dc.w	Res_C_3_1IY_d1-base	;undefined
	dc.w	Res_D_3_1IY_d1-base	;undefined
	dc.w	Res_E_3_1IY_d1-base	;undefined
	dc.w	Res_H_3_1IY_d1-base	;undefined
	dc.w	Res_L_3_1IY_d1-base	;undefined
	dc.w	Res_3_1IY_d1-base
	dc.w	Res_A_3_1IY_d1-base	;undefined
.A0	dc.w	Res_B_4_1IY_d1-base	;undefined
	dc.w	Res_C_4_1IY_d1-base	;undefined
	dc.w	Res_D_4_1IY_d1-base	;undefined
	dc.w	Res_E_4_1IY_d1-base	;undefined
	dc.w	Res_H_4_1IY_d1-base	;undefined
	dc.w	Res_L_4_1IY_d1-base	;undefined
	dc.w	Res_4_1IY_d1-base
	dc.w	Res_A_4_1IY_d1-base	;undefined
	dc.w	Res_B_5_1IY_d1-base	;undefined
	dc.w	Res_C_5_1IY_d1-base	;undefined
	dc.w	Res_D_5_1IY_d1-base	;undefined
	dc.w	Res_E_5_1IY_d1-base	;undefined
	dc.w	Res_H_5_1IY_d1-base	;undefined
	dc.w	Res_L_5_1IY_d1-base	;undefined
	dc.w	Res_5_1IY_d1-base
	dc.w	Res_A_5_1IY_d1-base	;undefined
.B0	dc.w	Res_B_6_1IY_d1-base	;undefined
	dc.w	Res_C_6_1IY_d1-base	;undefined
	dc.w	Res_D_6_1IY_d1-base	;undefined
	dc.w	Res_E_6_1IY_d1-base	;undefined
	dc.w	Res_H_6_1IY_d1-base	;undefined
	dc.w	Res_L_6_1IY_d1-base	;undefined
	dc.w	Res_6_1IY_d1-base
	dc.w	Res_A_6_1IY_d1-base	;undefined
	dc.w	Res_B_7_1IY_d1-base	;undefined
	dc.w	Res_C_7_1IY_d1-base	;undefined
	dc.w	Res_D_7_1IY_d1-base	;undefined
	dc.w	Res_E_7_1IY_d1-base	;undefined
	dc.w	Res_H_7_1IY_d1-base	;undefined
	dc.w	Res_L_7_1IY_d1-base	;undefined
	dc.w	Res_7_1IY_d1-base
	dc.w	Res_A_7_1IY_d1-base	;undefined
.C0	dc.w	Set_B_0_1IY_d1-base	;undefined
	dc.w	Set_C_0_1IY_d1-base	;undefined
	dc.w	Set_D_0_1IY_d1-base	;undefined
	dc.w	Set_E_0_1IY_d1-base	;undefined
	dc.w	Set_H_0_1IY_d1-base	;undefined
	dc.w	Set_L_0_1IY_d1-base	;undefined
	dc.w	Set_0_1IY_d1-base
	dc.w	Set_A_0_1IY_d1-base	;undefined
	dc.w	Set_B_1_1IY_d1-base	;undefined
	dc.w	Set_C_1_1IY_d1-base	;undefined
	dc.w	Set_D_1_1IY_d1-base	;undefined
	dc.w	Set_E_1_1IY_d1-base	;undefined
	dc.w	Set_H_1_1IY_d1-base	;undefined
	dc.w	Set_L_1_1IY_d1-base	;undefined
	dc.w	Set_1_1IY_d1-base
	dc.w	Set_A_1_1IY_d1-base	;undefined
.D0	dc.w	Set_B_2_1IY_d1-base	;undefined
	dc.w	Set_C_2_1IY_d1-base	;undefined
	dc.w	Set_D_2_1IY_d1-base	;undefined
	dc.w	Set_E_2_1IY_d1-base	;undefined
	dc.w	Set_H_2_1IY_d1-base	;undefined
	dc.w	Set_L_2_1IY_d1-base	;undefined
	dc.w	Set_2_1IY_d1-base
	dc.w	Set_A_2_1IY_d1-base	;undefined
	dc.w	Set_B_3_1IY_d1-base	;undefined
	dc.w	Set_C_3_1IY_d1-base	;undefined
	dc.w	Set_D_3_1IY_d1-base	;undefined
	dc.w	Set_E_3_1IY_d1-base	;undefined
	dc.w	Set_H_3_1IY_d1-base	;undefined
	dc.w	Set_L_3_1IY_d1-base	;undefined
	dc.w	Set_3_1IY_d1-base
	dc.w	Set_A_3_1IY_d1-base	;undefined
.E0	dc.w	Set_B_4_1IY_d1-base	;undefined
	dc.w	Set_C_4_1IY_d1-base	;undefined
	dc.w	Set_D_4_1IY_d1-base	;undefined
	dc.w	Set_E_4_1IY_d1-base	;undefined
	dc.w	Set_H_4_1IY_d1-base	;undefined
	dc.w	Set_L_4_1IY_d1-base	;undefined
	dc.w	Set_4_1IY_d1-base
	dc.w	Set_A_4_1IY_d1-base	;undefined
	dc.w	Set_B_5_1IY_d1-base	;undefined
	dc.w	Set_C_5_1IY_d1-base	;undefined
	dc.w	Set_D_5_1IY_d1-base	;undefined
	dc.w	Set_E_5_1IY_d1-base	;undefined
	dc.w	Set_H_5_1IY_d1-base	;undefined
	dc.w	Set_L_5_1IY_d1-base	;undefined
	dc.w	Set_5_1IY_d1-base
	dc.w	Set_A_5_1IY_d1-base	;undefined
.F0	dc.w	Set_B_6_1IY_d1-base	;undefined
	dc.w	Set_C_6_1IY_d1-base	;undefined
	dc.w	Set_D_6_1IY_d1-base	;undefined
	dc.w	Set_E_6_1IY_d1-base	;undefined
	dc.w	Set_H_6_1IY_d1-base	;undefined
	dc.w	Set_L_6_1IY_d1-base	;undefined
	dc.w	Set_6_1IY_d1-base
	dc.w	Set_A_6_1IY_d1-base	;undefined
	dc.w	Set_B_7_1IY_d1-base	;undefined
	dc.w	Set_C_7_1IY_d1-base	;undefined
	dc.w	Set_D_7_1IY_d1-base	;undefined
	dc.w	Set_E_7_1IY_d1-base	;undefined
	dc.w	Set_H_7_1IY_d1-base	;undefined
	dc.w	Set_L_7_1IY_d1-base	;undefined
	dc.w	Set_7_1IY_d1-base
	dc.w	Set_A_7_1IY_d1-base	;undefined

** =====================================================================
