** The offset table for the unprefixed Z80 instructions

** Following opcodes exactly follow Zaks' "Programming the Z80"

** 	n  = 8-bit number
** 	nn = 16-bit number
** 	e  = 8-bit relative jump offset
** 	d  = 8-bit displacement
** 	pq = 16-bit address
** 	p  = 8-bit address

**  Label notation:	Underscore used for SPACE, comma and +

** 			1 (one) used for ( and )

** =======================================

	IFD VERBOSE
	LIST
** Compiling the std_offsets.i file.
	NOLIST
	ENDC

offsets
	dc.w	Nop-base
	dc.w	Ld_BC_nn-base
	dc.w	Ld_1BC1_A-base
	dc.w	Inc_BC-base
	dc.w	Inc_B-base
	dc.w	Dec_B-base
	dc.w	Ld_B_n-base
	dc.w	Rlca-base
	dc.w	Ex_AF_AF-base
	dc.w	Add_HL_BC-base
	dc.w	Ld_A_1BC1-base
	dc.w	Dec_BC-base
	dc.w	Inc_C-base
	dc.w	Dec_C-base
	dc.w	Ld_C_n-base
	dc.w	Rrca-base
.10	dc.w	Djnz_e-base
	dc.w	Ld_DE_nn-base
	dc.w	Ld_1DE1_A-base
	dc.w	Inc_DE-base
	dc.w	Inc_D-base
	dc.w	Dec_D-base
	dc.w	Ld_D_n-base
	dc.w	Rla-base
	dc.w	Jr_e-base
	dc.w	Add_HL_DE-base
	dc.w	Ld_A_1DE1-base
	dc.w	Dec_DE-base
	dc.w	Inc_E-base
	dc.w	Dec_E-base
	dc.w	Ld_E_n-base
	dc.w	Rra-base
.20	dc.w	Jr_NZ_e-base
	dc.w	Ld_HL_nn-base
	dc.w	Ld_1nn1_HL-base
	dc.w	Inc_HL-base
	dc.w	Inc_H-base
	dc.w	Dec_H-base
	dc.w	Ld_H_n-base
	dc.w	Daa-base
	dc.w	Jr_Z_e-base
	dc.w	Add_HL_HL-base
	dc.w	Ld_HL_1nn1-base
	dc.w	Dec_HL-base
	dc.w	Inc_L-base
	dc.w	Dec_L-base
	dc.w	Ld_L_n-base
	dc.w	Cpl-base
.30	dc.w	Jr_NC_e-base
	dc.w	Ld_SP_nn-base
	dc.w	Ld_1nn1_A-base
	dc.w	Inc_SP-base
	dc.w	Inc_1HL1-base
	dc.w	Dec_1HL1-base
	dc.w	Ld_1HL1_n-base
	dc.w	Scf-base
	dc.w	Jr_C_e-base
	dc.w	Add_HL_SP-base
	dc.w	Ld_A_1nn1-base
	dc.w	Dec_SP-base
	dc.w	Inc_A-base
	dc.w	Dec_A-base
	dc.w	Ld_A_n-base
	dc.w	Ccf-base
.40	dc.w	Ld_B_B-base
	dc.w	Ld_B_C-base
	dc.w	Ld_B_D-base
	dc.w	Ld_B_E-base
	dc.w	Ld_B_H-base
	dc.w	Ld_B_L-base
	dc.w	Ld_B_1HL1-base
	dc.w	Ld_B_A-base
	dc.w	Ld_C_B-base
	dc.w	Ld_C_C-base
	dc.w	Ld_C_D-base
	dc.w	Ld_C_E-base
	dc.w	Ld_C_H-base
	dc.w	Ld_C_L-base
	dc.w	Ld_C_1HL1-base
	dc.w	Ld_C_A-base
.50	dc.w	Ld_D_B-base
	dc.w	Ld_D_C-base
	dc.w	Ld_D_D-base
	dc.w	Ld_D_E-base
	dc.w	Ld_D_H-base
	dc.w	Ld_D_L-base
	dc.w	Ld_D_1HL1-base
	dc.w	Ld_D_A-base
	dc.w	Ld_E_B-base
	dc.w	Ld_E_C-base
	dc.w	Ld_E_D-base
	dc.w	Ld_E_E-base
	dc.w	Ld_E_H-base
	dc.w	Ld_E_L-base
	dc.w	Ld_E_1HL1-base
	dc.w	Ld_E_A-base
.60	dc.w	Ld_H_B-base
	dc.w	Ld_H_C-base
	dc.w	Ld_H_D-base
	dc.w	Ld_H_E-base
	dc.w	Ld_H_H-base
	dc.w	Ld_H_L-base
	dc.w	Ld_H_1HL1-base
	dc.w	Ld_H_A-base
	dc.w	Ld_L_B-base
	dc.w	Ld_L_C-base
	dc.w	Ld_L_D-base
	dc.w	Ld_L_E-base
	dc.w	Ld_L_H-base
	dc.w	Ld_L_L-base
	dc.w	Ld_L_1HL1-base
	dc.w	Ld_L_A-base
.70	dc.w	Ld_1HL1_B-base
	dc.w	Ld_1HL1_C-base
	dc.w	Ld_1HL1_D-base
	dc.w	Ld_1HL1_E-base
	dc.w	Ld_1HL1_H-base
	dc.w	Ld_1HL1_L-base
	dc.w	Halt-base
	dc.w	Ld_1HL1_A-base
	dc.w	Ld_A_B-base
	dc.w	Ld_A_C-base
	dc.w	Ld_A_D-base
	dc.w	Ld_A_E-base
	dc.w	Ld_A_H-base
	dc.w	Ld_A_L-base
	dc.w	Ld_A_1HL1-base
	dc.w	Ld_A_A-base
.80	dc.w	Add_A_B-base
	dc.w	Add_A_C-base
	dc.w	Add_A_D-base
	dc.w	Add_A_E-base
	dc.w	Add_A_H-base
	dc.w	Add_A_L-base
	dc.w	Add_A_1HL1-base
	dc.w	Add_A_A-base
	dc.w	Adc_A_B-base
	dc.w	Adc_A_C-base
	dc.w	Adc_A_D-base
	dc.w	Adc_A_E-base
	dc.w	Adc_A_H-base
	dc.w	Adc_A_L-base
	dc.w	Adc_A_1HL1-base
	dc.w	Adc_A_A-base
.90	dc.w	Sub_B-base
	dc.w	Sub_C-base
	dc.w	Sub_D-base
	dc.w	Sub_E-base
	dc.w	Sub_H-base
	dc.w	Sub_L-base
	dc.w	Sub_1HL1-base
	dc.w	Sub_A-base
	dc.w	Sbc_A_B-base
	dc.w	Sbc_A_C-base
	dc.w	Sbc_A_D-base
	dc.w	Sbc_A_E-base
	dc.w	Sbc_A_H-base
	dc.w	Sbc_A_L-base
	dc.w	Sbc_A_1HL1-base
	dc.w	Sbc_A_A-base
.A0	dc.w	And_B-base
	dc.w	And_C-base
	dc.w	And_D-base
	dc.w	And_E-base
	dc.w	And_H-base
	dc.w	And_L-base
	dc.w	And_1HL1-base
	dc.w	And_A-base
	dc.w	Xor_B-base
	dc.w	Xor_C-base
	dc.w	Xor_D-base
	dc.w	Xor_E-base
	dc.w	Xor_H-base
	dc.w	Xor_L-base
	dc.w	Xor_1HL1-base
	dc.w	Xor_A-base
.B0	dc.w	Or_B-base
	dc.w	Or_C-base
	dc.w	Or_D-base
	dc.w	Or_E-base
	dc.w	Or_H-base
	dc.w	Or_L-base
	dc.w	Or_1HL1-base
	dc.w	Or_A-base
	dc.w	Cp_B-base
	dc.w	Cp_C-base
	dc.w	Cp_D-base
	dc.w	Cp_E-base
	dc.w	Cp_H-base
	dc.w	Cp_L-base
	dc.w	Cp_1HL1-base
	dc.w	Cp_A-base
.C0	dc.w	Ret_NZ-base
	dc.w	Pop_BC-base
	dc.w	Jp_NZ_pq-base
	dc.w	Jp_pq-base
	dc.w	Call_NZ_pq-base
	dc.w	Push_BC-base
	dc.w	Add_A_n-base
	dc.w	Rst_0-base
	dc.w	Ret_Z-base
	dc.w	Ret-base
	dc.w	Jp_Z_pq-base
	dc.w	CBdecode-base
	dc.w	Call_Z_pq-base
	dc.w	Call_pq-base
	dc.w	Adc_A_n-base
	dc.w	Rst_8-base
.D0	dc.w	Ret_NC-base
	dc.w	Pop_DE-base
	dc.w	Jp_NC_pq-base
	dc.w	Out_1n1_A-base
	dc.w	Call_NC_pq-base
	dc.w	Push_DE-base
	dc.w	Sub_n-base
	dc.w	Rst_16-base
	dc.w	Ret_C-base
	dc.w	Exx-base
	dc.w	Jp_C_pq-base
	dc.w	In_A_1n1-base
	dc.w	Call_C_pq-base
	dc.w	DDdecode-base
	dc.w	Sbc_A_n-base
	dc.w	Rst_24-base
.E0	dc.w	Ret_PO-base
	dc.w	Pop_HL-base
	dc.w	Jp_PO_pq-base
	dc.w	Ex_1SP1_HL-base
	dc.w	Call_PO_pq-base
	dc.w	Push_HL-base
	dc.w	And_n-base
	dc.w	Rst_32-base
	dc.w	Ret_PE-base
	dc.w	Jp_1HL1-base
	dc.w	Jp_PE_pq-base
	dc.w	Ex_DE_HL-base
	dc.w	Call_PE_pq-base
	dc.w	EDdecode-base
	dc.w	Xor_n-base
	dc.w	Rst_40-base
.F0	dc.w	Ret_P-base
	dc.w	Pop_AF-base
	dc.w	Jp_P_pq-base
	dc.w	Di-base
	dc.w	Call_P_pq-base
	dc.w	Push_AF-base
	dc.w	Or_n-base
	dc.w	Rst_48-base
	dc.w	Ret_M-base
	dc.w	Ld_SP_HL-base
	dc.w	Jp_M_pq-base
	dc.w	Ei-base
	dc.w	Call_M_pq-base
	dc.w	FDdecode-base
	dc.w	Cp_n-base
	dc.w	Rst_56-base

** =======================================
