
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <exec/lists.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <graphics/rastport.h>
#include <graphics/gfxmacros.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/layers.h>
#include <proto/utility.h>
#include <proto/asl.h>
#include <proto/diskfont.h>

#include "plotgui.h"

#define NT_DATA 250;

int OpenGTXScreen( void );

int OpenGTXWindow(int (* )());

BOOL rhp_Args(UBYTE *, UBYTE *);
BOOL rhp(UBYTE *, LONG);

struct TextFont *OpencPFont( void );

void Death(int);

struct Point {
     struct Point *NextPoint;
     float  xval;
     float  yval;
};

struct Set {
     struct Node snode;
     struct Point *FirstPoint;
     char  fn[255];
     int    npt;
     float  xmin;
     float  xmax;
     float  ymin;
     float  ymax;
};

struct World {
     double xdelta;
     double ydelta;
     double xmax;
     double xmin;
     double ymax;
     double ymin;
};

struct CurView {
     double xmax;
     double xmin;
     double ymax;
     double ymin;
     double xdelta;
     double ydelta;
     double xtik;
     double ytik;
     WORD xsubt;
     WORD ysubt;
     BOOL xmode;
     BOOL ymode;
     WORD xprec;
     WORD yprec;
     double xfact;
     double yfact;
     LONG xdec;
     LONG ydec;
};

extern struct World wd;
extern struct CurView cv;
extern struct List *SetList;
extern struct TextAttr *cPFont;
extern struct TextFont *fontPtr;
extern UBYTE *path;
extern struct RastPort *rp;
extern LONG thin;
extern LONG points;
extern BOOL grid;
extern BOOL LOGX;
extern BOOL LOGY;
extern BOOL MONO;
extern BOOL sym;
extern BOOL DEFS;
extern BOOL CPANEL;
extern BOOL NOFNAME;
extern WORD WIDTH;
extern WORD HEIGHT;
extern WORD xoff;
extern WORD yoff;
extern LONG Disp;
extern UWORD SWIDTH;
extern UWORD SHEIGHT;
extern WORD GADHEIGHT;
extern WORD GADWIDTH;
extern WORD lastcolor;
extern WORD depth;

BOOL AddSet( UBYTE * );

BPTR OpenFile( UBYTE * );

struct Point *File2Set( BPTR , struct Set * );

void FreePoints(struct Point * );

void FreeAllSets( void );

void DrawView( BOOL );

void FindWorld ( void );

void DrawSet ( struct Point * );

void DrawAllSets ( void );

void SymAllSets ( void );

void SymSet ( struct Point * );

void tik(double vmin, double vmax, double *tick, WORD *nsubt, BOOL *mode, WORD *prec);

void DrawColorBox( WORD, WORD, WORD, WORD, WORD);

WORD DrawFileNameBoxes( WORD);

void Erase( void );

void XAxis( void );
void YAxis( void );
void linXAxis( void );
void linYAxis( void );
void logXAxis( void );
void logYAxis( void );

BOOL AddNewSet( void );

void Zoom( void );

void Grid( void );
void logXGrid( void );
void logYGrid( void );
void linXGrid( void );
void linYGrid( void );

void E2xTen( UBYTE *s);

void Round( double * );

void CalcMode ( double, double *);

void Identify( WORD, WORD , BOOL);

void ticX( double, BOOL);
void ticY( double, BOOL);

LONG ScaleX( float );
LONG ScaleY( float );

double ZoomX( WORD );
double ZoomY( WORD );

LONG linX( float );
LONG linY( float );

double linZoomX( WORD );
double linZoomY( WORD );

LONG logX( float );
LONG logY( float );

double logZoomX( WORD );
double logZoomY( WORD );
