/*
 *	Copyright (c) 1993 Michael D. Bayne.
 *	All rights reserved.
 *
 *	Please see the documentation accompanying the distribution for
 *      distribution and disclaimer information.
 */

#include <exec/types.h>
#include <exec/memory.h>

#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <intuition/screens.h>

#include <libraries/gadtools.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/alib_protos.h>
#include <clib/gadtools_protos.h>

#include "Fireworks.h"
#include "Fireworks_rev.h"
#include "/defs.h"

#define	MAX_FIRE 200
#define	MAX_ECLAT 25
#define	MAX_NB	51

struct mPrefObject {
  LONG Number;
  LONG Power;
  LONG Radius;
};

VOID blank( VOID );

struct	mPrefObject	nP;
STATIC	const	UBYTE		VersTag[] = VERSTAG;
extern		ULONG		Depth, Mode, *Blanking;
extern		UBYTE		*prefData;

VOID setFireworksPrefs( VOID )
{
  GT_SetGadgetAttrs( FireworksGadgets[GD_NUMBER], FireworksWnd, 0L, GTSL_Level, nP.Number, 0L );
  GT_SetGadgetAttrs( FireworksGadgets[GD_POWER], FireworksWnd, 0L, GTSL_Level, nP.Power, 0L );
  GT_SetGadgetAttrs( FireworksGadgets[GD_RADIUS], FireworksWnd, 0L, GTSL_Level, nP.Radius, 0L );
}

int OKClicked( VOID )
{
  CopyMem( &nP, prefData, sizeof( struct mPrefObject ));
  return( QUIT );
}

int TESTClicked( VOID )
{
  *Blanking = TRUE;
  blank();
  return( CONTINUE );
}

int CANCELClicked( VOID )
{
  return( QUIT );
}

int NUMBERClicked( VOID )
{
  nP.Number = FireworksMsg.Code;
  return( CONTINUE );
}

int POWERClicked( VOID )
{
  nP.Power = FireworksMsg.Code;
  return( CONTINUE );
}

int RADIUSClicked( VOID )
{
  nP.Radius = FireworksMsg.Code;
  return( CONTINUE );
}

int FireworksVanillaKey( VOID )
{
  switch( FireworksMsg.Code ) {
  case 'o':
    return( OKClicked() );
  case 't':
    return( TESTClicked() );
  case 'c':
    return( CANCELClicked() );
  case 'n':
    GT_SetGadgetAttrs( FireworksGadgets[GD_NUMBER], FireworksWnd, 0L,
		      GTSL_Level, ++(nP.Number) > MAX_NB-1 ?
		      nP.Number = MAX_NB-1 : nP.Number, 0L );
    return( CONTINUE );
  case 'N':
    GT_SetGadgetAttrs( FireworksGadgets[GD_NUMBER], FireworksWnd, 0L,
		      GTSL_Level, --(nP.Number) < 1 ? nP.Number = 1 :
		      nP.Number, 0L );
    return( CONTINUE );
  case 'p':
    GT_SetGadgetAttrs( FireworksGadgets[GD_POWER], FireworksWnd, 0L,
		      GTSL_Level, ++(nP.Power) > 10 ? nP.Power = 10 :
		      nP.Power, 0L );
    return( CONTINUE );
  case 'P':
    GT_SetGadgetAttrs( FireworksGadgets[GD_POWER], FireworksWnd, 0L,
		      GTSL_Level, --(nP.Power) < 1 ? nP.Power = 1 :
		      nP.Power, 0L );
    return( CONTINUE );
  case 'r':
    GT_SetGadgetAttrs( FireworksGadgets[GD_RADIUS], FireworksWnd, 0L,
		      GTSL_Level, ++(nP.Radius) > 10 ? nP.Radius = 10 :
		      nP.Radius, 0L );
    return( CONTINUE );
  case 'R':
    GT_SetGadgetAttrs( FireworksGadgets[GD_RADIUS], FireworksWnd, 0L,
		      GTSL_Level, --(nP.Radius) < 1 ? nP.Radius = 1 :
		      nP.Radius, 0L );
    return( CONTINUE );
  default:
    return( CONTINUE );
  }
  
}

VOID prefs( LONG command )
{
  switch( command ) {
  case STARTUP:
    CopyMem( prefData, &nP, sizeof( struct mPrefObject ));
    if( !SetupScreen() ) {
      if( !OpenFireworksWindow()) setFireworksPrefs();
      CloseDownScreen();
    }
    break;
  case IDCMP:
    if( HandleFireworksIDCMP() != QUIT ) break;
  case KILL:
    CloseFireworksWindow();
  }
}

LONG winSig( VOID )
{
  return( FireworksWnd ? 1L << FireworksWnd->UserPort->mp_SigBit : 0L );
}
