#include <exec/types.h>
#include <intuition/intuition.h>
#include <dos/dos.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/alib_protos.h>

#include "/defs.h"

extern	ULONG	Depth, Mode;

VOID Interference( struct Screen *Scr )
{
	LONG	x, y, factor, mod = ( 1L << Depth ) - 1;
	WORD	Wid = Scr->Width, Hei = Scr->Height;

	ScreenToFront( Scr );

	factor = RangeRand( 20 ) + 1;
	for( y = -Hei / 2 + 1; ( y <= 0 ) && (!( SetSignal( 0L, 0L ) & SIGBREAKF_CTRL_C )); y++ ) {
		for( x = -Wid / 2 + 1; x <= 0; x++ ) {
			SetAPen( &( Scr->RastPort ), (UBYTE)(((( x * x + y * y ) / factor ) % mod ) + 1 ));
			WritePixel( &( Scr->RastPort ), (SHORT)( Wid / 2 - 1 + x ), (SHORT)( Hei / 2 - 1 + y ));
			WritePixel( &( Scr->RastPort ), (SHORT)( Wid / 2 - 1 - x ), (SHORT)( Hei / 2 - 1 + y ));
			WritePixel( &( Scr->RastPort ), (SHORT)( Wid / 2 - 1 + x ), (SHORT)( Hei / 2 - 1 - y ));
			WritePixel( &( Scr->RastPort ), (SHORT)( Wid / 2 - 1 - x ), (SHORT)( Hei / 2 - 1 - y ));
		}
	}

	for( x = 0; x < 400 && (!( SetSignal( 0L, 0L ) & SIGBREAKF_CTRL_C )); x++ ) {
		WaitTOF();
		RainbowPalette( Scr );
	}
}

VOID blank( VOID )
{
	struct Screen *Scr;

	if( Scr = OpenScreenTags( NULL, SA_Depth, Depth, SA_Overscan, OSCAN_STANDARD, SA_DisplayID, Mode, SA_Quiet,
		TRUE, SA_Behind, TRUE, TAG_DONE )) {

		SetRast(&( Scr->RastPort ), 0 );
		RainbowPalette( Scr );
		BlankMousePointer();

		ScreenToFront( Scr );

		while(!( SetSignal( 0L, 0L ) & SIGBREAKF_CTRL_C )) Interference( Scr );

		SetSignal( 0L, SIGBREAKF_CTRL_C );
		UnblankMousePointer();
		RainbowPalette( NULL );
		CloseScreen( Scr );
	}
}
