#include <exec/types.h>
#include <exec/memory.h>

#include <intuition/intuition.h>
#include <intuition/screens.h>

#include <libraries/gadtools.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/alib_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/utility_protos.h>

#include "Plasma.h"
#include "Plasma_rev.h"
#include "/defs.h"
#include "/utility.h"

struct pPrefObject {
  LONG Param;
  LONG WrapAround;
};

VOID blank( VOID );

struct pPrefObject nP;
STATIC const UBYTE VersTag[] = VERSTAG;
extern UBYTE *prefData;
extern ULONG *Blanking;

VOID setPlasmaPrefs( VOID )
{
  GT_SetGadgetAttrs( PlasmaGadgets[GD_PARAM], PlasmaWnd, 0L, GTSL_Level,
		    nP.Param, 0L );
  GT_SetGadgetAttrs( PlasmaGadgets[GD_WRAP], PlasmaWnd, 0L, GTCY_Active,
		    nP.WrapAround, 0L );
}

int OKClicked( VOID )
{
  CopyMem( &nP, prefData, sizeof( struct pPrefObject ));
  return( QUIT );
}

int TESTClicked( VOID )
{
  *Blanking = TRUE;
  blank();
  return( CONTINUE );
}

int CANCELClicked( VOID )
{
  return( QUIT );
}

int PARAMClicked( VOID )
{
  nP.Param = PlasmaMsg.Code;
  return( CONTINUE );
}

int WRAPClicked( VOID )
{
  nP.WrapAround = PlasmaMsg.Code;
  return( CONTINUE );
}

int PlasmaVanillaKey( VOID )
{
  switch( PlasmaMsg.Code ) {
  case 'o':
    return( OKClicked() );
  case 'c':
    return( CANCELClicked() );
  case 'p':
    GT_SetGadgetAttrs( PlasmaGadgets[GD_PARAM], PlasmaWnd, 0L, GTSL_Level, 
		      ++(nP.Param) > 32 ? nP.Param = 32 : nP.Param, 0L );
    return( CONTINUE );
  case 'P':
    GT_SetGadgetAttrs( PlasmaGadgets[GD_PARAM], PlasmaWnd, 0L, GTSL_Level,
		      --(nP.Param) < 0 ? nP.Param = 0 : nP.Param , 0L );
    return( CONTINUE );
  case 't':
    return( TESTClicked() );
  default:
    return( CONTINUE );
  }
}

VOID prefs( LONG command )
{
  switch( command ) {
  case STARTUP:
    CopyMem( prefData, &nP, sizeof( struct pPrefObject ));
    if( !SetupScreen() ) {
      if( !OpenPlasmaWindow()) setPlasmaPrefs();
      CloseDownScreen();
    }
    break;
  case IDCMP:
    if( HandlePlasmaIDCMP() != QUIT ) break;
  case KILL:
    ClosePlasmaWindow();
    break;
  }		
}

LONG winSig( VOID )
{
  return( PlasmaWnd ? ( 1l << PlasmaWnd->UserPort->mp_SigBit ) : 0l );
}
