#include <exec/types.h>
#include <exec/memory.h>

#include <intuition/intuition.h>

#include <dos/dos.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/alib_protos.h>

#include "Star.h"
#include "/defs.h"

#define WRITEPIXEL( R, x, y )\
  (( x < Wid )&&( y < Hei ))?( WritePixel( R, x, y )):1

#define	DE	200
#define	de	1000

struct mPrefObject {
  LONG	Stars, Speed;
};

struct	pt_3d
{
  SHORT	x,y,z,speed;
};

struct	pt_2d{
  SHORT	x,y;
};

extern struct mPrefObject nP;
extern ULONG Depth, Mode;
extern UBYTE *prefData;
struct pt_3d *tab_pt_3d;
struct pt_2d *tab_old;

void new_star( struct pt_3d *p, LONG speed )
{
  p->x = 1500 - RangeRand( 3000 );
  p->y = 1000 - RangeRand( 2000 );
  p->z = 1000 + RangeRand( 2000 );
  p->speed = RangeRand( 10 ) + speed;
}

VOID blank( VOID )
{
  struct mPrefObject *mP;
  struct RastPort *Rast;
  struct Screen *Scr;
  struct pt_3d *p;
  struct pt_2d *p2;
  WORD Wid, Hei, i, x, y, Stars, Speed;
  
  if( StarWnd ) mP = &nP;
  else mP = ( struct mPrefObject * )prefData;
  
  Stars = mP->Stars;
  Speed = mP->Speed;
  
  if(!( tab_pt_3d = AllocVec( Stars * sizeof( struct pt_3d ), MEMF_CLEAR )))
    return;
  if( tab_old = AllocVec( Stars * sizeof( struct pt_2d ), MEMF_CLEAR )) {
    if( Scr = OpenScreenTags( NULL, SA_Depth, 2, SA_Overscan, OSCAN_STANDARD,
			     SA_DisplayID, Mode, SA_Quiet, TRUE, SA_Behind,
			     TRUE, TAG_DONE )) {
      Wid = Scr->Width;
      Hei = Scr->Height;
      
      Rast = &( Scr->RastPort );
      for( i = 0; i < 4; i++ )
	SetRGB4(&( Scr->ViewPort ), i, 4 * i, 4 * i, 4 * i );
      SetRast( Rast, 0 );
      
      for( i = 0; i < Stars; i++ ) {
	new_star( &tab_pt_3d[i], Speed );
	tab_old[i].x = 0;
	tab_old[i].y = 0;
      }
      
      BlankMousePointer();
      ScreenToFront( Scr );
      
      while(!( SetSignal( 0L, 0L ) & SIGBREAKF_CTRL_C )) {
	p2 = tab_old;
	p = tab_pt_3d;
	for( i = 0; i < Stars; i++ ) {
	  x = p2->x;
	  y = p2->y;
	  
	  SetAPen( Rast, 0 );
	  if( p->z > 1000 ) WRITEPIXEL( Rast, x, y );
	  else if( p->z > 200 ) {
	    WRITEPIXEL( Rast, x, y );
	    WRITEPIXEL( Rast, x+1, y );
	  } else {
	    WRITEPIXEL( Rast, x, y );
	    WRITEPIXEL( Rast, x+1, y );
	    WRITEPIXEL( Rast, x, y+1 );
	    WRITEPIXEL( Rast, x+1, y+1 );
	  }
	  p->z -= p->speed;
	  if( p->z <= -de ) new_star( p, Speed );
	  
	  x = Wid/2 + ( DE * p->x ) / ( p->z + de );
	  y = Hei/2 + ( DE * p->y ) / ( p->z + de );
	  
	  if(( x < 0 )||( x >= Wid )||( y < 0 )||( y >= Hei )) {
	    new_star( p, Speed );
	    p2->x = 0;
	    p2->y = 0;
	  } else {
	    p2->x = x;
	    p2->y = y;
	    if( p->z > 2000 ) {
	      SetAPen( Rast, 1 );
	      WRITEPIXEL( Rast, x, y );
	    } else if( p->z > 1500 ) {
	      SetAPen( Rast, 2 );
	      WRITEPIXEL( Rast, x, y );
	    } else if( p->z > 1000 ) {
	      SetAPen( Rast, 3 );
	      WRITEPIXEL( Rast, x, y );
	    } else if( p->z > 200 ) {
	      SetAPen( Rast, 3 );
	      WRITEPIXEL( Rast, x, y );
	      WRITEPIXEL( Rast, x+1, y );
	    } else {
	      SetAPen( Rast, 3 );
	      WRITEPIXEL( Rast, x, y );
	      WRITEPIXEL( Rast, x+1, y );
	      WRITEPIXEL( Rast, x, y+1 );
	      WRITEPIXEL( Rast, x+1, y+1 );
	    }
	  }
	  p2++;
	  p++;
	}
      }
      SetSignal( 0L, SIGBREAKF_CTRL_C );
      UnblankMousePointer();
      CloseScreen(Scr);
    }
    FreeVec( tab_old );
  }
  if( tab_pt_3d ) FreeVec( tab_pt_3d );
}
