#include <exec/types.h>

#include <intuition/intuition.h>

#include <libraries/gadtools.h>

#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>

#include "Star.h"
#include "Star_rev.h"
#include "/defs.h"

struct mPrefObject {
  LONG	Stars, Speed;
};

struct	mPrefObject	nP;
STATIC	const	UBYTE		VersTag[] = VERSTAG;
extern ULONG *Blanking;
extern		UBYTE		*prefData;

#define	MAX_SPEED	20
#define	MAX_STAR	151

VOID setStarPrefs( VOID )
{
  GT_SetGadgetAttrs( StarGadgets[GD_STARS], StarWnd, 0L, GTSL_Level, nP.Stars, 0L );
  GT_SetGadgetAttrs( StarGadgets[GD_SPEED], StarWnd, 0L, GTSL_Level, nP.Speed, 0L );
}

int OKClicked( VOID )
{
  CopyMem( &nP, prefData, sizeof( struct mPrefObject ));
  return( QUIT );
}

int TESTClicked( VOID )
{
  *Blanking = TRUE;
  blank();
  return( CONTINUE );
}

int CANCELClicked( VOID )
{
  return( QUIT );
}

int SPEEDClicked( VOID )
{
  nP.Speed = StarMsg.Code;
  return( CONTINUE );
}

int STARSClicked( VOID )
{
  nP.Stars = StarMsg.Code;
  return( CONTINUE );
}

int StarVanillaKey( VOID )
{
  switch( StarMsg.Code ) {
  case 'o':
    return( OKClicked() );
  case 't':
    return( TESTClicked() );
  case 'c':
    return( CANCELClicked() );
  case 'a':
    GT_SetGadgetAttrs( StarGadgets[GD_STARS], StarWnd, 0L, GTSL_Level, ++(nP.Stars) > MAX_STAR-1 ?
		      nP.Stars= MAX_STAR-1 : nP.Stars, 0L );
    return( CONTINUE );
  case 'A':
    GT_SetGadgetAttrs( StarGadgets[GD_STARS], StarWnd, 0L, GTSL_Level, --(nP.Stars) < 1 ?
		      nP.Stars= 1 : nP.Stars, 0L );
    return( CONTINUE );
  case 's':
    GT_SetGadgetAttrs( StarGadgets[GD_SPEED], StarWnd, 0L, GTSL_Level, ++(nP.Speed) > MAX_SPEED ?
		      nP.Speed = MAX_SPEED : nP.Speed, 0L );
    return( CONTINUE );
  case 'S':
    GT_SetGadgetAttrs( StarGadgets[GD_SPEED], StarWnd, 0L, GTSL_Level, --(nP.Speed) < 1 ?
		      nP.Speed= 1 : nP.Speed, 0L );
    return( CONTINUE );
  default:
    return( CONTINUE );
  }
  
}

VOID prefs( LONG command )
{
  switch( command ) {
  case STARTUP:
    CopyMem( prefData, &nP, sizeof( struct mPrefObject ));
    if( !SetupScreen() ) {
      if( !OpenStarWindow()) setStarPrefs();
      CloseDownScreen();
    }
    break;
  case IDCMP:
    if( HandleStarIDCMP() != QUIT ) break;
  case KILL:
    CloseStarWindow();
  }
}

LONG winSig( VOID )
{
  return( StarWnd ? 1L << StarWnd->UserPort->mp_SigBit : 0L );
}
