/************************************************************************/
/* Images of chess pieces												*/
/************************************************************************/

#include <intuition/intuition.h>

struct Image SFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	NULL,		/* ImageData				*/
	0x00, 0x06,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

struct Image WFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	NULL,		/* ImageData				*/
	0x00, 0x07,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WBWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0x8001,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFE0,0x0000,0x07FF,
	0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x0000,0x03FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xE7E7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF,
	0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xE7E7,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0x87E1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFE,0x7FFE,0x7FFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFE,0x1FF8,0x7FFF,
	0xFFFC,0x7FFE,0x3FFF, 0xFFF9,0xFFFF,0x9FFF, 0xFFF3,0xFFFF,0xCFFF,
	0xFFE7,0xFFFF,0xE7FF, 0xFFCF,0xFFFF,0xF3FF, 0xFFDF,0xFFFF,0xFBFF,
	0xFF9F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF3F,0xFFFF,0xFCFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0x0000,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WBWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WBWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WBSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x03C0,0x0000, 0x0000,0x07E0,0x0000,
	0x0000,0x0C30,0x0000, 0x0000,0x1818,0x0000, 0x0000,0x1008,0x0000,
	0x0000,0x1008,0x0000, 0x0000,0x1008,0x0000, 0x0000,0x1818,0x0000,
	0x0000,0x0C30,0x0000, 0x0000,0x781E,0x0000, 0x0000,0xE007,0x0000,
	0x0001,0x8001,0x8000, 0x0003,0x0000,0xC000, 0x0002,0x0000,0x4000,
	0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000,
	0x0002,0x0000,0x4000, 0x0003,0x0000,0xC000, 0x0001,0x8001,0x8000,
	0x0000,0x8001,0x0000, 0x0000,0x700E,0x0000, 0x0001,0xE007,0x8000,
	0x0003,0x8001,0xC000, 0x0006,0x0000,0x6000, 0x000C,0x0000,0x3000,
	0x0018,0x0000,0x1800, 0x0030,0x0000,0x0C00, 0x0020,0x0000,0x0400,
	0x0060,0x0000,0x0600, 0x0040,0x0000,0x0200, 0x0040,0x0000,0x0200,
	0x00C0,0x0000,0x0300, 0x0080,0x0000,0x0100, 0x0080,0x0000,0x0100,
	0x0080,0x0000,0x0100, 0x0080,0x0000,0x0100, 0x0080,0x0000,0x0100,
	0x00FF,0xFFFF,0xFF00, 0x00FF,0xFFFF,0xFF00, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xE7E7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF,
	0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xE7E7,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0x87E1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFE,0x7FFE,0x7FFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFE,0x1FF8,0x7FFF,
	0xFFFC,0x7FFE,0x3FFF, 0xFFF9,0xFFFF,0x9FFF, 0xFFF3,0xFFFF,0xCFFF,
	0xFFE7,0xFFFF,0xE7FF, 0xFFCF,0xFFFF,0xF3FF, 0xFFDF,0xFFFF,0xFBFF,
	0xFF9F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF3F,0xFFFF,0xFCFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0x0000,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WBSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WBSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SBWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xE7E7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF,
	0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xE7E7,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0x87E1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFE,0x7FFE,0x7FFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFE,0x1FF8,0x7FFF,
	0xFFFC,0x7FFE,0x3FFF, 0xFFF9,0xFFFF,0x9FFF, 0xFFF3,0xFFFF,0xCFFF,
	0xFFE7,0xFFFF,0xE7FF, 0xFFCF,0xFFFF,0xF3FF, 0xFFDF,0xFFFF,0xFBFF,
	0xFF9F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF3F,0xFFFF,0xFCFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0x8001,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFE0,0x0000,0x07FF,
	0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x0000,0x03FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xE7E7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF,
	0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xE7E7,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0x87E1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFE,0x7FFE,0x7FFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFE,0x1FF8,0x7FFF,
	0xFFFC,0x7FFE,0x3FFF, 0xFFF9,0xFFFF,0x9FFF, 0xFFF3,0xFFFF,0xCFFF,
	0xFFE7,0xFFFF,0xE7FF, 0xFFCF,0xFFFF,0xF3FF, 0xFFDF,0xFFFF,0xFBFF,
	0xFF9F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF3F,0xFFFF,0xFCFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SBWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SBWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SBSFData[576] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x07E0,0x0000, 0x0000,0x0FF0,0x0000,
	0x0000,0x0FF0,0x0000, 0x0000,0x0FF0,0x0000, 0x0000,0x07E0,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x07E0,0x0000, 0x0000,0x1FF8,0x0000,
	0x0000,0x7FFE,0x0000, 0x0000,0xFFFF,0x0000, 0x0001,0xFFFF,0x8000,
	0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000,
	0x0001,0xFFFF,0x8000, 0x0000,0xFFFF,0x0000, 0x0000,0x7FFE,0x0000,
	0x0000,0x7FFE,0x0000, 0x0000,0x0FF0,0x0000, 0x0000,0x1FF8,0x0000,
	0x0000,0x7FFE,0x0000, 0x0001,0xFFFF,0x8000, 0x0003,0xFFFF,0xC000,
	0x0007,0xFFFF,0xE000, 0x000F,0xFFFF,0xF000, 0x001F,0xFFFF,0xF800,
	0x001F,0xFFFF,0xF800, 0x003F,0xFFFF,0xFC00, 0x003F,0xFFFF,0xFC00,
	0x003F,0xFFFF,0xFC00, 0x007F,0xFFFF,0xFE00, 0x007F,0xFFFF,0xFE00,
	0x007F,0xFFFF,0xFE00, 0x007F,0xFFFF,0xFE00, 0x007F,0xFFFF,0xFE00,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0x8001,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFE0,0x0000,0x07FF,
	0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x0000,0x03FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xE7E7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF,
	0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xEFF7,0xFFFF, 0xFFFF,0xE7E7,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0x87E1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFC,0xFFFF,0x3FFF, 0xFFFE,0x7FFE,0x7FFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFE,0x1FF8,0x7FFF,
	0xFFFC,0x7FFE,0x3FFF, 0xFFF9,0xFFFF,0x9FFF, 0xFFF3,0xFFFF,0xCFFF,
	0xFFE7,0xFFFF,0xE7FF, 0xFFCF,0xFFFF,0xF3FF, 0xFFDF,0xFFFF,0xFBFF,
	0xFF9F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF3F,0xFFFF,0xFCFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF, 0xFF7F,0xFFFF,0xFEFF,
	0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SBSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SBSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WTWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFC1,0xF81F,0x83FF, 0xFFC1,0xF81F,0x83FF,
	0xFFC1,0xF81F,0x83FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x0000,0x07FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFFBE,0xF7EF,0x7DFF, 0xFFBE,0x07E0,0x7DFF,
	0xFFBE,0x07E0,0x7DFF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFFB,0xFFFF,0xDFFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFB,0xFFFF,0xDFFF,
	0xFFF7,0xFFFF,0xEFFF, 0xFFEF,0xFFFF,0xF7FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0xFFFF,0xFBFF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFEFF,0xFFFF,0xFF7F,
	0xFEFF,0xFFFF,0xFF7F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFF80,0xF00F,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF0,0x0000,0x0FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WTWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WTWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WTSFData[576] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x007F,0x0FF0,0xFE00,
	0x007F,0x0FF0,0xFE00, 0x0041,0x0810,0x8200, 0x0041,0xF81F,0x8200,
	0x0041,0xF81F,0x8200, 0x0040,0x0000,0x0200, 0x0040,0x0000,0x0200,
	0x007F,0xFFFF,0xFE00, 0x003F,0xFFFF,0xFC00, 0x0008,0x0000,0x1000,
	0x0004,0x0000,0x2000, 0x0003,0xFFFF,0xC000, 0x0003,0xFFFF,0xC000,
	0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000,
	0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000,
	0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000,
	0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000, 0x0002,0x0000,0x4000,
	0x0003,0xFFFF,0xC000, 0x0003,0xFFFF,0xC000, 0x0004,0x0000,0x2000,
	0x0008,0x0000,0x1000, 0x0010,0x0000,0x0800, 0x003F,0xFFFF,0xF800,
	0x003F,0xFFFF,0xFC00, 0x0020,0x0000,0x0400, 0x0020,0x0000,0x0400,
	0x01FF,0xFFFF,0xFF80, 0x01FF,0xFFFF,0xFF80, 0x0100,0x0000,0x0080,
	0x0100,0x0000,0x0080, 0x01FF,0xFFFF,0xFF80, 0x01FF,0xFFFF,0xFF80,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFFBE,0xF7EF,0x7DFF, 0xFFBE,0x07E0,0x7DFF,
	0xFFBE,0x07E0,0x7DFF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFFB,0xFFFF,0xDFFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFB,0xFFFF,0xDFFF,
	0xFFF7,0xFFFF,0xEFFF, 0xFFEF,0xFFFF,0xF7FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0xFFFF,0xFBFF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFEFF,0xFFFF,0xFF7F,
	0xFEFF,0xFFFF,0xFF7F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFF80,0xF00F,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF0,0x0000,0x0FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFE0,0x0000,0x07FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WTSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WTSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip STWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFFBE,0xF7EF,0x7DFF, 0xFFBE,0x07E0,0x7DFF,
	0xFFBE,0x07E0,0x7DFF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFFB,0xFFFF,0xDFFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFB,0xFFFF,0xDFFF,
	0xFFF7,0xFFFF,0xEFFF, 0xFFEF,0xFFFF,0xF7FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0xFFFF,0xFBFF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFEFF,0xFFFF,0xFF7F,
	0xFEFF,0xFFFF,0xFF7F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFC1,0xF81F,0x83FF, 0xFFC1,0xF81F,0x83FF,
	0xFFC1,0xF81F,0x83FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x0000,0x07FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFFBE,0xF7EF,0x7DFF, 0xFFBE,0x07E0,0x7DFF,
	0xFFBE,0x07E0,0x7DFF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFFB,0xFFFF,0xDFFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFB,0xFFFF,0xDFFF,
	0xFFF7,0xFFFF,0xEFFF, 0xFFEF,0xFFFF,0xF7FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0xFFFF,0xFBFF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFEFF,0xFFFF,0xFF7F,
	0xFEFF,0xFFFF,0xFF7F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image STWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	STWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip STSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x003E,0x07E0,0x7C00, 0x003E,0x07E0,0x7C00,
	0x003E,0x07E0,0x7C00, 0x003F,0xFFFF,0xFC00, 0x003F,0xFFFF,0xFC00,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0007,0xFFFF,0xE000,
	0x0003,0xFFFF,0xC000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000,
	0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000,
	0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000,
	0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000, 0x0001,0xFFFF,0x8000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0003,0xFFFF,0xC000,
	0x0007,0xFFFF,0xE000, 0x000F,0xFFFF,0xF000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x001F,0xFFFF,0xF800, 0x001F,0xFFFF,0xF800,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x00FF,0xFFFF,0xFF00,
	0x00FF,0xFFFF,0xFF00, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFC1,0xF81F,0x83FF, 0xFFC1,0xF81F,0x83FF,
	0xFFC1,0xF81F,0x83FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFC,0x0000,0x3FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x0000,0x07FF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF00,0x0000,0x00FF,
	0xFF00,0x0000,0x00FF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFF80,0xF00F,0x01FF,
	0xFF80,0xF00F,0x01FF, 0xFFBE,0xF7EF,0x7DFF, 0xFFBE,0x07E0,0x7DFF,
	0xFFBE,0x07E0,0x7DFF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0xFFFF,0xFDFF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFFB,0xFFFF,0xDFFF, 0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF, 0xFFFD,0xFFFF,0xBFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFB,0xFFFF,0xDFFF,
	0xFFF7,0xFFFF,0xEFFF, 0xFFEF,0xFFFF,0xF7FF, 0xFFC0,0x0000,0x07FF,
	0xFFC0,0x0000,0x03FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0xFFFF,0xFBFF,
	0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F, 0xFEFF,0xFFFF,0xFF7F,
	0xFEFF,0xFFFF,0xFF7F, 0xFE00,0x0000,0x007F, 0xFE00,0x0000,0x007F,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image STSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	STSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WSWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFF3,0xF7FF,0xFFFF, 0xFFF1,0xE3FF,0xFFFF,
	0xFFF0,0x43FF,0xFFFF, 0xFFF3,0xC1FF,0xFFFF, 0xFFFF,0x80FF,0xFFFF,
	0xFFFC,0x0007,0xFFFF, 0xFFE0,0x0000,0xFFFF, 0xFFE0,0x0000,0x3FFF,
	0xFF80,0x0000,0x1FFF, 0xFF80,0x0000,0x0FFF, 0xFF0C,0x0000,0x07FF,
	0xFF1C,0x0000,0x03FF, 0xFF18,0x0000,0x03FF, 0xFF20,0x0040,0x01FF,
	0xFF00,0x0020,0x01FF, 0xFF00,0x0020,0x00FF, 0xFE00,0x0040,0x00FF,
	0xFE00,0x0040,0x007F, 0xFC00,0x0080,0x007F, 0xF800,0x0180,0x007F,
	0xF800,0x0700,0x003F, 0xF000,0x1F00,0x003F, 0xF000,0x7F00,0x003F,
	0xE601,0xFF00,0x001F, 0xEE03,0xFF00,0x001F, 0xEC07,0xFF00,0x001F,
	0xE80F,0xFF00,0x001F, 0xE00F,0xFE00,0x001F, 0xF09F,0xFE00,0x000F,
	0xFD9F,0xFC00,0x000F, 0xFF3F,0xFC00,0x000F, 0xFFFF,0xF800,0x000F,
	0xFFFF,0xF000,0x000F, 0xFFFF,0xE000,0x000F, 0xFFFF,0xC000,0x0007,
	0xFFFF,0x8000,0x0007, 0xFFFF,0x0000,0x0007, 0xFFFF,0x0000,0x0007,
	0xFFFE,0x0000,0x0007, 0xFFFE,0x0000,0x0007, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFEC,0x49FF,0xFFFF, 0xFFEE,0x5DFF,0xFFFF,
	0xFFEF,0xBCFF,0xFFFF, 0xFFEC,0x3E07,0xFFFF, 0xFFE0,0x7F00,0xFFFF,
	0xFFC3,0xFFF8,0x3FFF, 0xFF9F,0xFFFF,0x1FFF, 0xFF1F,0xFFFF,0xCFFF,
	0xFF7F,0xFFFF,0xE7FF, 0xFE7F,0xFFFF,0xF3FF, 0xFEF3,0xFFFF,0xF9FF,
	0xFEE3,0xFFFF,0xFDFF, 0xFEE7,0xFFFF,0xFCFF, 0xFEDF,0xFFBF,0xFEFF,
	0xFEFF,0xFFDF,0xFE7F, 0xFCFF,0xFFDF,0xFF7F, 0xFDFF,0xFFBF,0xFF3F,
	0xF9FF,0xFFBF,0xFFBF, 0xF3FF,0xFF7F,0xFFBF, 0xF7FF,0xFE7F,0xFF9F,
	0xE7FF,0xF8FF,0xFFDF, 0xEFFF,0xE0FF,0xFFDF, 0xCFFF,0x86FF,0xFFCF,
	0xD9FE,0x1EFF,0xFFEF, 0xD1FC,0x7EFF,0xFFEF, 0xD3F9,0xFEFF,0xFFEF,
	0xD7F3,0xFCFF,0xFFEF, 0xDFF7,0xFDFF,0xFFE7, 0xCF67,0xF9FF,0xFFF7,
	0xE26F,0xFBFF,0xFFF7, 0xF0CF,0xF3FF,0xFFF7, 0xFC1F,0xE7FF,0xFFF7,
	0xFF3F,0xCFFF,0xFFF7, 0xFFFF,0x9FFF,0xFFF3, 0xFFFF,0x3FFF,0xFFFB,
	0xFFFE,0x7FFF,0xFFFB, 0xFFFE,0xFFFF,0xFFFB, 0xFFFC,0xFFFF,0xFFFB,
	0xFFFD,0xFFFF,0xFFFB, 0xFFFD,0xFFFF,0xFFFB, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFE0,0x41FF,0xFFFF, 0xFFE0,0x41FF,0xFFFF,
	0xFFE0,0x00FF,0xFFFF, 0xFFE0,0x0007,0xFFFF, 0xFFE0,0x0000,0xFFFF,
	0xFFC0,0x0000,0x3FFF, 0xFF80,0x0000,0x1FFF, 0xFF00,0x0000,0x0FFF,
	0xFF00,0x0000,0x07FF, 0xFE00,0x0000,0x03FF, 0xFE00,0x0000,0x01FF,
	0xFE00,0x0000,0x01FF, 0xFE00,0x0000,0x00FF, 0xFE00,0x0000,0x00FF,
	0xFE00,0x0000,0x007F, 0xFC00,0x0000,0x007F, 0xFC00,0x0000,0x003F,
	0xF800,0x0000,0x003F, 0xF000,0x0000,0x003F, 0xF000,0x0000,0x001F,
	0xE000,0x0000,0x001F, 0xE000,0x0000,0x001F, 0xC000,0x0600,0x000F,
	0xC000,0x1E00,0x000F, 0xC000,0x7E00,0x000F, 0xC001,0xFE00,0x000F,
	0xC003,0xFC00,0x000F, 0xC007,0xFC00,0x0007, 0xC007,0xF800,0x0007,
	0xE00F,0xF800,0x0007, 0xF00F,0xF000,0x0007, 0xFC1F,0xE000,0x0007,
	0xFF3F,0xC000,0x0007, 0xFFFF,0x8000,0x0003, 0xFFFF,0x0000,0x0003,
	0xFFFE,0x0000,0x0003, 0xFFFE,0x0000,0x0003, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFC,0x0000,0x0003, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WSWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WSWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WSSFData[576] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0010,0x0400,0x0000, 0x001C,0x0C00,0x0000,
	0x001E,0x1C00,0x0000, 0x0013,0xB600,0x0000, 0x0011,0xA200,0x0000,
	0x0010,0x4300,0x0000, 0x0013,0xC1F8,0x0000, 0x001F,0x80FF,0x0000,
	0x003C,0x0007,0xC000, 0x0060,0x0000,0xE000, 0x00E0,0x0000,0x3000,
	0x0080,0x0000,0x1800, 0x0180,0x0000,0x0C00, 0x010C,0x0000,0x0600,
	0x011C,0x0000,0x0200, 0x0118,0x0000,0x0300, 0x0120,0x0040,0x0100,
	0x0100,0x0020,0x0180, 0x0300,0x0020,0x0080, 0x0200,0x0040,0x00C0,
	0x0600,0x0040,0x0040, 0x0C00,0x0080,0x0040, 0x0800,0x0180,0x0060,
	0x1800,0x0700,0x0020, 0x1000,0x1F00,0x0020, 0x3000,0x7900,0x0030,
	0x2601,0xE100,0x0010, 0x2E03,0x8100,0x0010, 0x2C06,0x0100,0x0010,
	0x280C,0x0300,0x0010, 0x2008,0x0200,0x0018, 0x3098,0x0600,0x0008,
	0x1D90,0x0400,0x0008, 0x0F30,0x0C00,0x0008, 0x03E0,0x1800,0x0008,
	0x00C0,0x3000,0x0008, 0x0000,0x6000,0x000C, 0x0000,0xC000,0x0004,
	0x0001,0x8000,0x0004, 0x0001,0x0000,0x0004, 0x0003,0x0000,0x0004,
	0x0002,0x0000,0x0004, 0x0002,0x0000,0x0004, 0x0003,0xFFFF,0xFFFC,
	0x0003,0xFFFF,0xFFFC, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFEC,0x49FF,0xFFFF, 0xFFEE,0x5DFF,0xFFFF,
	0xFFEF,0xBCFF,0xFFFF, 0xFFEC,0x3E07,0xFFFF, 0xFFE0,0x7F00,0xFFFF,
	0xFFC3,0xFFF8,0x3FFF, 0xFF9F,0xFFFF,0x1FFF, 0xFF1F,0xFFFF,0xCFFF,
	0xFF7F,0xFFFF,0xE7FF, 0xFE7F,0xFFFF,0xF3FF, 0xFEF3,0xFFFF,0xF9FF,
	0xFEE3,0xFFFF,0xFDFF, 0xFEE7,0xFFFF,0xFCFF, 0xFEDF,0xFFBF,0xFEFF,
	0xFEFF,0xFFDF,0xFE7F, 0xFCFF,0xFFDF,0xFF7F, 0xFDFF,0xFFBF,0xFF3F,
	0xF9FF,0xFFBF,0xFFBF, 0xF3FF,0xFF7F,0xFFBF, 0xF7FF,0xFE7F,0xFF9F,
	0xE7FF,0xF8FF,0xFFDF, 0xEFFF,0xE0FF,0xFFDF, 0xCFFF,0x86FF,0xFFCF,
	0xD9FE,0x1EFF,0xFFEF, 0xD1FC,0x7EFF,0xFFEF, 0xD3F9,0xFEFF,0xFFEF,
	0xD7F3,0xFCFF,0xFFEF, 0xDFF7,0xFDFF,0xFFE7, 0xCF67,0xF9FF,0xFFF7,
	0xE26F,0xFBFF,0xFFF7, 0xF0CF,0xF3FF,0xFFF7, 0xFC1F,0xE7FF,0xFFF7,
	0xFF3F,0xCFFF,0xFFF7, 0xFFFF,0x9FFF,0xFFF3, 0xFFFF,0x3FFF,0xFFFB,
	0xFFFE,0x7FFF,0xFFFB, 0xFFFE,0xFFFF,0xFFFB, 0xFFFC,0xFFFF,0xFFFB,
	0xFFFD,0xFFFF,0xFFFB, 0xFFFD,0xFFFF,0xFFFB, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFE0,0x41FF,0xFFFF, 0xFFE0,0x41FF,0xFFFF,
	0xFFE0,0x00FF,0xFFFF, 0xFFE0,0x0007,0xFFFF, 0xFFE0,0x0000,0xFFFF,
	0xFFC0,0x0000,0x3FFF, 0xFF80,0x0000,0x1FFF, 0xFF00,0x0000,0x0FFF,
	0xFF00,0x0000,0x07FF, 0xFE00,0x0000,0x03FF, 0xFE00,0x0000,0x01FF,
	0xFE00,0x0000,0x01FF, 0xFE00,0x0000,0x00FF, 0xFE00,0x0000,0x00FF,
	0xFE00,0x0000,0x007F, 0xFC00,0x0000,0x007F, 0xFC00,0x0000,0x003F,
	0xF800,0x0000,0x003F, 0xF000,0x0000,0x003F, 0xF000,0x0000,0x001F,
	0xE000,0x0000,0x001F, 0xE000,0x0000,0x001F, 0xC000,0x0600,0x000F,
	0xC000,0x1E00,0x000F, 0xC000,0x7E00,0x000F, 0xC001,0xFE00,0x000F,
	0xC003,0xFC00,0x000F, 0xC007,0xFC00,0x0007, 0xC007,0xF800,0x0007,
	0xE00F,0xF800,0x0007, 0xF00F,0xF000,0x0007, 0xFC1F,0xE000,0x0007,
	0xFF3F,0xC000,0x0007, 0xFFFF,0x8000,0x0003, 0xFFFF,0x0000,0x0003,
	0xFFFE,0x0000,0x0003, 0xFFFE,0x0000,0x0003, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFC,0x0000,0x0003, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WSSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WSSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SSWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFEC,0x49FF,0xFFFF, 0xFFEE,0x5DFF,0xFFFF,
	0xFFEF,0xBCFF,0xFFFF, 0xFFEC,0x3E07,0xFFFF, 0xFFE0,0x7F00,0xFFFF,
	0xFFC3,0xFFF8,0x3FFF, 0xFF9F,0xFFFF,0x1FFF, 0xFF1F,0xFFFF,0xCFFF,
	0xFF7F,0xFFFF,0xE7FF, 0xFE7F,0xFFFF,0xF3FF, 0xFEF3,0xFFFF,0xF9FF,
	0xFEE3,0xFFFF,0xFDFF, 0xFEE7,0xFFFF,0xFCFF, 0xFEDF,0xFFBF,0xFEFF,
	0xFEFF,0xFFDF,0xFE7F, 0xFCFF,0xFFDF,0xFF7F, 0xFDFF,0xFFBF,0xFF3F,
	0xF9FF,0xFFBF,0xFFBF, 0xF3FF,0xFF7F,0xFFBF, 0xF7FF,0xFE7F,0xFF9F,
	0xE7FF,0xF8FF,0xFFDF, 0xEFFF,0xE0FF,0xFFDF, 0xCFFF,0x86FF,0xFFCF,
	0xD9FE,0x1EFF,0xFFEF, 0xD1FC,0x7EFF,0xFFEF, 0xD3F9,0xFEFF,0xFFEF,
	0xD7F3,0xFCFF,0xFFEF, 0xDFF7,0xFDFF,0xFFE7, 0xCF67,0xF9FF,0xFFF7,
	0xE26F,0xFBFF,0xFFF7, 0xF0CF,0xF3FF,0xFFF7, 0xFC1F,0xE7FF,0xFFF7,
	0xFF3F,0xCFFF,0xFFF7, 0xFFFF,0x9FFF,0xFFF3, 0xFFFF,0x3FFF,0xFFFB,
	0xFFFE,0x7FFF,0xFFFB, 0xFFFE,0xFFFF,0xFFFB, 0xFFFC,0xFFFF,0xFFFB,
	0xFFFD,0xFFFF,0xFFFB, 0xFFFD,0xFFFF,0xFFFB, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFF3,0xF7FF,0xFFFF, 0xFFF1,0xE3FF,0xFFFF,
	0xFFF0,0x43FF,0xFFFF, 0xFFF3,0xC1FF,0xFFFF, 0xFFFF,0x80FF,0xFFFF,
	0xFFFC,0x0007,0xFFFF, 0xFFE0,0x0000,0xFFFF, 0xFFE0,0x0000,0x3FFF,
	0xFF80,0x0000,0x1FFF, 0xFF80,0x0000,0x0FFF, 0xFF0C,0x0000,0x07FF,
	0xFF1C,0x0000,0x03FF, 0xFF18,0x0000,0x03FF, 0xFF20,0x0040,0x01FF,
	0xFF00,0x0020,0x01FF, 0xFF00,0x0020,0x00FF, 0xFE00,0x0040,0x00FF,
	0xFE00,0x0040,0x007F, 0xFC00,0x0080,0x007F, 0xF800,0x0180,0x007F,
	0xF800,0x0700,0x003F, 0xF000,0x1F00,0x003F, 0xF000,0x7F00,0x003F,
	0xE601,0xFF00,0x001F, 0xEE03,0xFF00,0x001F, 0xEC07,0xFF00,0x001F,
	0xE80F,0xFF00,0x001F, 0xE00F,0xFE00,0x001F, 0xF09F,0xFE00,0x000F,
	0xFD9F,0xFC00,0x000F, 0xFF3F,0xFC00,0x000F, 0xFFFF,0xF800,0x000F,
	0xFFFF,0xF000,0x000F, 0xFFFF,0xE000,0x000F, 0xFFFF,0xC000,0x0007,
	0xFFFF,0x8000,0x0007, 0xFFFF,0x0000,0x0007, 0xFFFF,0x0000,0x0007,
	0xFFFE,0x0000,0x0007, 0xFFFE,0x0000,0x0007, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFEC,0x49FF,0xFFFF, 0xFFEE,0x5DFF,0xFFFF,
	0xFFEF,0xBCFF,0xFFFF, 0xFFEC,0x3E07,0xFFFF, 0xFFE0,0x7F00,0xFFFF,
	0xFFC3,0xFFF8,0x3FFF, 0xFF9F,0xFFFF,0x1FFF, 0xFF1F,0xFFFF,0xCFFF,
	0xFF7F,0xFFFF,0xE7FF, 0xFE7F,0xFFFF,0xF3FF, 0xFEF3,0xFFFF,0xF9FF,
	0xFEE3,0xFFFF,0xFDFF, 0xFEE7,0xFFFF,0xFCFF, 0xFEDF,0xFFBF,0xFEFF,
	0xFEFF,0xFFDF,0xFE7F, 0xFCFF,0xFFDF,0xFF7F, 0xFDFF,0xFFBF,0xFF3F,
	0xF9FF,0xFFBF,0xFFBF, 0xF3FF,0xFF7F,0xFFBF, 0xF7FF,0xFE7F,0xFF9F,
	0xE7FF,0xF8FF,0xFFDF, 0xEFFF,0xE0FF,0xFFDF, 0xCFFF,0x86FF,0xFFCF,
	0xD9FE,0x1EFF,0xFFEF, 0xD1FC,0x7EFF,0xFFEF, 0xD3F9,0xFEFF,0xFFEF,
	0xD7F3,0xFCFF,0xFFEF, 0xDFF7,0xFDFF,0xFFE7, 0xCF67,0xF9FF,0xFFF7,
	0xE26F,0xFBFF,0xFFF7, 0xF0CF,0xF3FF,0xFFF7, 0xFC1F,0xE7FF,0xFFF7,
	0xFF3F,0xCFFF,0xFFF7, 0xFFFF,0x9FFF,0xFFF3, 0xFFFF,0x3FFF,0xFFFB,
	0xFFFE,0x7FFF,0xFFFB, 0xFFFE,0xFFFF,0xFFFB, 0xFFFC,0xFFFF,0xFFFB,
	0xFFFD,0xFFFF,0xFFFB, 0xFFFD,0xFFFF,0xFFFB, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SSWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SSWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SSSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x000C,0x0800,0x0000, 0x000E,0x1C00,0x0000,
	0x000F,0xBC00,0x0000, 0x000C,0x3E00,0x0000, 0x0000,0x7F00,0x0000,
	0x0003,0xFFF8,0x0000, 0x001F,0xFFFF,0x0000, 0x001F,0xFFFF,0xC000,
	0x007F,0xFFFF,0xE000, 0x007F,0xFFFF,0xF000, 0x00F3,0xFFFF,0xF800,
	0x00E3,0xFFFF,0xFC00, 0x00E7,0xFFFF,0xFC00, 0x00DF,0xFFBF,0xFE00,
	0x00FF,0xFFDF,0xFE00, 0x00FF,0xFFDF,0xFF00, 0x01FF,0xFFBF,0xFF00,
	0x01FF,0xFFBF,0xFF80, 0x03FF,0xFF7F,0xFF80, 0x07FF,0xFE7F,0xFF80,
	0x07FF,0xF8FF,0xFFC0, 0x0FFF,0xE0FF,0xFFC0, 0x0FFF,0x80FF,0xFFC0,
	0x19FE,0x00FF,0xFFE0, 0x11FC,0x00FF,0xFFE0, 0x13F8,0x00FF,0xFFE0,
	0x17F0,0x00FF,0xFFE0, 0x1FF0,0x01FF,0xFFE0, 0x0F60,0x01FF,0xFFF0,
	0x0260,0x03FF,0xFFF0, 0x00C0,0x03FF,0xFFF0, 0x0000,0x07FF,0xFFF0,
	0x0000,0x0FFF,0xFFF0, 0x0000,0x1FFF,0xFFF0, 0x0000,0x3FFF,0xFFF8,
	0x0000,0x7FFF,0xFFF8, 0x0000,0xFFFF,0xFFF8, 0x0000,0xFFFF,0xFFF8,
	0x0001,0xFFFF,0xFFF8, 0x0001,0xFFFF,0xFFF8, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFF3,0xF7FF,0xFFFF, 0xFFF1,0xE3FF,0xFFFF,
	0xFFF0,0x43FF,0xFFFF, 0xFFF3,0xC1FF,0xFFFF, 0xFFFF,0x80FF,0xFFFF,
	0xFFFC,0x0007,0xFFFF, 0xFFE0,0x0000,0xFFFF, 0xFFE0,0x0000,0x3FFF,
	0xFF80,0x0000,0x1FFF, 0xFF80,0x0000,0x0FFF, 0xFF0C,0x0000,0x07FF,
	0xFF1C,0x0000,0x03FF, 0xFF18,0x0000,0x03FF, 0xFF20,0x0040,0x01FF,
	0xFF00,0x0020,0x01FF, 0xFF00,0x0020,0x00FF, 0xFE00,0x0040,0x00FF,
	0xFE00,0x0040,0x007F, 0xFC00,0x0080,0x007F, 0xF800,0x0180,0x007F,
	0xF800,0x0700,0x003F, 0xF000,0x1F00,0x003F, 0xF000,0x7F00,0x003F,
	0xE601,0xFF00,0x001F, 0xEE03,0xFF00,0x001F, 0xEC07,0xFF00,0x001F,
	0xE80F,0xFF00,0x001F, 0xE00F,0xFE00,0x001F, 0xF09F,0xFE00,0x000F,
	0xFD9F,0xFC00,0x000F, 0xFF3F,0xFC00,0x000F, 0xFFFF,0xF800,0x000F,
	0xFFFF,0xF000,0x000F, 0xFFFF,0xE000,0x000F, 0xFFFF,0xC000,0x0007,
	0xFFFF,0x8000,0x0007, 0xFFFF,0x0000,0x0007, 0xFFFF,0x0000,0x0007,
	0xFFFE,0x0000,0x0007, 0xFFFE,0x0000,0x0007, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFEF,0xFBFF,0xFFFF, 0xFFE3,0xF3FF,0xFFFF,
	0xFFE1,0xE3FF,0xFFFF, 0xFFEC,0x49FF,0xFFFF, 0xFFEE,0x5DFF,0xFFFF,
	0xFFEF,0xBCFF,0xFFFF, 0xFFEC,0x3E07,0xFFFF, 0xFFE0,0x7F00,0xFFFF,
	0xFFC3,0xFFF8,0x3FFF, 0xFF9F,0xFFFF,0x1FFF, 0xFF1F,0xFFFF,0xCFFF,
	0xFF7F,0xFFFF,0xE7FF, 0xFE7F,0xFFFF,0xF3FF, 0xFEF3,0xFFFF,0xF9FF,
	0xFEE3,0xFFFF,0xFDFF, 0xFEE7,0xFFFF,0xFCFF, 0xFEDF,0xFFBF,0xFEFF,
	0xFEFF,0xFFDF,0xFE7F, 0xFCFF,0xFFDF,0xFF7F, 0xFDFF,0xFFBF,0xFF3F,
	0xF9FF,0xFFBF,0xFFBF, 0xF3FF,0xFF7F,0xFFBF, 0xF7FF,0xFE7F,0xFF9F,
	0xE7FF,0xF8FF,0xFFDF, 0xEFFF,0xE0FF,0xFFDF, 0xCFFF,0x86FF,0xFFCF,
	0xD9FE,0x1EFF,0xFFEF, 0xD1FC,0x7EFF,0xFFEF, 0xD3F9,0xFEFF,0xFFEF,
	0xD7F3,0xFCFF,0xFFEF, 0xDFF7,0xFDFF,0xFFE7, 0xCF67,0xF9FF,0xFFF7,
	0xE26F,0xFBFF,0xFFF7, 0xF0CF,0xF3FF,0xFFF7, 0xFC1F,0xE7FF,0xFFF7,
	0xFF3F,0xCFFF,0xFFF7, 0xFFFF,0x9FFF,0xFFF3, 0xFFFF,0x3FFF,0xFFFB,
	0xFFFE,0x7FFF,0xFFFB, 0xFFFE,0xFFFF,0xFFFB, 0xFFFC,0xFFFF,0xFFFB,
	0xFFFD,0xFFFF,0xFFFB, 0xFFFD,0xFFFF,0xFFFB, 0xFFFC,0x0000,0x0003,
	0xFFFC,0x0000,0x0003, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SSSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SSSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WLWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0180,0xFFFF, 0xFFFE,0x0180,0x7FFF,
	0xFFFC,0x07E0,0x3FFF, 0xFFFC,0x07E0,0x3FFF, 0xFFF8,0x0180,0x1FFF,
	0xFFF8,0x0180,0x1FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x3FFC,0xFFFF, 0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0FF0,0xFFFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFF1,0x8001,0x8FFF, 0xFE00,0x0180,0x007F,
	0xF800,0x07E0,0x001F, 0xF00F,0xFFFF,0xF00F, 0xF87F,0xFFFF,0xFE1F,
	0xFDFF,0xFFFF,0xFFBF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xFBDF,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF18F,0xFFFF,
	0xFFFF,0xE3C7,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFE7F,0x3FFF, 0xFFF9,0xFE7F,0x9FFF,
	0xFFFB,0xF81F,0xDFFF, 0xFFF3,0xF81F,0xCFFF, 0xFFF7,0xFE7F,0xEFFF,
	0xFFF7,0xFE7F,0xEFFF, 0xFFF7,0xFFFF,0xEFFF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFF3,0xFFFF,0xCFFF, 0xFFFB,0xFFFF,0xDFFF, 0xFFF9,0xF00F,0x9FFF,
	0xFFFC,0xC003,0x3FFF, 0xFFFE,0x8FF1,0x7FFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFE,0xF00F,0x7FFF, 0xFFFE,0xC003,0x7FFF,
	0xFFFE,0x8FF1,0x7FFF, 0xFFFE,0x3FFC,0x7FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x83C1,0x8FFF,
	0xFE00,0x07E0,0x007F, 0xF80E,0x7FFE,0x701F, 0xF1FF,0xFE7F,0xFF8F,
	0xF7FF,0xF81F,0xFFEF, 0xEFF0,0x0180,0x0FF7, 0xE780,0x07E0,0x01E7,
	0xF20F,0xFFFF,0xF04F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xE007,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFF,0x0000,0xFFFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x8001,0x8FFF,
	0xFE00,0x0000,0x007F, 0xF800,0x0000,0x001F, 0xF000,0x0000,0x000F,
	0xF000,0x0000,0x000F, 0xE000,0x0180,0x0007, 0xE000,0x07E0,0x0007,
	0xF00F,0xFFFF,0xF00F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF
};

struct Image WLWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WLWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WLSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x0660,0x0000, 0x0000,0x0420,0x0000,
	0x0000,0x0420,0x0000, 0x0000,0x0660,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x0180,0x0000, 0x0000,0x03C0,0x0000, 0x0000,0x0E70,0x0000,
	0x0000,0x1C38,0x0000, 0x0000,0x700E,0x0000, 0x0000,0xE007,0x0000,
	0x0001,0x8001,0x8000, 0x0003,0x0180,0xC000, 0x0006,0x0180,0x6000,
	0x0004,0x07E0,0x2000, 0x000C,0x07E0,0x3000, 0x0008,0x0180,0x1000,
	0x0008,0x0180,0x1000, 0x0008,0x0000,0x1000, 0x0008,0x0000,0x1000,
	0x000C,0x0000,0x3000, 0x0004,0x0000,0x2000, 0x0006,0x0FF0,0x6000,
	0x0003,0x3FFC,0xC000, 0x0001,0x700E,0x8000, 0x0000,0xC003,0x0000,
	0x0000,0x8001,0x0000, 0x0001,0x0FF0,0x8000, 0x0001,0x3FFC,0x8000,
	0x0001,0x700E,0x8000, 0x0001,0xC003,0x8000, 0x0001,0xF00F,0x8000,
	0x0000,0x7FFE,0x0000, 0x0000,0x0FF0,0x0000, 0x000E,0x7C3E,0x7000,
	0x01FF,0xF81F,0xFF80, 0x07F1,0x8001,0x8FE0, 0x0E00,0x0180,0x0070,
	0x0800,0x07E0,0x0010, 0x100F,0xFE7F,0xF008, 0x187F,0xF81F,0xFE18,
	0x0DF0,0x0000,0x0FB0, 0x0780,0x0000,0x01E0, 0x0200,0x0000,0x0040,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xFBDF,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF18F,0xFFFF,
	0xFFFF,0xE3C7,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFE7F,0x3FFF, 0xFFF9,0xFE7F,0x9FFF,
	0xFFFB,0xF81F,0xDFFF, 0xFFF3,0xF81F,0xCFFF, 0xFFF7,0xFE7F,0xEFFF,
	0xFFF7,0xFE7F,0xEFFF, 0xFFF7,0xFFFF,0xEFFF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFF3,0xFFFF,0xCFFF, 0xFFFB,0xFFFF,0xDFFF, 0xFFF9,0xF00F,0x9FFF,
	0xFFFC,0xC003,0x3FFF, 0xFFFE,0x8FF1,0x7FFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFE,0xF00F,0x7FFF, 0xFFFE,0xC003,0x7FFF,
	0xFFFE,0x8FF1,0x7FFF, 0xFFFE,0x3FFC,0x7FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x83C1,0x8FFF,
	0xFE00,0x07E0,0x007F, 0xF80E,0x7FFE,0x701F, 0xF1FF,0xFE7F,0xFF8F,
	0xF7FF,0xF81F,0xFFEF, 0xEFF0,0x0180,0x0FF7, 0xE780,0x07E0,0x01E7,
	0xF20F,0xFFFF,0xF04F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xE007,0xFFFF, 0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFC,0x0000,0x3FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF, 0xFFF0,0x0000,0x0FFF,
	0xFFF0,0x0000,0x0FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFF,0x0000,0xFFFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF, 0xFFFE,0x0000,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x8001,0x8FFF,
	0xFE00,0x0000,0x007F, 0xF800,0x0000,0x001F, 0xF000,0x0000,0x000F,
	0xF000,0x0000,0x000F, 0xE000,0x0180,0x0007, 0xE000,0x07E0,0x0007,
	0xF00F,0xFFFF,0xF00F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF
};

struct Image WLSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WLSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SLWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xFBDF,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF18F,0xFFFF,
	0xFFFF,0xE3C7,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFE7F,0x3FFF, 0xFFF9,0xFE7F,0x9FFF,
	0xFFFB,0xF81F,0xDFFF, 0xFFF3,0xF81F,0xCFFF, 0xFFF7,0xFE7F,0xEFFF,
	0xFFF7,0xFE7F,0xEFFF, 0xFFF7,0xFFFF,0xEFFF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFF3,0xFFFF,0xCFFF, 0xFFFB,0xFFFF,0xDFFF, 0xFFF9,0xF00F,0x9FFF,
	0xFFFC,0xC003,0x3FFF, 0xFFFE,0x8FF1,0x7FFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFE,0xF00F,0x7FFF, 0xFFFE,0xC003,0x7FFF,
	0xFFFE,0x8FF1,0x7FFF, 0xFFFE,0x3FFC,0x7FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x83C1,0x8FFF,
	0xFE00,0x07E0,0x007F, 0xF80E,0x7FFE,0x701F, 0xF1FF,0xFE7F,0xFF8F,
	0xF7FF,0xF81F,0xFFEF, 0xEFF0,0x0180,0x0FF7, 0xE780,0x07E0,0x01E7,
	0xF20F,0xFFFF,0xF04F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0180,0xFFFF, 0xFFFE,0x0180,0x7FFF,
	0xFFFC,0x07E0,0x3FFF, 0xFFFC,0x07E0,0x3FFF, 0xFFF8,0x0180,0x1FFF,
	0xFFF8,0x0180,0x1FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x3FFC,0xFFFF, 0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0FF0,0xFFFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFF1,0x8001,0x8FFF, 0xFE00,0x0180,0x007F,
	0xF800,0x07E0,0x001F, 0xF00F,0xFFFF,0xF00F, 0xF87F,0xFFFF,0xFE1F,
	0xFDFF,0xFFFF,0xFFBF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xFBDF,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF18F,0xFFFF,
	0xFFFF,0xE3C7,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFE7F,0x3FFF, 0xFFF9,0xFE7F,0x9FFF,
	0xFFFB,0xF81F,0xDFFF, 0xFFF3,0xF81F,0xCFFF, 0xFFF7,0xFE7F,0xEFFF,
	0xFFF7,0xFE7F,0xEFFF, 0xFFF7,0xFFFF,0xEFFF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFF3,0xFFFF,0xCFFF, 0xFFFB,0xFFFF,0xDFFF, 0xFFF9,0xF00F,0x9FFF,
	0xFFFC,0xC003,0x3FFF, 0xFFFE,0x8FF1,0x7FFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFE,0xF00F,0x7FFF, 0xFFFE,0xC003,0x7FFF,
	0xFFFE,0x8FF1,0x7FFF, 0xFFFE,0x3FFC,0x7FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x83C1,0x8FFF,
	0xFE00,0x07E0,0x007F, 0xF80E,0x7FFE,0x701F, 0xF1FF,0xFE7F,0xFF8F,
	0xF7FF,0xF81F,0xFFEF, 0xEFF0,0x0180,0x0FF7, 0xE780,0x07E0,0x01E7,
	0xF20F,0xFFFF,0xF04F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF
};

struct Image SLWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SLWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SLSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x0FF0,0x0000, 0x0000,0x1FF8,0x0000,
	0x0000,0x7FFE,0x0000, 0x0000,0xFE7F,0x0000, 0x0001,0xFE7F,0x8000,
	0x0003,0xF81F,0xC000, 0x0003,0xF81F,0xC000, 0x0007,0xFE7F,0xE000,
	0x0007,0xFE7F,0xE000, 0x0007,0xFFFF,0xE000, 0x0007,0xFFFF,0xE000,
	0x0003,0xFFFF,0xC000, 0x0003,0xFFFF,0xC000, 0x0001,0xF00F,0x8000,
	0x0000,0xC003,0x0000, 0x0000,0x8FF1,0x0000, 0x0000,0x3FFC,0x0000,
	0x0000,0x7FFE,0x0000, 0x0000,0xF00F,0x0000, 0x0000,0xC003,0x0000,
	0x0000,0x8FF1,0x0000, 0x0000,0x3FFC,0x0000, 0x0000,0x0FF0,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x07E0,0x0000, 0x000E,0x7FFE,0x7000, 0x01FF,0xFE7F,0xFF80,
	0x07FF,0xF81F,0xFFE0, 0x0FF0,0x0000,0x0FF0, 0x0780,0x0000,0x01E0,
	0x0200,0x0000,0x0040, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xE007,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0180,0xFFFF, 0xFFFE,0x0180,0x7FFF,
	0xFFFC,0x07E0,0x3FFF, 0xFFFC,0x07E0,0x3FFF, 0xFFF8,0x0180,0x1FFF,
	0xFFF8,0x0180,0x1FFF, 0xFFF8,0x0000,0x1FFF, 0xFFF8,0x0000,0x1FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFC,0x0000,0x3FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x3FFC,0xFFFF, 0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0x0FF0,0xFFFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x700E,0xFFFF, 0xFFFF,0xC003,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFF1,0x8001,0x8FFF, 0xFE00,0x0180,0x007F,
	0xF800,0x07E0,0x001F, 0xF00F,0xFFFF,0xF00F, 0xF87F,0xFFFF,0xFE1F,
	0xFDFF,0xFFFF,0xFFBF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xFBDF,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF18F,0xFFFF,
	0xFFFF,0xE3C7,0xFFFF, 0xFFFF,0x8FF1,0xFFFF, 0xFFFF,0x1FF8,0xFFFF,
	0xFFFE,0x7FFE,0x7FFF, 0xFFFC,0xFE7F,0x3FFF, 0xFFF9,0xFE7F,0x9FFF,
	0xFFFB,0xF81F,0xDFFF, 0xFFF3,0xF81F,0xCFFF, 0xFFF7,0xFE7F,0xEFFF,
	0xFFF7,0xFE7F,0xEFFF, 0xFFF7,0xFFFF,0xEFFF, 0xFFF7,0xFFFF,0xEFFF,
	0xFFF3,0xFFFF,0xCFFF, 0xFFFB,0xFFFF,0xDFFF, 0xFFF9,0xF00F,0x9FFF,
	0xFFFC,0xC003,0x3FFF, 0xFFFE,0x8FF1,0x7FFF, 0xFFFF,0x3FFC,0xFFFF,
	0xFFFF,0x7FFE,0xFFFF, 0xFFFE,0xF00F,0x7FFF, 0xFFFE,0xC003,0x7FFF,
	0xFFFE,0x8FF1,0x7FFF, 0xFFFE,0x3FFC,0x7FFF, 0xFFFE,0x0FF0,0x7FFF,
	0xFFFF,0x8001,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFF1,0x83C1,0x8FFF,
	0xFE00,0x07E0,0x007F, 0xF80E,0x7FFE,0x701F, 0xF1FF,0xFE7F,0xFF8F,
	0xF7FF,0xF81F,0xFFEF, 0xEFF0,0x0180,0x0FF7, 0xE780,0x07E0,0x01E7,
	0xF20F,0xFFFF,0xF04F, 0xF87F,0xFFFF,0xFE1F, 0xFDFF,0xFFFF,0xFFBF
};

struct Image SLSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SLSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WDWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xFC3F,0xCFFF, 0xFFE1,0xFE7F,0x87FF,
	0xFFE1,0xFFFF,0x87FF, 0xFFF3,0xFFFF,0xCFFF, 0xCFFF,0xFFFF,0xFFF3,
	0x87FF,0xFFFF,0xFFE1, 0x87FB,0xFE7F,0xDFE1, 0xCFFB,0xFE7F,0xDFF3,
	0xFFFB,0xFE7F,0xDFFF, 0xFFFB,0xFE7F,0xDFFF, 0xFFF9,0xFE7F,0x9FFF,
	0xF7F9,0xFE7F,0x9FEF, 0xF7F8,0xFC3F,0x1FEF, 0xF7F8,0xFC3F,0x1FEF,
	0xF3F8,0xFC3F,0x1FCF, 0xFBF8,0x7C3E,0x1FDF, 0xF9F0,0x7C3E,0x0F9F,
	0xF9F0,0x7C3E,0x0F9F, 0xF8F0,0x381C,0x0F1F, 0xF8F0,0x381C,0x0F1F,
	0xF870,0x381C,0x0E1F, 0xF870,0x1998,0x0E1F, 0xF833,0x1FF8,0xCC1F,
	0xFC1F,0xFE7F,0xF83F, 0xFDFC,0xE007,0x3FBF, 0xFFE0,0x0000,0x07FF,
	0xFE00,0x0000,0x007F, 0xFE00,0x3FFC,0x007F, 0xFF07,0xFFFF,0xE0FF,
	0xFF3F,0xC003,0xFCFF, 0xFFF8,0x0000,0x1FFF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFE3,0xFFFF,0xC7FF, 0xFFFF,0xC003,0xFFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x7FFE,0x07FF,
	0xFFCF,0xFFFF,0xF3FF, 0xFFFF,0x8001,0xFFFF, 0xFFF0,0x0000,0x0FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF99F,0xCFFF,
	0xFFE1,0xFBDF,0x87FF, 0xFFCC,0xFBDF,0x33FF, 0xFFDE,0xF99F,0x7BFF,
	0xCFDE,0xFC3F,0x7BF3, 0x87CC,0xFE7F,0x33E1, 0x33E1,0xFE7F,0x87CC,
	0x7BF3,0xFE7F,0xCFDE, 0x7BF5,0xFDBF,0xAFDE, 0x33F5,0xFDBF,0xAFCC,
	0x87F5,0xFDBF,0xAFE1, 0xC7F4,0xFDBF,0x2FE3, 0xE3F6,0xFDBF,0x6FC7,
	0xEBF6,0x799E,0x6FD7, 0xEBF7,0x7BDE,0xEFD7, 0xE9F7,0x7BDE,0xEF97,
	0xEDF7,0x3BDC,0xEFB7, 0xE4E7,0xBBDD,0xE727, 0xF6EF,0xBBDD,0xF76F,
	0xF66F,0x93C9,0xF66F, 0xF76F,0xD7EB,0xF6EF, 0xF72F,0xD7EB,0xF4EF,
	0xF7AF,0xC7E3,0xF5EF, 0xF78F,0xE667,0xF1EF, 0xF7CC,0xE007,0x33EF,
	0xF3E0,0x0180,0x07CF, 0xFA03,0x1FF8,0xC05F, 0xF81F,0xFFFF,0xF81F,
	0xF9FF,0xFFFF,0xFF9F, 0xFDFF,0xC003,0xFFBF, 0xFEF8,0x0000,0x1F7F,
	0xFEC0,0x3FFC,0x037F, 0xFF07,0xFFFF,0xE0FF, 0xFFBF,0xFFFF,0xFDFF,
	0xFFBF,0xC003,0xFDFF, 0xFFDC,0x0000,0x3BFF, 0xFFC0,0x3FFC,0x03FF,
	0xFFC3,0xFFFF,0xC3FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0x8001,0xFBFF,
	0xFFB0,0x0000,0x0DFF, 0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF1FF,
	0xFFE3,0xFFFF,0xC7FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF,
	/* BitPlane 2 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF81F,0xCFFF,
	0xFFE1,0xF81F,0x87FF, 0xFFC0,0xF81F,0x03FF, 0xFFC0,0xF81F,0x03FF,
	0xCFC0,0xFC3F,0x03F3, 0x87C0,0xFE7F,0x03E1, 0x03E1,0xFE7F,0x87C0,
	0x03F3,0xFE7F,0xCFC0, 0x03F1,0xFC3F,0x8FC0, 0x03F1,0xFC3F,0x8FC0,
	0x87F1,0xFC3F,0x8FE1, 0xC7F0,0xFC3F,0x0FE3, 0xE3F0,0xFC3F,0x0FC7,
	0xE3F0,0x781E,0x0FC7, 0xE3F0,0x781E,0x0FC7, 0xE1F0,0x781E,0x0F87,
	0xE1F0,0x381C,0x0F87, 0xE0E0,0x381C,0x0707, 0xF0E0,0x381C,0x070F,
	0xF060,0x1008,0x060F, 0xF060,0x1008,0x060F, 0xF020,0x1008,0x040F,
	0xF020,0x0000,0x040F, 0xF000,0x0000,0x000F, 0xF000,0x0000,0x000F,
	0xF000,0x0000,0x000F, 0xF800,0x0000,0x001F, 0xF800,0x0000,0x001F,
	0xF800,0x0000,0x001F, 0xFC00,0x0000,0x003F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFF00,0x0000,0x00FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFFE0,0x0000,0x07FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF
};

struct Image WDWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WDWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WDSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0180,0x0000, 0x0000,0x03C0,0x0000, 0x000C,0x0660,0x3000,
	0x001E,0x0420,0x7800, 0x0033,0x0420,0xCC00, 0x0021,0x0660,0x8400,
	0x3021,0x03C0,0x840C, 0x7833,0x0180,0xCC1E, 0xCC1E,0x0180,0x7833,
	0x840C,0x0180,0x3021, 0x840A,0x0240,0x5021, 0xCC0A,0x0240,0x5033,
	0x780A,0x0240,0x501E, 0x380B,0x0240,0xD01C, 0x1C09,0x0240,0x9038,
	0x1409,0x8661,0x9028, 0x1408,0x8421,0x1028, 0x1608,0x8421,0x1068,
	0x1208,0xC423,0x1048, 0x1B18,0x4422,0x18D8, 0x0910,0x4422,0x0890,
	0x0990,0x6C36,0x0990, 0x0890,0x2814,0x0910, 0x08D0,0x2814,0x0B10,
	0x0850,0x381C,0x0A10, 0x0870,0x1998,0x0E10, 0x0833,0x1FF8,0xCC10,
	0x0C1F,0xFE7F,0xF830, 0x05FC,0xE007,0x3FA0, 0x07E0,0x0000,0x07E0,
	0x0600,0x0000,0x0060, 0x0200,0x3FFC,0x0040, 0x0107,0xFFFF,0xE080,
	0x013F,0xC003,0xFC80, 0x00F8,0x0000,0x1F00, 0x0040,0x0000,0x0200,
	0x0040,0x3FFC,0x0200, 0x0023,0xFFFF,0xC400, 0x003F,0xC003,0xFC00,
	0x003C,0x0000,0x3C00, 0x0020,0x0000,0x0400, 0x0020,0x7FFE,0x0400,
	0x004F,0xFFFF,0xF200, 0x007F,0x8001,0xFE00, 0x0070,0x0000,0x0E00,
	0x001C,0x0000,0x3800, 0x000F,0xFFFF,0xF000, 0x0003,0xFFFF,0xC000,
	/* BitPlane 1 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF99F,0xCFFF,
	0xFFE1,0xFBDF,0x87FF, 0xFFCC,0xFBDF,0x33FF, 0xFFDE,0xF99F,0x7BFF,
	0xCFDE,0xFC3F,0x7BF3, 0x87CC,0xFE7F,0x33E1, 0x33E1,0xFE7F,0x87CC,
	0x7BF3,0xFE7F,0xCFDE, 0x7BF5,0xFDBF,0xAFDE, 0x33F5,0xFDBF,0xAFCC,
	0x87F5,0xFDBF,0xAFE1, 0xC7F4,0xFDBF,0x2FE3, 0xE3F6,0xFDBF,0x6FC7,
	0xEBF6,0x799E,0x6FD7, 0xEBF7,0x7BDE,0xEFD7, 0xE9F7,0x7BDE,0xEF97,
	0xEDF7,0x3BDC,0xEFB7, 0xE4E7,0xBBDD,0xE727, 0xF6EF,0xBBDD,0xF76F,
	0xF66F,0x93C9,0xF66F, 0xF76F,0xD7EB,0xF6EF, 0xF72F,0xD7EB,0xF4EF,
	0xF7AF,0xC7E3,0xF5EF, 0xF78F,0xE667,0xF1EF, 0xF7CC,0xE007,0x33EF,
	0xF3E0,0x0180,0x07CF, 0xFA03,0x1FF8,0xC05F, 0xF81F,0xFFFF,0xF81F,
	0xF9FF,0xFFFF,0xFF9F, 0xFDFF,0xC003,0xFFBF, 0xFEF8,0x0000,0x1F7F,
	0xFEC0,0x3FFC,0x037F, 0xFF07,0xFFFF,0xE0FF, 0xFFBF,0xFFFF,0xFDFF,
	0xFFBF,0xC003,0xFDFF, 0xFFDC,0x0000,0x3BFF, 0xFFC0,0x3FFC,0x03FF,
	0xFFC3,0xFFFF,0xC3FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0x8001,0xFBFF,
	0xFFB0,0x0000,0x0DFF, 0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF1FF,
	0xFFE3,0xFFFF,0xC7FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF,
	/* BitPlane 2 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF81F,0xCFFF,
	0xFFE1,0xF81F,0x87FF, 0xFFC0,0xF81F,0x03FF, 0xFFC0,0xF81F,0x03FF,
	0xCFC0,0xFC3F,0x03F3, 0x87C0,0xFE7F,0x03E1, 0x03E1,0xFE7F,0x87C0,
	0x03F3,0xFE7F,0xCFC0, 0x03F1,0xFC3F,0x8FC0, 0x03F1,0xFC3F,0x8FC0,
	0x87F1,0xFC3F,0x8FE1, 0xC7F0,0xFC3F,0x0FE3, 0xE3F0,0xFC3F,0x0FC7,
	0xE3F0,0x781E,0x0FC7, 0xE3F0,0x781E,0x0FC7, 0xE1F0,0x781E,0x0F87,
	0xE1F0,0x381C,0x0F87, 0xE0E0,0x381C,0x0707, 0xF0E0,0x381C,0x070F,
	0xF060,0x1008,0x060F, 0xF060,0x1008,0x060F, 0xF020,0x1008,0x040F,
	0xF020,0x0000,0x040F, 0xF000,0x0000,0x000F, 0xF000,0x0000,0x000F,
	0xF000,0x0000,0x000F, 0xF800,0x0000,0x001F, 0xF800,0x0000,0x001F,
	0xF800,0x0000,0x001F, 0xFC00,0x0000,0x003F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFF00,0x0000,0x00FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x0000,0x03FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFFE0,0x0000,0x07FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF
};

struct Image WDSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WDSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SDWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF99F,0xCFFF,
	0xFFE1,0xFBDF,0x87FF, 0xFFCC,0xFBDF,0x33FF, 0xFFDE,0xF99F,0x7BFF,
	0xCFDE,0xFC3F,0x7BF3, 0x87CC,0xFE7F,0x33E1, 0x33E1,0xFE7F,0x87CC,
	0x7BF3,0xFE7F,0xCFDE, 0x7BF5,0xFDBF,0xAFDE, 0x33F5,0xFDBF,0xAFCC,
	0x87F5,0xFDBF,0xAFE1, 0xC7F4,0xFDBF,0x2FE3, 0xE3F6,0xFDBF,0x6FC7,
	0xEBF6,0x799E,0x6FD7, 0xEBF7,0x7BDE,0xEFD7, 0xE9F7,0x7BDE,0xEF97,
	0xEDF7,0x3BDC,0xEFB7, 0xE4E7,0xBBDD,0xE727, 0xF6EF,0xBBDD,0xF76F,
	0xF66F,0x93C9,0xF66F, 0xF76F,0xD7EB,0xF6EF, 0xF72F,0xD7EB,0xF4EF,
	0xF7AF,0xC7E3,0xF5EF, 0xF78F,0xE667,0xF1EF, 0xF7CC,0xE007,0x33EF,
	0xF3E0,0x0180,0x07CF, 0xFA03,0x1FF8,0xC05F, 0xF81F,0xFFFF,0xF81F,
	0xF9FF,0xFFFF,0xFF9F, 0xFDFF,0xC003,0xFFBF, 0xFEF8,0x0000,0x1F7F,
	0xFEC0,0x3FFC,0x037F, 0xFF07,0xFFFF,0xE0FF, 0xFFBF,0xFFFF,0xFDFF,
	0xFFBF,0xC003,0xFDFF, 0xFFDC,0x0000,0x3BFF, 0xFFC0,0x3FFC,0x03FF,
	0xFFC3,0xFFFF,0xC3FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0x8001,0xFBFF,
	0xFFB0,0x0000,0x0DFF, 0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF1FF,
	0xFFE3,0xFFFF,0xC7FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xFC3F,0xCFFF, 0xFFE1,0xFE7F,0x87FF,
	0xFFE1,0xFFFF,0x87FF, 0xFFF3,0xFFFF,0xCFFF, 0xCFFF,0xFFFF,0xFFF3,
	0x87FF,0xFFFF,0xFFE1, 0x87FB,0xFE7F,0xDFE1, 0xCFFB,0xFE7F,0xDFF3,
	0xFFFB,0xFE7F,0xDFFF, 0xFFFB,0xFE7F,0xDFFF, 0xFFF9,0xFE7F,0x9FFF,
	0xF7F9,0xFE7F,0x9FEF, 0xF7F8,0xFC3F,0x1FEF, 0xF7F8,0xFC3F,0x1FEF,
	0xF3F8,0xFC3F,0x1FCF, 0xFBF8,0x7C3E,0x1FDF, 0xF9F0,0x7C3E,0x0F9F,
	0xF9F0,0x7C3E,0x0F9F, 0xF8F0,0x381C,0x0F1F, 0xF8F0,0x381C,0x0F1F,
	0xF870,0x381C,0x0E1F, 0xF870,0x1998,0x0E1F, 0xF833,0x1FF8,0xCC1F,
	0xFC1F,0xFE7F,0xF83F, 0xFDFC,0xE007,0x3FBF, 0xFFE0,0x0000,0x07FF,
	0xFE00,0x0000,0x007F, 0xFE00,0x3FFC,0x007F, 0xFF07,0xFFFF,0xE0FF,
	0xFF3F,0xC003,0xFCFF, 0xFFF8,0x0000,0x1FFF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFE3,0xFFFF,0xC7FF, 0xFFFF,0xC003,0xFFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x7FFE,0x07FF,
	0xFFCF,0xFFFF,0xF3FF, 0xFFFF,0x8001,0xFFFF, 0xFFF0,0x0000,0x0FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF99F,0xCFFF,
	0xFFE1,0xFBDF,0x87FF, 0xFFCC,0xFBDF,0x33FF, 0xFFDE,0xF99F,0x7BFF,
	0xCFDE,0xFC3F,0x7BF3, 0x87CC,0xFE7F,0x33E1, 0x33E1,0xFE7F,0x87CC,
	0x7BF3,0xFE7F,0xCFDE, 0x7BF5,0xFDBF,0xAFDE, 0x33F5,0xFDBF,0xAFCC,
	0x87F5,0xFDBF,0xAFE1, 0xC7F4,0xFDBF,0x2FE3, 0xE3F6,0xFDBF,0x6FC7,
	0xEBF6,0x799E,0x6FD7, 0xEBF7,0x7BDE,0xEFD7, 0xE9F7,0x7BDE,0xEF97,
	0xEDF7,0x3BDC,0xEFB7, 0xE4E7,0xBBDD,0xE727, 0xF6EF,0xBBDD,0xF76F,
	0xF66F,0x93C9,0xF66F, 0xF76F,0xD7EB,0xF6EF, 0xF72F,0xD7EB,0xF4EF,
	0xF7AF,0xC7E3,0xF5EF, 0xF78F,0xE667,0xF1EF, 0xF7CC,0xE007,0x33EF,
	0xF3E0,0x0180,0x07CF, 0xFA03,0x1FF8,0xC05F, 0xF81F,0xFFFF,0xF81F,
	0xF9FF,0xFFFF,0xFF9F, 0xFDFF,0xC003,0xFFBF, 0xFEF8,0x0000,0x1F7F,
	0xFEC0,0x3FFC,0x037F, 0xFF07,0xFFFF,0xE0FF, 0xFFBF,0xFFFF,0xFDFF,
	0xFFBF,0xC003,0xFDFF, 0xFFDC,0x0000,0x3BFF, 0xFFC0,0x3FFC,0x03FF,
	0xFFC3,0xFFFF,0xC3FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0x8001,0xFBFF,
	0xFFB0,0x0000,0x0DFF, 0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF1FF,
	0xFFE3,0xFFFF,0xC7FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF
};

struct Image SDWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SDWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SDSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000,
	0x0000,0x03C0,0x0000, 0x000C,0x03C0,0x3000, 0x001E,0x0180,0x7800,
	0x001E,0x0000,0x7800, 0x000C,0x0000,0x3000, 0x3000,0x0000,0x000C,
	0x7800,0x0000,0x001E, 0x7804,0x0180,0x201E, 0x3004,0x0180,0x200C,
	0x0004,0x0180,0x2000, 0x0004,0x0180,0x2000, 0x0006,0x0180,0x6000,
	0x0806,0x0180,0x6010, 0x0807,0x03C0,0xE010, 0x0807,0x03C0,0xE010,
	0x0C07,0x03C0,0xE030, 0x0407,0x83C1,0xE020, 0x060F,0x83C1,0xF060,
	0x060F,0x83C1,0xF060, 0x070F,0xC7E3,0xF0E0, 0x070F,0xC7E3,0xF0E0,
	0x078F,0xC7E3,0xF1E0, 0x078F,0xE667,0xF1E0, 0x07CC,0xE007,0x33E0,
	0x03E0,0x0180,0x07C0, 0x0203,0x1FF8,0xC040, 0x001F,0xFFFF,0xF800,
	0x01FF,0xFFFF,0xFF80, 0x01FF,0xC003,0xFF80, 0x00F8,0x0000,0x1F00,
	0x00C0,0x3FFC,0x0300, 0x0007,0xFFFF,0xE000, 0x003F,0xFFFF,0xFC00,
	0x003F,0xC003,0xFC00, 0x001C,0x0000,0x3800, 0x0000,0x3FFC,0x0000,
	0x0003,0xFFFF,0xC000, 0x001F,0xFFFF,0xF800, 0x001F,0x8001,0xF800,
	0x0030,0x0000,0x0C00, 0x0000,0x7FFE,0x0000, 0x000F,0xFFFF,0xF000,
	0x0003,0xFFFF,0xC000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xFC3F,0xCFFF, 0xFFE1,0xFE7F,0x87FF,
	0xFFE1,0xFFFF,0x87FF, 0xFFF3,0xFFFF,0xCFFF, 0xCFFF,0xFFFF,0xFFF3,
	0x87FF,0xFFFF,0xFFE1, 0x87FB,0xFE7F,0xDFE1, 0xCFFB,0xFE7F,0xDFF3,
	0xFFFB,0xFE7F,0xDFFF, 0xFFFB,0xFE7F,0xDFFF, 0xFFF9,0xFE7F,0x9FFF,
	0xF7F9,0xFE7F,0x9FEF, 0xF7F8,0xFC3F,0x1FEF, 0xF7F8,0xFC3F,0x1FEF,
	0xF3F8,0xFC3F,0x1FCF, 0xFBF8,0x7C3E,0x1FDF, 0xF9F0,0x7C3E,0x0F9F,
	0xF9F0,0x7C3E,0x0F9F, 0xF8F0,0x381C,0x0F1F, 0xF8F0,0x381C,0x0F1F,
	0xF870,0x381C,0x0E1F, 0xF870,0x1998,0x0E1F, 0xF833,0x1FF8,0xCC1F,
	0xFC1F,0xFE7F,0xF83F, 0xFDFC,0xE007,0x3FBF, 0xFFE0,0x0000,0x07FF,
	0xFE00,0x0000,0x007F, 0xFE00,0x3FFC,0x007F, 0xFF07,0xFFFF,0xE0FF,
	0xFF3F,0xC003,0xFCFF, 0xFFF8,0x0000,0x1FFF, 0xFFC0,0x0000,0x03FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFE3,0xFFFF,0xC7FF, 0xFFFF,0xC003,0xFFFF,
	0xFFFC,0x0000,0x3FFF, 0xFFE0,0x0000,0x07FF, 0xFFE0,0x7FFE,0x07FF,
	0xFFCF,0xFFFF,0xF3FF, 0xFFFF,0x8001,0xFFFF, 0xFFF0,0x0000,0x0FFF,
	0xFFFC,0x0000,0x3FFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF, 0xFFF3,0xF99F,0xCFFF,
	0xFFE1,0xFBDF,0x87FF, 0xFFCC,0xFBDF,0x33FF, 0xFFDE,0xF99F,0x7BFF,
	0xCFDE,0xFC3F,0x7BF3, 0x87CC,0xFE7F,0x33E1, 0x33E1,0xFE7F,0x87CC,
	0x7BF3,0xFE7F,0xCFDE, 0x7BF5,0xFDBF,0xAFDE, 0x33F5,0xFDBF,0xAFCC,
	0x87F5,0xFDBF,0xAFE1, 0xC7F4,0xFDBF,0x2FE3, 0xE3F6,0xFDBF,0x6FC7,
	0xEBF6,0x799E,0x6FD7, 0xEBF7,0x7BDE,0xEFD7, 0xE9F7,0x7BDE,0xEF97,
	0xEDF7,0x3BDC,0xEFB7, 0xE4E7,0xBBDD,0xE727, 0xF6EF,0xBBDD,0xF76F,
	0xF66F,0x93C9,0xF66F, 0xF76F,0xD7EB,0xF6EF, 0xF72F,0xD7EB,0xF4EF,
	0xF7AF,0xC7E3,0xF5EF, 0xF78F,0xE667,0xF1EF, 0xF7CC,0xE007,0x33EF,
	0xF3E0,0x0180,0x07CF, 0xFA03,0x1FF8,0xC05F, 0xF81F,0xFFFF,0xF81F,
	0xF9FF,0xFFFF,0xFF9F, 0xFDFF,0xC003,0xFFBF, 0xFEF8,0x0000,0x1F7F,
	0xFEC0,0x3FFC,0x037F, 0xFF07,0xFFFF,0xE0FF, 0xFFBF,0xFFFF,0xFDFF,
	0xFFBF,0xC003,0xFDFF, 0xFFDC,0x0000,0x3BFF, 0xFFC0,0x3FFC,0x03FF,
	0xFFC3,0xFFFF,0xC3FF, 0xFFDF,0xFFFF,0xFBFF, 0xFFDF,0x8001,0xFBFF,
	0xFFB0,0x0000,0x0DFF, 0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF1FF,
	0xFFE3,0xFFFF,0xC7FF, 0xFFF0,0x0000,0x0FFF, 0xFFFC,0x0000,0x3FFF
};

struct Image SDSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SDSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WKWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFE0F,0xF81F,0xF07F, 0xF803,0xFC3F,0xC01F,
	0xF000,0xFC3F,0x000F, 0xF000,0x3C3C,0x000F, 0xE000,0x1C38,0x0007,
	0xE000,0x0C30,0x0007, 0xF000,0x0660,0x000F, 0xF000,0x0240,0x000F,
	0xF800,0x0240,0x001F, 0xF800,0x0180,0x001F, 0xFC00,0x0180,0x003F,
	0xFE00,0x0180,0x007F, 0xFF00,0x0180,0x00FF, 0xFF00,0x0180,0x00FF,
	0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF9FF, 0xFFFF,0x8001,0xFFFF,
	0xFFF0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x7FFE,0x03FF,
	0xFFDF,0xFFFF,0xFBFF, 0xFFFF,0x8001,0xFFFF, 0xFFE0,0x0000,0x07FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFC7,0xFFFF,0xE3FF, 0xFFFF,0xC003,0xFFFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF7EF,0xFFFF,
	0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xF7EF,0xFFFF, 0xFE0F,0xF7EF,0xF07F,
	0xF803,0xF7EF,0xC01F, 0xF1F0,0xF7EF,0x0F8F, 0xE7FC,0x33CC,0x3FE7,
	0xEFFF,0x1BD8,0xFFF7, 0xCFFF,0xCBD3,0xFFF3, 0xDFFF,0xE3C7,0xFFFB,
	0xDFFF,0xF3CF,0xFFFB, 0xCFFF,0xF99F,0xFFF3, 0xEFFF,0xFDBF,0xFFF7,
	0xE7FF,0xFDBF,0xFFE7, 0xF7FF,0xFE7F,0xFFEF, 0xF3FF,0xFE7F,0xFFCF,
	0xF9FF,0xFE7F,0xFF9F, 0xFCFF,0xFE7F,0xFF3F, 0xFEFF,0xFE7F,0xFF7F,
	0xFE7F,0x8001,0xFE7F, 0xFF70,0x0000,0x06FF, 0xFF00,0x7FFE,0x00FF,
	0xFF8F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0x8001,0xFDFF,
	0xFFA0,0x0000,0x05FF, 0xFF80,0x7FFE,0x01FF, 0xFF9F,0xFFFF,0xF9FF,
	0xFFBF,0xC003,0xFDFF, 0xFFB8,0x0000,0x1DFF, 0xFF80,0x3FFC,0x01FF,
	0xFF87,0xFFFF,0xE1FF, 0xFF8F,0xFFFF,0xF1FF, 0xFFE0,0xFFFF,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFE0F,0xF00F,0xF07F,
	0xF803,0xF00F,0xC01F, 0xF000,0xF00F,0x000F, 0xE000,0x300C,0x0007,
	0xE000,0x1818,0x0007, 0xC000,0x0810,0x0003, 0xC000,0x0000,0x0003,
	0xC000,0x0000,0x0003, 0xC000,0x0000,0x0003, 0xE000,0x0000,0x0007,
	0xE000,0x0000,0x0007, 0xF000,0x0000,0x000F, 0xF000,0x0000,0x000F,
	0xF800,0x0000,0x001F, 0xFC00,0x0000,0x003F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFFE0,0x0000,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WKWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WKWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip WKSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x0660,0x0000, 0x0000,0x0E70,0x0000, 0x0000,0x0810,0x0000,
	0x0000,0x0E70,0x0000, 0x0000,0x0660,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x0660,0x0000, 0x0000,0x0420,0x0000,
	0x0000,0x0C30,0x0000, 0x0000,0x0810,0x0000, 0x01F0,0x0810,0x0F80,
	0x07FC,0x0810,0x3FE0, 0x0E0F,0x0810,0xF070, 0x1803,0xCC33,0xC018,
	0x1000,0xE427,0x0008, 0x3000,0x342C,0x000C, 0x2000,0x1C38,0x0004,
	0x2000,0x0C30,0x0004, 0x3000,0x0660,0x000C, 0x1000,0x0240,0x0008,
	0x1800,0x0240,0x0018, 0x0800,0x0180,0x0010, 0x0C00,0x0180,0x0030,
	0x0600,0x0180,0x0060, 0x0300,0x0180,0x00C0, 0x0100,0x0180,0x0080,
	0x0180,0x7FFE,0x0180, 0x008F,0xFFFF,0xF900, 0x00FF,0x8001,0xFF00,
	0x0070,0x0000,0x0600, 0x0040,0x0000,0x0200, 0x0040,0x7FFE,0x0200,
	0x005F,0xFFFF,0xFA00, 0x007F,0x8001,0xFE00, 0x0060,0x0000,0x0600,
	0x0040,0x3FFC,0x0200, 0x0047,0xFFFF,0xE200, 0x007F,0xC003,0xFE00,
	0x0078,0x0000,0x1E00, 0x0070,0x0000,0x0E00, 0x001F,0x0000,0xF800,
	0x000F,0xFFFF,0xF000, 0x0000,0xFFFF,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF7EF,0xFFFF,
	0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xF7EF,0xFFFF, 0xFE0F,0xF7EF,0xF07F,
	0xF803,0xF7EF,0xC01F, 0xF1F0,0xF7EF,0x0F8F, 0xE7FC,0x33CC,0x3FE7,
	0xEFFF,0x1BD8,0xFFF7, 0xCFFF,0xCBD3,0xFFF3, 0xDFFF,0xE3C7,0xFFFB,
	0xDFFF,0xF3CF,0xFFFB, 0xCFFF,0xF99F,0xFFF3, 0xEFFF,0xFDBF,0xFFF7,
	0xE7FF,0xFDBF,0xFFE7, 0xF7FF,0xFE7F,0xFFEF, 0xF3FF,0xFE7F,0xFFCF,
	0xF9FF,0xFE7F,0xFF9F, 0xFCFF,0xFE7F,0xFF3F, 0xFEFF,0xFE7F,0xFF7F,
	0xFE7F,0x8001,0xFE7F, 0xFF70,0x0000,0x06FF, 0xFF00,0x7FFE,0x00FF,
	0xFF8F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0x8001,0xFDFF,
	0xFFA0,0x0000,0x05FF, 0xFF80,0x7FFE,0x01FF, 0xFF9F,0xFFFF,0xF9FF,
	0xFFBF,0xC003,0xFDFF, 0xFFB8,0x0000,0x1DFF, 0xFF80,0x3FFC,0x01FF,
	0xFF87,0xFFFF,0xE1FF, 0xFF8F,0xFFFF,0xF1FF, 0xFFE0,0xFFFF,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF00F,0xFFFF, 0xFFFF,0xF00F,0xFFFF, 0xFE0F,0xF00F,0xF07F,
	0xF803,0xF00F,0xC01F, 0xF000,0xF00F,0x000F, 0xE000,0x300C,0x0007,
	0xE000,0x1818,0x0007, 0xC000,0x0810,0x0003, 0xC000,0x0000,0x0003,
	0xC000,0x0000,0x0003, 0xC000,0x0000,0x0003, 0xE000,0x0000,0x0007,
	0xE000,0x0000,0x0007, 0xF000,0x0000,0x000F, 0xF000,0x0000,0x000F,
	0xF800,0x0000,0x001F, 0xFC00,0x0000,0x003F, 0xFE00,0x0000,0x007F,
	0xFE00,0x0000,0x007F, 0xFF00,0x0000,0x00FF, 0xFF00,0x0000,0x00FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF,
	0xFF80,0x0000,0x01FF, 0xFF80,0x0000,0x01FF, 0xFFE0,0x0000,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image WKSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	WKSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SKWFData[] = {
	/* BitPlane 0 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF7EF,0xFFFF,
	0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xF7EF,0xFFFF, 0xFE0F,0xF7EF,0xF07F,
	0xF803,0xF7EF,0xC01F, 0xF1F0,0xF7EF,0x0F8F, 0xE7FC,0x33CC,0x3FE7,
	0xEFFF,0x1BD8,0xFFF7, 0xCFFF,0xCBD3,0xFFF3, 0xDFFF,0xE3C7,0xFFFB,
	0xDFFF,0xF3CF,0xFFFB, 0xCFFF,0xF99F,0xFFF3, 0xEFFF,0xFDBF,0xFFF7,
	0xE7FF,0xFDBF,0xFFE7, 0xF7FF,0xFE7F,0xFFEF, 0xF3FF,0xFE7F,0xFFCF,
	0xF9FF,0xFE7F,0xFF9F, 0xFCFF,0xFE7F,0xFF3F, 0xFEFF,0xFE7F,0xFF7F,
	0xFE7F,0x8001,0xFE7F, 0xFF70,0x0000,0x06FF, 0xFF00,0x7FFE,0x00FF,
	0xFF8F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0x8001,0xFDFF,
	0xFFA0,0x0000,0x05FF, 0xFF80,0x7FFE,0x01FF, 0xFF9F,0xFFFF,0xF9FF,
	0xFFBF,0xC003,0xFDFF, 0xFFB8,0x0000,0x1DFF, 0xFF80,0x3FFC,0x01FF,
	0xFF87,0xFFFF,0xE1FF, 0xFF8F,0xFFFF,0xF1FF, 0xFFE0,0xFFFF,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFE0F,0xF81F,0xF07F, 0xF803,0xFC3F,0xC01F,
	0xF000,0xFC3F,0x000F, 0xF000,0x3C3C,0x000F, 0xE000,0x1C38,0x0007,
	0xE000,0x0C30,0x0007, 0xF000,0x0660,0x000F, 0xF000,0x0240,0x000F,
	0xF800,0x0240,0x001F, 0xF800,0x0180,0x001F, 0xFC00,0x0180,0x003F,
	0xFE00,0x0180,0x007F, 0xFF00,0x0180,0x00FF, 0xFF00,0x0180,0x00FF,
	0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF9FF, 0xFFFF,0x8001,0xFFFF,
	0xFFF0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x7FFE,0x03FF,
	0xFFDF,0xFFFF,0xFBFF, 0xFFFF,0x8001,0xFFFF, 0xFFE0,0x0000,0x07FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFC7,0xFFFF,0xE3FF, 0xFFFF,0xC003,0xFFFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF7EF,0xFFFF,
	0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xF7EF,0xFFFF, 0xFE0F,0xF7EF,0xF07F,
	0xF803,0xF7EF,0xC01F, 0xF1F0,0xF7EF,0x0F8F, 0xE7FC,0x33CC,0x3FE7,
	0xEFFF,0x1BD8,0xFFF7, 0xCFFF,0xCBD3,0xFFF3, 0xDFFF,0xE3C7,0xFFFB,
	0xDFFF,0xF3CF,0xFFFB, 0xCFFF,0xF99F,0xFFF3, 0xEFFF,0xFDBF,0xFFF7,
	0xE7FF,0xFDBF,0xFFE7, 0xF7FF,0xFE7F,0xFFEF, 0xF3FF,0xFE7F,0xFFCF,
	0xF9FF,0xFE7F,0xFF9F, 0xFCFF,0xFE7F,0xFF3F, 0xFEFF,0xFE7F,0xFF7F,
	0xFE7F,0x8001,0xFE7F, 0xFF70,0x0000,0x06FF, 0xFF00,0x7FFE,0x00FF,
	0xFF8F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0x8001,0xFDFF,
	0xFFA0,0x0000,0x05FF, 0xFF80,0x7FFE,0x01FF, 0xFF9F,0xFFFF,0xF9FF,
	0xFFBF,0xC003,0xFDFF, 0xFFB8,0x0000,0x1DFF, 0xFF80,0x3FFC,0x01FF,
	0xFF87,0xFFFF,0xE1FF, 0xFF8F,0xFFFF,0xF1FF, 0xFFE0,0xFFFF,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SKWFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SKWFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

static UWORD __chip SKSFData[] = {
	/* BitPlane 0 */
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0180,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x07E0,0x0000,
	0x0000,0x0180,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0180,0x0000, 0x0000,0x03C0,0x0000,
	0x0000,0x03C0,0x0000, 0x0000,0x07E0,0x0000, 0x0000,0x07E0,0x0000,
	0x0000,0x07E0,0x0000, 0x01F0,0x07E0,0x0F80, 0x07FC,0x03C0,0x3FE0,
	0x0FFF,0x03C0,0xFFF0, 0x0FFF,0xC3C3,0xFFF0, 0x1FFF,0xE3C7,0xFFF8,
	0x1FFF,0xF3CF,0xFFF8, 0x0FFF,0xF99F,0xFFF0, 0x0FFF,0xFDBF,0xFFF0,
	0x07FF,0xFDBF,0xFFE0, 0x07FF,0xFE7F,0xFFE0, 0x03FF,0xFE7F,0xFFC0,
	0x01FF,0xFE7F,0xFF80, 0x00FF,0xFE7F,0xFF00, 0x00FF,0xFE7F,0xFF00,
	0x007F,0x8001,0xFE00, 0x0070,0x0000,0x0600, 0x0000,0x7FFE,0x0000,
	0x000F,0xFFFF,0xF800, 0x003F,0xFFFF,0xFC00, 0x003F,0x8001,0xFC00,
	0x0020,0x0000,0x0400, 0x0000,0x7FFE,0x0000, 0x001F,0xFFFF,0xF800,
	0x003F,0xC003,0xFC00, 0x0038,0x0000,0x1C00, 0x0000,0x3FFC,0x0000,
	0x0007,0xFFFF,0xE000, 0x000F,0xFFFF,0xF000, 0x0000,0xFFFF,0x0000,
	0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000, 0x0000,0x0000,0x0000,
	/* BitPlane 1 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF81F,0xFFFF, 0xFFFF,0xF81F,0xFFFF,
	0xFFFF,0xF81F,0xFFFF, 0xFE0F,0xF81F,0xF07F, 0xF803,0xFC3F,0xC01F,
	0xF000,0xFC3F,0x000F, 0xF000,0x3C3C,0x000F, 0xE000,0x1C38,0x0007,
	0xE000,0x0C30,0x0007, 0xF000,0x0660,0x000F, 0xF000,0x0240,0x000F,
	0xF800,0x0240,0x001F, 0xF800,0x0180,0x001F, 0xFC00,0x0180,0x003F,
	0xFE00,0x0180,0x007F, 0xFF00,0x0180,0x00FF, 0xFF00,0x0180,0x00FF,
	0xFF80,0x7FFE,0x01FF, 0xFF8F,0xFFFF,0xF9FF, 0xFFFF,0x8001,0xFFFF,
	0xFFF0,0x0000,0x07FF, 0xFFC0,0x0000,0x03FF, 0xFFC0,0x7FFE,0x03FF,
	0xFFDF,0xFFFF,0xFBFF, 0xFFFF,0x8001,0xFFFF, 0xFFE0,0x0000,0x07FF,
	0xFFC0,0x3FFC,0x03FF, 0xFFC7,0xFFFF,0xE3FF, 0xFFFF,0xC003,0xFFFF,
	0xFFF8,0x0000,0x1FFF, 0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF,
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFFFF,0xFFFF,
	/* BitPlane 2 */
	0xFFFF,0xFFFF,0xFFFF, 0xFFFF,0xFE7F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF7EF,0xFFFF,
	0xFFFF,0xF18F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFC3F,0xFFFF,
	0xFFFF,0xFC3F,0xFFFF, 0xFFFF,0xF99F,0xFFFF, 0xFFFF,0xFBDF,0xFFFF,
	0xFFFF,0xF3CF,0xFFFF, 0xFFFF,0xF7EF,0xFFFF, 0xFE0F,0xF7EF,0xF07F,
	0xF803,0xF7EF,0xC01F, 0xF1F0,0xF7EF,0x0F8F, 0xE7FC,0x33CC,0x3FE7,
	0xEFFF,0x1BD8,0xFFF7, 0xCFFF,0xCBD3,0xFFF3, 0xDFFF,0xE3C7,0xFFFB,
	0xDFFF,0xF3CF,0xFFFB, 0xCFFF,0xF99F,0xFFF3, 0xEFFF,0xFDBF,0xFFF7,
	0xE7FF,0xFDBF,0xFFE7, 0xF7FF,0xFE7F,0xFFEF, 0xF3FF,0xFE7F,0xFFCF,
	0xF9FF,0xFE7F,0xFF9F, 0xFCFF,0xFE7F,0xFF3F, 0xFEFF,0xFE7F,0xFF7F,
	0xFE7F,0x8001,0xFE7F, 0xFF70,0x0000,0x06FF, 0xFF00,0x7FFE,0x00FF,
	0xFF8F,0xFFFF,0xF9FF, 0xFFBF,0xFFFF,0xFDFF, 0xFFBF,0x8001,0xFDFF,
	0xFFA0,0x0000,0x05FF, 0xFF80,0x7FFE,0x01FF, 0xFF9F,0xFFFF,0xF9FF,
	0xFFBF,0xC003,0xFDFF, 0xFFB8,0x0000,0x1DFF, 0xFF80,0x3FFC,0x01FF,
	0xFF87,0xFFFF,0xE1FF, 0xFF8F,0xFFFF,0xF1FF, 0xFFE0,0xFFFF,0x07FF,
	0xFFF0,0x0000,0x0FFF, 0xFFFF,0x0000,0xFFFF, 0xFFFF,0xFFFF,0xFFFF
};

struct Image SKSFImage = {
	0, 0,		/* LeftEdge, TopEdge		*/
	48, 48, 4,	/* Width, Height, Depth		*/
	SKSFData,	/* ImageData				*/
	0x07, 0x00,	/* PlanePick, PlaneOnOff	*/
	NULL		/* NextImage				*/
};

struct Image *Images[] = {
	&WFImage,
	&WBWFImage, &WTWFImage, &WSWFImage, &WLWFImage, &WDWFImage, &WKWFImage,
	&SBWFImage, &STWFImage, &SSWFImage, &SLWFImage, &SDWFImage, &SKWFImage,
	&SFImage,
	&WBSFImage, &WTSFImage, &WSSFImage, &WLSFImage, &WDSFImage, &WKSFImage,
	&SBSFImage, &STSFImage, &SSSFImage, &SLSFImage, &SDSFImage, &SKSFImage
};
